DefinitionBlock ("dsdt.aml", "DSDT", 1, "A1514", "A1514001", 0x00000001)
{
    Scope (_PR)
    {
        Processor (P001, 0x01, 0x00000810, 0x06)
        {
        }
        Processor (P002, 0x02, 0x00000000, 0x00)
        {
        }
        Processor (P003, 0x03, 0x00000000, 0x00)
        {
        }
        Processor (P004, 0x04, 0x00000000, 0x00)
        {
        }
        Processor (P005, 0x05, 0x00000000, 0x00)
        {
        }
        Processor (P006, 0x06, 0x00000000, 0x00)
        {
        }
        Processor (P007, 0x07, 0x00000000, 0x00)
        {
        }
        Processor (P008, 0x08, 0x00000000, 0x00)
        {
        }
        Processor (P009, 0x09, 0x00000000, 0x00)
        {
        }
        Processor (P010, 0x0A, 0x00000000, 0x00)
        {
        }
        Processor (P011, 0x0B, 0x00000000, 0x00)
        {
        }
        Processor (P012, 0x0C, 0x00000000, 0x00)
        {
        }
        Processor (P013, 0x0D, 0x00000000, 0x00)
        {
        }
        Processor (P014, 0x0E, 0x00000000, 0x00)
        {
        }
        Processor (P015, 0x0F, 0x00000000, 0x00)
        {
        }
        Processor (P016, 0x10, 0x00000000, 0x00)
        {
        }
    }
    Name (DP80, 0x80)
    Name (DP90, 0x90)
    Name (WKTP, Zero)
    Name (SPIO, 0x2E)
    Name (IOHW, 0x0290)
    Name (IOSB, Zero)
    Name (IOSL, 0x10)
    Name (IOHB, 0x0290)
    Name (IOHL, 0x10)
    Name (SMIP, 0xB2)
    Name (PMBS, 0x0800)
    Name (PMLN, 0x80)
    Name (GPBS, 0x0500)
    Name (GPLN, 0x80)
    Name (SMBL, Zero)
    Name (PM30, 0x0830)
    Name (SUSW, 0xFF)
    Name (TPBA, 0xFED40000)
    Name (TPBL, Zero)
    Name (GEBS, Zero)
    Name (GELN, Zero)
    Name (APIC, One)
    Name (PCIB, 0xF8000000)
    Name (PCIL, 0x04000000)
    Name (PEHP, One)
    Name (SHPC, Zero)
    Name (PEPM, One)
    Name (PEER, One)
    Name (PECS, One)
    Name (SMBS, 0x0400)
    Name (CPUC, 0x10)
    OperationRegion (BIOS, SystemMemory, 0xDFE88064, 0xFF)
    Field (BIOS, ByteAcc, NoLock, Preserve)
    {
        SS1,    1, 
        SS2,    1, 
        SS3,    1, 
        SS4,    1, 
                Offset (0x01), 
        IOST,   16, 
        TOPM,   32, 
        ROMS,   32, 
        MG1B,   32, 
        MG1L,   32, 
        MG2B,   32, 
        MG2L,   32, 
                Offset (0x1C), 
        DMAX,   8, 
        HPTA,   32, 
        CPB0,   32, 
        CPB1,   32, 
        CPB2,   32, 
        CPB3,   32, 
        ASSB,   8, 
        AOTB,   8, 
        AAXB,   32, 
        SMIF,   8, 
        DTSE,   8, 
        DTS1,   8, 
        DTS2,   8, 
        MPEN,   8, 
        TPMF,   8, 
        MG3B,   32, 
        MG3L,   32, 
        MH1B,   32, 
        MH1L,   32, 
        OSTP,   8
    }
    Method (RRIO, 4, NotSerialized)
    {
        Store ("RRIO", Debug)
    }
    Method (RDMA, 3, NotSerialized)
    {
        Store ("rDMA", Debug)
    }
    Name (PICM, Zero)
    Method (_PIC, 1, NotSerialized)
    {
        If (Arg0)
        {
            Store (0xAA, DBG8)
        }
        Else
        {
            Store (0xAC, DBG8)
        }
        Store (Arg0, PICM)
    }
    Name (OSVR, Ones)
    Method (OSFL, 0, NotSerialized)
    {
        If (LNotEqual (OSVR, Ones))
        {
            Return (OSVR)
        }
        Name (T_0, Zero)
        Store (OSYS (), T_0)
        If (LEqual (T_0, One))
        {
            Store (0x03, OSVR)
        }
        Else
        {
            If (LEqual (T_0, 0x10))
            {
                Store (One, OSVR)
            }
            Else
            {
                If (LEqual (T_0, 0x11))
                {
                    Store (0x02, OSVR)
                }
                Else
                {
                    If (LEqual (T_0, 0x12))
                    {
                        Store (0x04, OSVR)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x13))
                        {
                            Store (Zero, OSVR)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x14))
                            {
                                Store (Zero, OSVR)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x15))
                                {
                                    Store (Zero, OSVR)
                                }
                            }
                        }
                    }
                }
            }
        }
        Return (OSVR)
    }
    Method (MCTH, 2, NotSerialized)
    {
        If (LLess (SizeOf (Arg0), SizeOf (Arg1)))
        {
            Return (Zero)
        }
        Add (SizeOf (Arg0), One, Local0)
        Name (BUF0, Buffer (Local0) {})
        Name (BUF1, Buffer (Local0) {})
        Store (Arg0, BUF0)
        Store (Arg1, BUF1)
        While (Local0)
        {
            Decrement (Local0)
            If (LNotEqual (DerefOf (Index (BUF0, Local0)), DerefOf (Index (
                BUF1, Local0))))
            {
                Return (Zero)
            }
        }
        Return (One)
    }
    Name (PRWP, Package (0x02)
    {
        Zero, 
        Zero
    })
    Method (GPRW, 2, NotSerialized)
    {
        Store (Arg0, Index (PRWP, Zero))
        Store (ShiftLeft (SS1, One), Local0)
        Or (Local0, ShiftLeft (SS2, 0x02), Local0)
        Or (Local0, ShiftLeft (SS3, 0x03), Local0)
        Or (Local0, ShiftLeft (SS4, 0x04), Local0)
        If (And (ShiftLeft (One, Arg1), Local0))
        {
            Store (Arg1, Index (PRWP, One))
        }
        Else
        {
            ShiftRight (Local0, One, Local0)
            If (LOr (LEqual (OSFL (), One), LEqual (OSFL (), 0x02)))
            {
                FindSetLeftBit (Local0, Index (PRWP, One))
            }
            Else
            {
                FindSetRightBit (Local0, Index (PRWP, One))
            }
        }
        Return (PRWP)
    }
    Name (WAKP, Package (0x02)
    {
        Zero, 
        Zero
    })
    OperationRegion (DEB0, SystemIO, DP80, One)
    Field (DEB0, ByteAcc, NoLock, Preserve)
    {
        DBG8,   8
    }
    OperationRegion (DEB1, SystemIO, DP90, 0x02)
    Field (DEB1, WordAcc, NoLock, Preserve)
    {
        DBG9,   16
    }
    Method (OSYS, 0, NotSerialized)
    {
        Store (0x10, Local0)
        If (CondRefOf (_OSI, Local1))
        {
            If (_OSI ("Windows 2000"))
            {
                Store (0x12, Local0)
            }
            If (_OSI ("Windows 2001"))
            {
                Store (0x13, Local0)
            }
            If (_OSI ("Windows 2001 SP1"))
            {
                Store (0x13, Local0)
            }
            If (_OSI ("Windows 2001 SP2"))
            {
                Store (0x13, Local0)
            }
            If (_OSI ("Windows 2001.1"))
            {
                Store (0x14, Local0)
            }
            If (_OSI ("Windows 2001.1 SP1"))
            {
                Store (0x14, Local0)
            }
            If (_OSI ("Windows 2006"))
            {
                Store (0x15, Local0)
            }
        }
        Else
        {
            If (MCTH (_OS, "Microsoft Windows NT"))
            {
                Store (0x12, Local0)
            }
            Else
            {
                If (MCTH (_OS, "Microsoft WindowsME: Millennium Edition"))
                {
                    Store (0x11, Local0)
                }
                If (MCTH (_OS, "Linux"))
                {
                    Store (One, Local0)
                }
            }
        }
        Return (Local0)
    }
    Scope (_SB)
    {
        Name (PR00, Package (0x28)
        {
            Package (0x04)
            {
                0x0002FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                Zero, 
                LNKH, 
                Zero
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                0x02, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                0x03, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                One, 
                LNKF, 
                Zero
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x001BFFFF, 
                Zero, 
                LNKG, 
                Zero
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                Zero, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                One, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                0x03, 
                LNKF, 
                Zero
            }
        })
        Name (AR00, Package (0x28)
        {
            Package (0x04)
            {
                0x0002FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0004FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                Zero, 
                Zero, 
                0x17
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                One, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                0x02, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x001DFFFF, 
                0x03, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                One, 
                Zero, 
                0x15
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x001AFFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x001BFFFF, 
                Zero, 
                Zero, 
                0x16
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0016FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0005FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0006FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                Zero, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                One, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x001CFFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                Zero, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x001FFFFF, 
                0x03, 
                Zero, 
                0x15
            }
        })
        Name (PR01, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR01, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR03, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR03, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR05, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR05, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR06, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR06, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR20, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR20, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR21, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKA, 
                Zero
            }
        })
        Name (AR21, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x10
            }
        })
        Name (PR22, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKB, 
                Zero
            }
        })
        Name (AR22, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x11
            }
        })
        Name (PR23, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKC, 
                Zero
            }
        })
        Name (AR23, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x12
            }
        })
        Name (PR24, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKD, 
                Zero
            }
        })
        Name (AR24, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x13
            }
        })
        Name (PR25, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKA, 
                Zero
            }
        })
        Name (AR25, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x10
            }
        })
        Name (PR26, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKB, 
                Zero
            }
        })
        Name (AR26, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x11
            }
        })
        Name (PR27, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                LNKC, 
                Zero
            }
        })
        Name (AR27, Package (0x04)
        {
            Package (0x04)
            {
                0xFFFF, 
                Zero, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0xFFFF, 
                One, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x02, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0xFFFF, 
                0x03, 
                Zero, 
                0x12
            }
        })
        Name (PR1E, Package (0x0C)
        {
            Package (0x04)
            {
                0x0001FFFF, 
                Zero, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                One, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x03, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                Zero, 
                LNKB, 
                Zero
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                One, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                0x02, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                0x03, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                Zero, 
                LNKC, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                One, 
                LNKD, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x02, 
                LNKA, 
                Zero
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x03, 
                LNKB, 
                Zero
            }
        })
        Name (AR1E, Package (0x0C)
        {
            Package (0x04)
            {
                0x0001FFFF, 
                Zero, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                One, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x02, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0001FFFF, 
                0x03, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                Zero, 
                Zero, 
                0x11
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                One, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                0x02, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0002FFFF, 
                0x03, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                Zero, 
                Zero, 
                0x12
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                One, 
                Zero, 
                0x13
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x02, 
                Zero, 
                0x10
            }, 
            Package (0x04)
            {
                0x0003FFFF, 
                0x03, 
                Zero, 
                0x11
            }
        })
        Name (PRSA, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {3,4,6,7,10,11,12,14,15}
        })
        Name (PRSB, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {5}
        })
        Alias (PRSA, PRSC)
        Alias (PRSA, PRSD)
        Alias (PRSA, PRSE)
        Alias (PRSA, PRSF)
        Alias (PRSA, PRSG)
        Alias (PRSA, PRSH)
        Device (PCI0)
        {
            Name (_HID, EisaId ("PNP0A08"))
            Name (_CID, EisaId ("PNP0A03"))
            Name (_ADR, Zero)
            Method (^BN00, 0, NotSerialized)
            {
                Return (Zero)
            }
            Method (_BBN, 0, NotSerialized)
            {
                Return (BN00 ())
            }
            Name (_UID, Zero)
            Method (_PRT, 0, NotSerialized)
            {
                If (PICM)
                {
                    Return (AR00)
                }
                Return (PR00)
            }
            Device (IOH)
            {
                Name (_HID, EisaId ("PNP0C01"))
                Name (_UID, 0x0A)
                Name (_CRS, ResourceTemplate ()
                {
                    Memory32Fixed (ReadWrite,
                        0xFED14000,         // Address Base
                        0x00006000,         // Address Length
                        )
                })
            }
            Method (NPTS, 1, NotSerialized)
            {
            }
            Method (NWAK, 1, NotSerialized)
            {
            }
            Device (P0P4)
            {
                Name (_ADR, 0x00040000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
            }
            Device (BR1E)
            {
                Name (_ADR, 0x001E0000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0B, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR1E)
                    }
                    Return (PR1E)
                }
            }
            Device (SBRG)
            {
                Name (_ADR, 0x001F0000)
                Device (IELK)
                {
                    Name (_HID, "AWY0001")
                    OperationRegion (RXA0, PCI_Config, 0xA0, 0x20)
                    Field (RXA0, ByteAcc, NoLock, Preserve)
                    {
                            ,   9, 
                        PBLV,   1, 
                                Offset (0x10), 
                            ,   1, 
                        PBMS,   1, 
                            ,   1, 
                        PMCS,   1, 
                        ECNS,   1, 
                                Offset (0x11), 
                        ECT1,   16, 
                        ELEN,   1, 
                                Offset (0x14)
                    }
                    Method (\_GPE._L0A, 0, NotSerialized)
                    {
                        Notify (\_SB.PCI0.SBRG.IELK, 0x81)
                        Store (One, \_SB.PCI0.SBRG.IELK.PMCS)
                    }
                    Method (_STA, 0, NotSerialized)
                    {
                        If (ELEN)
                        {
                            Return (0x0F)
                        }
                        Else
                        {
                            Return (Zero)
                        }
                    }
                    Method (SMOD, 1, NotSerialized)
                    {
                    }
                    Method (GPBS, 0, NotSerialized)
                    {
                        Return (XOr (PBLV, One))
                    }
                }
                Method (SPTS, 1, NotSerialized)
                {
                    Store (One, PS1S)
                    Store (One, PS1E)
                    Store (One, SLPS)
                }
                Method (SWAK, 1, NotSerialized)
                {
                    Store (Zero, SLPS)
                    Store (Zero, PS1E)
                    If (LAnd (LEqual (Arg0, One), RTCS)) {}
                    Else
                    {
                        If (LAnd (LEqual (Arg0, 0x03), BRTC)) {}
                        Else
                        {
                            Notify (PWRB, 0x02)
                        }
                    }
                }
                OperationRegion (APMP, SystemIO, SMIP, 0x02)
                Field (APMP, ByteAcc, NoLock, Preserve)
                {
                    APMC,   8, 
                    APMS,   8
                }
                Field (APMP, ByteAcc, NoLock, Preserve)
                {
                            Offset (0x01), 
                        ,   1, 
                    BRTC,   1
                }
                OperationRegion (PMS0, SystemIO, PMBS, 0x04)
                Field (PMS0, ByteAcc, NoLock, Preserve)
                {
                        ,   10, 
                    RTCS,   1, 
                        ,   4, 
                    WAKS,   1, 
                            Offset (0x03), 
                    PWBT,   1, 
                            Offset (0x04)
                }
                OperationRegion (SMIE, SystemIO, PM30, 0x08)
                Field (SMIE, ByteAcc, NoLock, Preserve)
                {
                        ,   4, 
                    PS1E,   1, 
                        ,   31, 
                    PS1S,   1, 
                            Offset (0x08)
                }
                Scope (\_SB)
                {
                    Name (SLPS, Zero)
                }
                Device (IPIC)
                {
                    Name (_HID, EisaId ("PNP0000"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0020,             // Range Minimum
                            0x0020,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00A0,             // Range Minimum
                            0x00A0,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IRQNoFlags ()
                            {2}
                    })
                }
                Device (DMAC)
                {
                    Name (_HID, EisaId ("PNP0200"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        DMA (Compatibility, BusMaster, Transfer8, )
                            {4}
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0081,             // Range Minimum
                            0x0081,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0087,             // Range Minimum
                            0x0087,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0089,             // Range Minimum
                            0x0089,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x008F,             // Range Minimum
                            0x008F,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x00C0,             // Range Minimum
                            0x00C0,             // Range Maximum
                            0x00,               // Alignment
                            0x20,               // Length
                            )
                    })
                }
                Device (TIMR)
                {
                    Name (_HID, EisaId ("PNP0100"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0040,             // Range Minimum
                            0x0040,             // Range Maximum
                            0x00,               // Alignment
                            0x04,               // Length
                            )
                        IRQNoFlags ()
                            {0}
                    })
                }
                Device (RTC)
                {
                    Name (_HID, EisaId ("PNP0B00"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0070,             // Range Minimum
                            0x0070,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IRQNoFlags ()
                            {8}
                    })
                }
                Device (SPKR)
                {
                    Name (_HID, EisaId ("PNP0800"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0061,             // Range Minimum
                            0x0061,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                    })
                }
                Device (MATH)
                {
                    Name (_HID, EisaId ("PNP0C04"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x00F0,             // Range Minimum
                            0x00F0,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IRQNoFlags ()
                            {13}
                    })
                }
                Device (FDC)
                {
                    Name (_HID, EisaId ("PNP0700"))
                    Method (_FDE, 0, NotSerialized)
                    {
                        Name (FDEP, Package (0x05)
                        {
                            Zero, 
                            Zero, 
                            0x02, 
                            0x02, 
                            0x02
                        })
                        If (_STA ())
                        {
                            Store (One, Index (FDEP, Zero))
                        }
                        Return (FDEP)
                    }
                    Method (_STA, 0, NotSerialized)
                    {
                        Return (DSTA (0x03))
                    }
                    Method (_DIS, 0, NotSerialized)
                    {
                        DCNT (0x03, Zero)
                    }
                    Method (_CRS, 0, NotSerialized)
                    {
                        DCRS (0x03, One)
                        Store (IRQM, IRQE)
                        Store (DMAM, DMAE)
                        Store (IO11, IO21)
                        Store (IO12, IO22)
                        Store (0x06, LEN2)
                        Add (IO21, 0x07, IO31)
                        Store (IO31, IO32)
                        Store (One, LEN3)
                        Return (CRS2)
                    }
                    Method (_SRS, 1, NotSerialized)
                    {
                        DSRS (Arg0, 0x03)
                        CreateWordField (Arg0, 0x11, IRQE)
                        CreateByteField (Arg0, 0x14, DMAE)
                        ENFG (CGLD (0x03))
                        If (IRQE)
                        {
                            FindSetRightBit (IRQE, Local0)
                            Subtract (Local0, One, INTR)
                        }
                        Else
                        {
                            Store (Zero, INTR)
                        }
                        If (DMAE)
                        {
                            FindSetRightBit (DMAE, Local0)
                            Subtract (Local0, One, DMCH)
                        }
                        Else
                        {
                            Store (0x04, DMCH)
                        }
                        EXFG ()
                    }
                    Name (_PRS, ResourceTemplate ()
                    {
                        StartDependentFn (0x00, 0x00)
                        {
                            IO (Decode16,
                                0x03F0,             // Range Minimum
                                0x03F0,             // Range Maximum
                                0x01,               // Alignment
                                0x06,               // Length
                                )
                            IO (Decode16,
                                0x03F7,             // Range Minimum
                                0x03F7,             // Range Maximum
                                0x01,               // Alignment
                                0x01,               // Length
                                )
                            IRQNoFlags ()
                                {6}
                            DMA (Compatibility, NotBusMaster, Transfer8, )
                                {2}
                        }
                        StartDependentFnNoPri ()
                        {
                            IO (Decode16,
                                0x03F0,             // Range Minimum
                                0x03F0,             // Range Maximum
                                0x01,               // Alignment
                                0x06,               // Length
                                )
                            IO (Decode16,
                                0x03F7,             // Range Minimum
                                0x03F7,             // Range Maximum
                                0x01,               // Alignment
                                0x01,               // Length
                                )
                            IRQNoFlags ()
                                {3,4,5,6,7,10,11,12}
                            DMA (Compatibility, NotBusMaster, Transfer8, )
                                {0,1,2,3}
                        }
                        StartDependentFnNoPri ()
                        {
                            IO (Decode16,
                                0x0370,             // Range Minimum
                                0x0370,             // Range Maximum
                                0x01,               // Alignment
                                0x06,               // Length
                                )
                            IO (Decode16,
                                0x0377,             // Range Minimum
                                0x0377,             // Range Maximum
                                0x01,               // Alignment
                                0x01,               // Length
                                )
                            IRQNoFlags ()
                                {3,4,5,6,7,10,11,12}
                            DMA (Compatibility, NotBusMaster, Transfer8, )
                                {0,1,2,3}
                        }
                        EndDependentFn ()
                    })
                }
                Device (SIOR)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Method (_UID, 0, NotSerialized)
                    {
                        Return (SPIO)
                    }
                    Name (CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y00)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y01)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y02)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        If (LAnd (LNotEqual (SPIO, 0x03F0), LGreater (SPIO, 0xF0)))
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIOR._Y00._MIN, GP10)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIOR._Y00._MAX, GP11)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.SIOR._Y00._LEN, GPL1)
                            Store (SPIO, GP10)
                            Store (SPIO, GP11)
                            Store (0x02, GPL1)
                        }
                        If (IOSB)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIOR._Y01._MIN, GP20)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIOR._Y01._MAX, GP21)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.SIOR._Y01._LEN, GPL2)
                            Store (IOSB, GP20)
                            Store (IOSB, GP21)
                            Store (IOSL, GPL2)
                        }
                        If (IOHB)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIOR._Y02._MIN, GP30)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.SIOR._Y02._MAX, GP31)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.SIOR._Y02._LEN, GPL3)
                            Store (IOHB, GP30)
                            Store (IOHB, GP31)
                            Store (IOHL, GPL3)
                        }
                        Return (CRS)
                    }
                }
                Name (DCAT, Package (0x16)
                {
                    0x02, 
                    0x03, 
                    One, 
                    Zero, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0x06, 
                    0x09, 
                    0xFF, 
                    0xFF, 
                    0xFF, 
                    0xFF
                })
                Method (ENFG, 1, NotSerialized)
                {
                    Store (0x87, INDX)
                    Store (0x87, INDX)
                    Store (Arg0, LDN)
                }
                Method (EXFG, 0, NotSerialized)
                {
                    Store (0xAA, INDX)
                }
                Method (LPTM, 1, NotSerialized)
                {
                    ENFG (CGLD (Arg0))
                    And (OPT0, 0x02, Local0)
                    EXFG ()
                    Return (Local0)
                }
                Method (UHID, 1, NotSerialized)
                {
                    If (LEqual (Arg0, One))
                    {
                        ENFG (CGLD (Arg0))
                        And (OPT1, 0x38, Local0)
                        EXFG ()
                        If (Local0)
                        {
                            Return (0x1005D041)
                        }
                    }
                    Return (0x0105D041)
                }
                Method (SIOK, 1, NotSerialized)
                {
                    ENFG (0x0A)
                    And (0xFF, OPT3, OPT3)
                    And (Arg0, One, Local0)
                    Or (OPT2, Local0, OPT2)
                    Store (And (Arg0, One), ACTR)
                    EXFG ()
                }
                Name (KBFG, One)
                Name (MSFG, One)
                Name (U1FG, One)
                Name (U2FG, One)
                OperationRegion (KBRW, SystemIO, 0x60, 0x05)
                Field (KBRW, ByteAcc, NoLock, Preserve)
                {
                    KP60,   8, 
                            Offset (0x04), 
                    KP64,   8
                }
                OperationRegion (KB64, SystemIO, 0x64, One)
                Field (KB64, ByteAcc, NoLock, Preserve)
                {
                        ,   1, 
                    KRDY,   1, 
                            Offset (0x01)
                }
                Method (SIOS, 1, NotSerialized)
                {
                    Store ("SIOS", Debug)
                    And (CRE0, 0x1F, CRE0)
                    If (LEqual (Arg0, One))
                    {
                        SIOK (Ones)
                        ENFG (0x0A)
                        If (KBFG)
                        {
                            Or (OPT6, 0x10, OPT6)
                        }
                        If (MSFG)
                        {
                            Or (OPT6, 0x20, OPT6)
                        }
                        EXFG ()
                    }
                    If (LOr (LEqual (Arg0, 0x03), LEqual (Arg0, 0x04)))
                    {
                        If (WKTP)
                        {
                            SIOK (Ones)
                            ENFG (0x0A)
                            If (KBFG)
                            {
                                Or (OPT6, 0x10, OPT6)
                            }
                            If (MSFG)
                            {
                                Or (OPT6, 0x20, OPT6)
                            }
                            EXFG ()
                        }
                        Else
                        {
                            ENFG (0x0A)
                            If (KBFG)
                            {
                                Or (CRE0, 0x41, CRE0)
                            }
                            If (MSFG)
                            {
                                Or (CRE0, 0x22, CRE0)
                                Or (CRE6, 0x80, CRE6)
                            }
                            EXFG ()
                        }
                    }
                }
                Method (SIOW, 1, NotSerialized)
                {
                    Store ("SIOW", Debug)
                    SIOK (Zero)
                    ENFG (0x0A)
                    And (OPT6, 0xCF, OPT6)
                    And (OPT2, 0xFE, OPT2)
                    And (CRE0, 0x1D, CRE0)
                    And (CRE6, 0x7F, CRE6)
                    EXFG ()
                }
                Method (SIOH, 0, NotSerialized)
                {
                    Store ("SIOH", Debug)
                    ENFG (0x0A)
                    If (And (OPT3, 0x10))
                    {
                        Notify (PS2K, 0x02)
                    }
                    If (And (OPT3, 0x20))
                    {
                        Notify (PS2M, 0x02)
                    }
                    SIOK (Zero)
                }
                OperationRegion (IOID, SystemIO, SPIO, 0x02)
                Field (IOID, ByteAcc, NoLock, Preserve)
                {
                    INDX,   8, 
                    DATA,   8
                }
                IndexField (INDX, DATA, ByteAcc, NoLock, Preserve)
                {
                            Offset (0x07), 
                    LDN,    8, 
                            Offset (0x20), 
                    CR20,   8, 
                            Offset (0x22), 
                    FDCP,   1, 
                        ,   2, 
                    LPTP,   1, 
                    URAP,   1, 
                    URBP,   1, 
                            Offset (0x2C), 
                    CR2C,   8, 
                            Offset (0x30), 
                    ACTR,   8, 
                            Offset (0x60), 
                    IOAH,   8, 
                    IOAL,   8, 
                    IOH2,   8, 
                    IOL2,   8, 
                            Offset (0x70), 
                    INTR,   8, 
                            Offset (0x74), 
                    DMCH,   8, 
                            Offset (0xE0), 
                    CRE0,   8, 
                    CRE1,   8, 
                    CRE2,   8, 
                    CRE3,   8, 
                    CRE4,   8, 
                    CRE5,   8, 
                    CRE6,   8, 
                    CRE7,   8, 
                    CRE8,   8, 
                    CRE9,   8, 
                    CREA,   8, 
                    CREB,   8, 
                    CREC,   8, 
                            Offset (0xF0), 
                    OPT0,   8, 
                    OPT1,   8, 
                    OPT2,   8, 
                    OPT3,   8, 
                    OPT4,   8, 
                    OPT5,   8, 
                    OPT6,   8
                }
                Method (CGLD, 1, NotSerialized)
                {
                    Return (DerefOf (Index (DCAT, Arg0)))
                }
                Method (DSTA, 1, NotSerialized)
                {
                    ENFG (CGLD (Arg0))
                    Store (ACTR, Local0)
                    EXFG ()
                    If (LEqual (Local0, 0xFF))
                    {
                        Return (Zero)
                    }
                    And (Local0, One, Local0)
                    Or (IOST, ShiftLeft (Local0, Arg0), IOST)
                    If (Local0)
                    {
                        Return (0x0F)
                    }
                    Else
                    {
                        If (And (ShiftLeft (One, Arg0), IOST))
                        {
                            Return (0x0D)
                        }
                        Else
                        {
                            Return (Zero)
                        }
                    }
                }
                Method (DCNT, 2, NotSerialized)
                {
                    ENFG (CGLD (Arg0))
                    ShiftLeft (IOAH, 0x08, Local1)
                    Or (IOAL, Local1, Local1)
                    If (LAnd (LLess (DMCH, 0x04), LNotEqual (And (DMCH, 0x03, 
                        Local1), Zero)))
                    {
                        RDMA (Arg0, Arg1, Increment (Local1))
                    }
                    Store (Arg1, ACTR)
                    RRIO (Arg0, Arg1, Local1, 0x08)
                    EXFG ()
                }
                Name (CRS1, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0000,             // Range Minimum
                        0x0000,             // Range Maximum
                        0x01,               // Alignment
                        0x00,               // Length
                        _Y05)
                    IRQNoFlags (_Y03)
                        {}
                    DMA (Compatibility, NotBusMaster, Transfer8, _Y04)
                        {}
                })
                CreateWordField (CRS1, \_SB.PCI0.SBRG._Y03._INT, IRQM)
                CreateByteField (CRS1, \_SB.PCI0.SBRG._Y04._DMA, DMAM)
                CreateWordField (CRS1, \_SB.PCI0.SBRG._Y05._MIN, IO11)
                CreateWordField (CRS1, \_SB.PCI0.SBRG._Y05._MAX, IO12)
                CreateByteField (CRS1, \_SB.PCI0.SBRG._Y05._LEN, LEN1)
                Name (CRS2, ResourceTemplate ()
                {
                    IO (Decode16,
                        0x0000,             // Range Minimum
                        0x0000,             // Range Maximum
                        0x01,               // Alignment
                        0x00,               // Length
                        _Y08)
                    IO (Decode16,
                        0x0000,             // Range Minimum
                        0x0000,             // Range Maximum
                        0x01,               // Alignment
                        0x00,               // Length
                        _Y09)
                    IRQNoFlags (_Y06)
                        {6}
                    DMA (Compatibility, NotBusMaster, Transfer8, _Y07)
                        {2}
                })
                CreateWordField (CRS2, \_SB.PCI0.SBRG._Y06._INT, IRQE)
                CreateByteField (CRS2, \_SB.PCI0.SBRG._Y07._DMA, DMAE)
                CreateWordField (CRS2, \_SB.PCI0.SBRG._Y08._MIN, IO21)
                CreateWordField (CRS2, \_SB.PCI0.SBRG._Y08._MAX, IO22)
                CreateByteField (CRS2, \_SB.PCI0.SBRG._Y08._LEN, LEN2)
                CreateWordField (CRS2, \_SB.PCI0.SBRG._Y09._MIN, IO31)
                CreateWordField (CRS2, \_SB.PCI0.SBRG._Y09._MAX, IO32)
                CreateByteField (CRS2, \_SB.PCI0.SBRG._Y09._LEN, LEN3)
                Method (DCRS, 2, NotSerialized)
                {
                    ENFG (CGLD (Arg0))
                    ShiftLeft (IOAH, 0x08, IO11)
                    Or (IOAL, IO11, IO11)
                    Store (IO11, IO12)
                    Subtract (FindSetRightBit (IO11), One, Local0)
                    ShiftLeft (One, Local0, LEN1)
                    If (INTR)
                    {
                        ShiftLeft (One, INTR, IRQM)
                    }
                    Else
                    {
                        Store (Zero, IRQM)
                    }
                    If (LOr (LGreater (DMCH, 0x03), LEqual (Arg1, Zero)))
                    {
                        Store (Zero, DMAM)
                    }
                    Else
                    {
                        And (DMCH, 0x03, Local1)
                        ShiftLeft (One, Local1, DMAM)
                    }
                    EXFG ()
                    Return (CRS1)
                }
                Method (DSRS, 2, NotSerialized)
                {
                    CreateWordField (Arg0, 0x09, IRQM)
                    CreateByteField (Arg0, 0x0C, DMAM)
                    CreateWordField (Arg0, 0x02, IO11)
                    ENFG (CGLD (Arg1))
                    ShiftLeft (IOAH, 0x08, Local1)
                    Or (IOAL, Local1, Local1)
                    RRIO (Arg1, Zero, Local1, 0x08)
                    RRIO (Arg1, One, IO11, 0x08)
                    And (IO11, 0xFF, IOAL)
                    ShiftRight (IO11, 0x08, IOAH)
                    If (IRQM)
                    {
                        FindSetRightBit (IRQM, Local0)
                        Subtract (Local0, One, INTR)
                    }
                    Else
                    {
                        Store (Zero, INTR)
                    }
                    If (DMAM)
                    {
                        FindSetRightBit (DMAM, Local0)
                        Subtract (Local0, One, DMCH)
                    }
                    Else
                    {
                        Store (0x04, DMCH)
                    }
                    EXFG ()
                    DCNT (Arg1, One)
                }
                Device (RMSC)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x10)
                    Name (CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0010,             // Range Minimum
                            0x0010,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0022,             // Range Minimum
                            0x0022,             // Range Maximum
                            0x00,               // Alignment
                            0x1E,               // Length
                            )
                        IO (Decode16,
                            0x0044,             // Range Minimum
                            0x0044,             // Range Maximum
                            0x00,               // Alignment
                            0x0A,               // Length
                            )
                        IO (Decode16,
                            0x0050,             // Range Minimum
                            0x0050,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0062,             // Range Minimum
                            0x0062,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0065,             // Range Minimum
                            0x0065,             // Range Maximum
                            0x00,               // Alignment
                            0x0B,               // Length
                            )
                        IO (Decode16,
                            0x0072,             // Range Minimum
                            0x0072,             // Range Maximum
                            0x00,               // Alignment
                            0x0E,               // Length
                            )
                        IO (Decode16,
                            0x0080,             // Range Minimum
                            0x0080,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0084,             // Range Minimum
                            0x0084,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0088,             // Range Minimum
                            0x0088,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x008C,             // Range Minimum
                            0x008C,             // Range Maximum
                            0x00,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0090,             // Range Minimum
                            0x0090,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x00A2,             // Range Minimum
                            0x00A2,             // Range Maximum
                            0x00,               // Alignment
                            0x1E,               // Length
                            )
                        IO (Decode16,
                            0x00E0,             // Range Minimum
                            0x00E0,             // Range Maximum
                            0x00,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x04D0,             // Range Minimum
                            0x04D0,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y0A)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y0B)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y0C)
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x00,               // Alignment
                            0x00,               // Length
                            _Y0D)
                        Memory32Fixed (ReadWrite,
                            0xFED1C000,         // Address Base
                            0x00004000,         // Address Length
                            )
                        Memory32Fixed (ReadWrite,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y0E)
                        Memory32Fixed (ReadWrite,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y0F)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0A._MIN, GP00)
                        CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0A._MAX, GP01)
                        CreateByteField (CRS, \_SB.PCI0.SBRG.RMSC._Y0A._LEN, GP0L)
                        Store (PMBS, GP00)
                        Store (PMBS, GP01)
                        Store (PMLN, GP0L)
                        If (SMBS)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0B._MIN, GP10)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0B._MAX, GP11)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.RMSC._Y0B._LEN, GP1L)
                            Store (SMBS, GP10)
                            Store (SMBS, GP11)
                            Store (SMBL, GP1L)
                        }
                        If (GPBS)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0C._MIN, GP20)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0C._MAX, GP21)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.RMSC._Y0C._LEN, GP2L)
                            Store (GPBS, GP20)
                            Store (GPBS, GP21)
                            Store (GPLN, GP2L)
                        }
                        If (GEBS)
                        {
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0D._MIN, GP30)
                            CreateWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0D._MAX, GP31)
                            CreateByteField (CRS, \_SB.PCI0.SBRG.RMSC._Y0D._LEN, GP3L)
                            Store (GEBS, GP30)
                            Store (GEBS, GP31)
                            Store (GELN, GP3L)
                        }
                        CreateDWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0E._LEN, TML1)
                        CreateDWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0E._BAS, TMB1)
                        CreateDWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0F._LEN, TML2)
                        CreateDWordField (CRS, \_SB.PCI0.SBRG.RMSC._Y0F._BAS, TMB2)
                        Store (0xFED20000, TMB1)
                        Subtract (TPBA, 0xFED20000, TML1)
                        If (TPMF)
                        {
                            Add (TPBA, TPBL, TMB2)
                        }
                        Else
                        {
                            Add (TPBA, Zero, TMB2)
                        }
                        Subtract (0xFED90000, TMB2, TML2)
                        Return (CRS)
                    }
                }
                Scope (\)
                {
                    OperationRegion (RAMW, SystemMemory, 0xDFEDC000, 0x00010000)
                    Field (RAMW, ByteAcc, NoLock, Preserve)
                    {
                        PAR0,   32, 
                        PAR1,   32, 
                        PAR2,   32
                    }
                    OperationRegion (IOB2, SystemIO, 0xB2, 0x02)
                    Field (IOB2, ByteAcc, NoLock, Preserve)
                    {
                        SMIC,   8, 
                        SMIS,   8
                    }
                    Method (ISMI, 1, Serialized)
                    {
                        Store (Arg0, SMIC)
                    }
                    Method (GNVS, 1, Serialized)
                    {
                        Store (Arg0, PAR0)
                        ISMI (0x70)
                        Return (PAR1)
                    }
                    Method (SNVS, 2, Serialized)
                    {
                        Store (Arg0, PAR0)
                        Store (Arg1, PAR1)
                        ISMI (0x71)
                    }
                    Method (SMSR, 3, Serialized)
                    {
                        Store (Arg0, PAR0)
                        Store (Arg1, PAR1)
                        Store (Arg2, PAR2)
                        ISMI (0x79)
                    }
                    Method (GMAX, 1, Serialized)
                    {
                        Store (Arg0, PAR0)
                        ISMI (0x7A)
                        Return (PAR1)
                    }
                    Method (GMDX, 1, Serialized)
                    {
                        Store (Arg0, PAR0)
                        ISMI (0x7B)
                        Return (PAR1)
                    }
                    Method (GCAX, 1, Serialized)
                    {
                        Store (Arg0, PAR0)
                        ISMI (0x7C)
                        Return (PAR1)
                    }
                    Method (GCDX, 1, Serialized)
                    {
                        Store (Arg0, PAR0)
                        ISMI (0x7D)
                        Return (PAR1)
                    }
                }
                Scope (\_SB.PCI0.SBRG)
                {
                    Device (ASOC)
                    {
                        Name (_HID, "ATK0110")
                        Name (_UID, 0x01010110)
                        Name (MVID, 0x3E)
                        Method (_STA, 0, NotSerialized)
                        {
                            Return (0x0F)
                        }
                        Method (_INI, 0, NotSerialized)
                        {
                            CUPI ()
                            UMVT ()
                            SVDR ()
                            UVCR ()
                        }
                        Method (CUPI, 0, NotSerialized)
                        {
                            Store (GNVS (0x82A0), Local1)
                            Store (Local1, Index (G3C5, 0x03))
                            If (And (And (XOr (ShiftRight (GMDX (0x01A0), 0x06), One
                                ), And (ShiftRight (GMAX (0xCE), 0x1C), One)), And (
                                GNVS (0x16B8), One)))
                            {
                                Store (Local1, Index (G3C2, 0x04))
                                Store (0x40, Local0)
                                Subtract (Local0, Local1, Index (G3C2, 0x06))
                                Subtract (GNVS (0x82A0), Local1, Index (G3C2, 0x03))
                                If (LNotEqual (GPRE (0x003F1800), Ones))
                                {
                                    Store (0x04, Index (G3DS, 0x06))
                                }
                                Else
                                {
                                    Store (0x02, Index (G3DS, 0x06))
                                }
                                ShiftRight (GNVS (0x8290), One, Local0)
                                If (LEqual (Local0, Zero))
                                {
                                    Store (GNVS (0x82A0), Local0)
                                }
                                If (LNotEqual (GPRE (0x003F1800), Ones))
                                {
                                    Store (GNVS (0x4598), Local1)
                                }
                                Else
                                {
                                    Store (GNVS (0x4590), Local1)
                                }
                                Add (Local0, Local1, Local2)
                                If (LGreaterEqual (Local2, GNVS (0x82A0)))
                                {
                                    Store (Zero, Index (G3C2, 0x02))
                                }
                            }
                            Else
                            {
                                Store (D4CR, Index (G3C2, 0x03))
                            }
                        }
                        Method (UMVT, 0, NotSerialized)
                        {
                            Store (VIDI, Index (G3C1, 0x03))
                            Multiply (0x50, 0x64, Index (G3C0, 0x04))
                        }
                        Method (SVDR, 0, NotSerialized)
                        {
                            Store (GNVS (0x7340), Local0)
                            If (LEqual (Local0, Zero))
                            {
                                Store (0x15, Local0)
                            }
                            Else
                            {
                                Decrement (Local0)
                            }
                            Store (Local0, VDAD)
                            If (LEqual (GPRE (0x003F1800), Ones))
                            {
                                Or (0x40000000, DerefOf (Index (G3D4, 0x02)), Index (G3D4, 0x02
                                    ))
                                Or (0x40000000, DerefOf (Index (G3D6, 0x02)), Index (G3D6, 0x02
                                    ))
                            }
                            Store (GNVS (0x7348), Local0)
                            If (LEqual (Local0, Zero))
                            {
                                Store (0x15, Local0)
                            }
                            Else
                            {
                                Decrement (Local0)
                            }
                            Store (Local0, VDBD)
                        }
                        Method (UVCR, 0, NotSerialized)
                        {
                            Store (VIDI, RVCR)
                            ENFG (0x0D)
                            Store (And (CRE4, 0xC0), Local0)
                            EXFG ()
                            If (LEqual (Local0, 0x40))
                            {
                                If (LEqual (GNVS (0x16CB), Zero))
                                {
                                    Add (GNVS (0x8318), RVCR, RVCR)
                                }
                                Else
                                {
                                    Subtract (RVCR, GNVS (0x8318), RVCR)
                                }
                            }
                            Else
                            {
                                If (LEqual (Local0, 0x80))
                                {
                                    Store (GNVS (0x8310), Local1)
                                    If (LNotEqual (Local1, Zero))
                                    {
                                        Decrement (Local1)
                                    }
                                    Store (Local1, RVCR)
                                }
                            }
                            Store (GNVS (0x5490), VIMC)
                            If (LNotEqual (VIMC, Zero))
                            {
                                Decrement (VIMC)
                            }
                        }
                        Name (MBIF, Package (0x08)
                        {
                            0x03, 
                            "P7P55D", 
                            0x03010203, 
                            0x02000100, 
                            0xE0000000, 
                            One, 
                            Zero, 
                            Zero
                        })
                        Name (ASBF, Buffer (0x0200) {})
                        CreateDWordField (ASBF, Zero, ASB0)
                        CreateDWordField (ASBF, 0x04, ASB1)
                        CreateDWordField (ASBF, 0x08, ASB2)
                        Method (GGRP, 1, Serialized)
                        {
                            Name (T_0, Zero)
                            Store (Arg0, T_0)
                            If (LEqual (T_0, Zero))
                            {
                                Return (GRP0)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x03))
                                {
                                    Return (GRP3)
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x04))
                                    {
                                        Return (GRP4)
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x05))
                                        {
                                            Return (GRP5)
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x06))
                                            {
                                                Return (GRP6)
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x09))
                                                {
                                                    Return (GRP9)
                                                }
                                                Else
                                                {
                                                    If (LEqual (T_0, 0x0B))
                                                    {
                                                        Return (GRPB)
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (T_0, 0x0E))
                                                        {
                                                            Return (GRPE)
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (T_0, 0x0F))
                                                            {
                                                                Return (GRPF ())
                                                            }
                                                            Else
                                                            {
                                                                Return (Zero)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        Method (GITM, 1, Serialized)
                        {
                            CreateDWordField (Arg0, Zero, PRM0)
                            CreateByteField (Arg0, 0x03, GPID)
                            Store (One, ASB0)
                            Name (T_0, Zero)
                            Store (GPID, T_0)
                            If (LEqual (T_0, Zero))
                            {
                                GIT0 (PRM0)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x03))
                                {
                                    GIT3 (PRM0)
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x04))
                                    {
                                        GIT4 (PRM0)
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x05))
                                        {
                                            CreateDWordField (Arg0, 0x04, PRM1)
                                            GIT5 (PRM0, PRM1)
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x06))
                                            {
                                                GIT6 (PRM0)
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x09))
                                                {
                                                    GIT9 (PRM0)
                                                }
                                                Else
                                                {
                                                    If (LEqual (T_0, 0x0B))
                                                    {
                                                        GITB (PRM0)
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (T_0, 0x0E))
                                                        {
                                                            GITE (PRM0)
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (T_0, 0x0F))
                                                            {
                                                                GITF (PRM0)
                                                            }
                                                            Else
                                                            {
                                                                Store (Zero, ASB0)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            Return (ASBF)
                        }
                        Method (SITM, 1, Serialized)
                        {
                            CreateDWordField (Arg0, Zero, PRM0)
                            CreateDWordField (Arg0, 0x04, PRM1)
                            CreateDWordField (Arg0, 0x08, PRM2)
                            CreateByteField (Arg0, 0x03, GPID)
                            Store (One, ASB0)
                            Name (T_0, Zero)
                            Store (GPID, T_0)
                            If (LEqual (T_0, Zero))
                            {
                                SIT0 (PRM0, PRM1, PRM2)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x03))
                                {
                                    SIT3 (PRM0, PRM1, PRM2)
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x04))
                                    {
                                        SIT4 (PRM0, PRM1, PRM2)
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x05))
                                        {
                                            SIT5 (PRM0, PRM1, PRM2)
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x06))
                                            {
                                                SIT6 (PRM0, PRM1, PRM2)
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x09))
                                                {
                                                    SIT9 (PRM0, PRM1, PRM2)
                                                }
                                                Else
                                                {
                                                    If (LEqual (T_0, 0x0B))
                                                    {
                                                        SITB (PRM0, PRM1, PRM2)
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (T_0, 0x0E))
                                                        {
                                                            SITE (PRM0, PRM1, PRM2)
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (T_0, 0x0F))
                                                            {
                                                                SITF (PRM0, PRM1, PRM2)
                                                            }
                                                            Else
                                                            {
                                                                Store (Zero, ASB0)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            Return (ASBF)
                        }
                        Method (OP2V, 2, NotSerialized)
                        {
                            Store (DerefOf (Index (Arg1, 0x04)), Local0)
                            Store (DerefOf (Index (Arg1, 0x05)), Local1)
                            Multiply (Arg0, Local1, Local1)
                            Add (Local0, Local1, Local0)
                            Return (Local0)
                        }
                        Method (V2OP, 2, NotSerialized)
                        {
                            Store (DerefOf (Index (Arg1, 0x04)), Local0)
                            Store (DerefOf (Index (Arg1, 0x05)), Local1)
                            Subtract (Arg0, Local0, Local0)
                            Divide (Local0, Local1, Local1, Local0)
                            Return (Local0)
                        }
                    }
                }
                OperationRegion (RX80, PCI_Config, Zero, 0xFF)
                Field (RX80, ByteAcc, NoLock, Preserve)
                {
                            Offset (0x80), 
                    LPCD,   16, 
                    LPCE,   16
                }
                Name (DBPT, Package (0x04)
                {
                    Package (0x08)
                    {
                        0x03F8, 
                        0x02F8, 
                        0x0220, 
                        0x0228, 
                        0x0238, 
                        0x02E8, 
                        0x0338, 
                        0x03E8
                    }, 
                    Package (0x08)
                    {
                        0x03F8, 
                        0x02F8, 
                        0x0220, 
                        0x0228, 
                        0x0238, 
                        0x02E8, 
                        0x0338, 
                        0x03E8
                    }, 
                    Package (0x03)
                    {
                        0x0378, 
                        0x0278, 
                        0x03BC
                    }, 
                    Package (0x02)
                    {
                        0x03F0, 
                        0x0370
                    }
                })
                Name (DDLT, Package (0x04)
                {
                    Package (0x02)
                    {
                        Zero, 
                        0xFFF8
                    }, 
                    Package (0x02)
                    {
                        0x04, 
                        0xFF8F
                    }, 
                    Package (0x02)
                    {
                        0x08, 
                        0xFCFF
                    }, 
                    Package (0x02)
                    {
                        0x0C, 
                        0xEFFF
                    }
                })
                Method (RRIO, 4, NotSerialized)
                {
                    If (LAnd (LLessEqual (Arg0, 0x03), LGreaterEqual (Arg0, Zero)))
                    {
                        Store (Match (DerefOf (Index (DBPT, Arg0)), MEQ, Arg2, MTR, 
                            Zero, Zero), Local0)
                        If (LNotEqual (Local0, Ones))
                        {
                            Store (DerefOf (Index (DerefOf (Index (DDLT, Arg0)), Zero)), 
                                Local1)
                            Store (DerefOf (Index (DerefOf (Index (DDLT, Arg0)), One)), 
                                Local2)
                            ShiftLeft (Local0, Local1, Local0)
                            And (LPCD, Local2, LPCD)
                            Or (LPCD, Local0, LPCD)
                            WX82 (Arg0, Arg1)
                        }
                    }
                    If (LEqual (Arg0, 0x08))
                    {
                        If (LEqual (Arg2, 0x0200))
                        {
                            WX82 (0x08, Arg0)
                        }
                        Else
                        {
                            If (LEqual (Arg2, 0x0208))
                            {
                                WX82 (0x09, Arg0)
                            }
                        }
                    }
                    If (LAnd (LLessEqual (Arg0, 0x0D), LGreaterEqual (Arg0, 0x0A)))
                    {
                        WX82 (Arg0, Arg1)
                    }
                }
                Method (WX82, 2, NotSerialized)
                {
                    ShiftLeft (One, Arg0, Local0)
                    If (Arg1)
                    {
                        Or (LPCE, Local0, LPCE)
                    }
                    Else
                    {
                        Not (Local0, Local0)
                        And (LPCE, Local0, LPCE)
                    }
                }
                Method (RDMA, 3, NotSerialized)
                {
                }
                Device (FWH)
                {
                    Name (_HID, EisaId ("INT0800"))
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y11)
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y12)
                    })
                    CreateDWordField (CRS, \_SB.PCI0.SBRG.FWH._Y11._BAS, BS00)
                    CreateDWordField (CRS, \_SB.PCI0.SBRG.FWH._Y11._LEN, BL00)
                    CreateDWordField (CRS, \_SB.PCI0.SBRG.FWH._Y12._BAS, BS10)
                    CreateDWordField (CRS, \_SB.PCI0.SBRG.FWH._Y12._LEN, BL10)
                    Method (_CRS, 0, NotSerialized)
                    {
                        Store (0xFF800000, Local0)
                        FindSetRightBit (FHD0, Local1)
                        Decrement (Local1)
                        If (Local1)
                        {
                            Multiply (Local1, 0x00080000, Local1)
                        }
                        Add (Local0, Local1, Local2)
                        Store (Local2, BS00)
                        Add (BS00, 0x00400000, BS10)
                        Subtract (Zero, BS10, BL00)
                        Store (BL00, BL10)
                        Return (CRS)
                    }
                }
                Device (FWHE)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x03)
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y13)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        CreateDWordField (CRS, \_SB.PCI0.SBRG.FWHE._Y13._BAS, BS00)
                        CreateDWordField (CRS, \_SB.PCI0.SBRG.FWHE._Y13._LEN, BL00)
                        If (LEqual (^^FWH.BS00, Zero))
                        {
                            ^^FWH._CRS ()
                        }
                        Add (^^FWH.BS00, ^^FWH.BL00, BS00)
                        Subtract (^^FWH.BS10, BS00, BL00)
                        Return (CRS)
                    }
                }
                OperationRegion (FHR0, PCI_Config, 0xD8, 0x02)
                Field (FHR0, ByteAcc, NoLock, Preserve)
                {
                    FHD1,   4, 
                            Offset (0x01), 
                    FHD0,   8
                }
                Device (^PCIE)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x11)
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly,
                            0xF8000000,         // Address Base
                            0x04000000,         // Address Length
                            _Y14)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        CreateDWordField (CRS, \_SB.PCI0.PCIE._Y14._BAS, BAS1)
                        CreateDWordField (CRS, \_SB.PCI0.PCIE._Y14._LEN, LEN1)
                        Store (PCIB, BAS1)
                        Store (PCIL, LEN1)
                        Return (CRS)
                    }
                }
                Scope (\_GPE)
                {
                    Method (_L1D, 0, NotSerialized)
                    {
                        Notify (\_SB.PCI0.SBRG.ASOC, One)
                        Sleep (0x03E8)
                    }
                }
                Scope (ASOC)
                {
                    Name (VESL, Zero)
                    Method (SPLV, 1, Serialized)
                    {
                        And (Arg0, 0xFFFF, VESL)
                        Store (VESL, PAR0)
                        ISMI (0x88)
                        Store (And (PAR0, 0xFFFF), Local0)
                        Return (Local0)
                    }
                    Method (GPLV, 0, Serialized)
                    {
                        Return (VESL)
                    }
                }
                Device (UAR1)
                {
                    Name (_UID, One)
                    Name (_HID, EisaId ("PNP0501"))
                    Method (_STA, 0, NotSerialized)
                    {
                        Return (DSTA (Zero))
                    }
                    Method (_DIS, 0, NotSerialized)
                    {
                        DCNT (Zero, Zero)
                    }
                    Method (_CRS, 0, NotSerialized)
                    {
                        Return (DCRS (Zero, Zero))
                    }
                    Method (_SRS, 1, NotSerialized)
                    {
                        DSRS (Arg0, Zero)
                    }
                    Method (_PRS, 0, NotSerialized)
                    {
                        Return (CMPR)
                    }
                    Name (CMPR, ResourceTemplate ()
                    {
                        StartDependentFn (0x00, 0x00)
                        {
                            IO (Decode16,
                                0x03F8,             // Range Minimum
                                0x03F8,             // Range Maximum
                                0x01,               // Alignment
                                0x08,               // Length
                                )
                            IRQNoFlags ()
                                {4}
                            DMA (Compatibility, NotBusMaster, Transfer8, )
                                {}
                        }
                        StartDependentFnNoPri ()
                        {
                            IO (Decode16,
                                0x03F8,             // Range Minimum
                                0x03F8,             // Range Maximum
                                0x01,               // Alignment
                                0x08,               // Length
                                )
                            IRQNoFlags ()
                                {3,4,5,6,7,10,11,12}
                            DMA (Compatibility, NotBusMaster, Transfer8, )
                                {}
                        }
                        StartDependentFnNoPri ()
                        {
                            IO (Decode16,
                                0x02F8,             // Range Minimum
                                0x02F8,             // Range Maximum
                                0x01,               // Alignment
                                0x08,               // Length
                                )
                            IRQNoFlags ()
                                {3,4,5,6,7,10,11,12}
                            DMA (Compatibility, NotBusMaster, Transfer8, )
                                {}
                        }
                        StartDependentFnNoPri ()
                        {
                            IO (Decode16,
                                0x03E8,             // Range Minimum
                                0x03E8,             // Range Maximum
                                0x01,               // Alignment
                                0x08,               // Length
                                )
                            IRQNoFlags ()
                                {3,4,5,6,7,10,11,12}
                            DMA (Compatibility, NotBusMaster, Transfer8, )
                                {}
                        }
                        StartDependentFnNoPri ()
                        {
                            IO (Decode16,
                                0x02E8,             // Range Minimum
                                0x02E8,             // Range Maximum
                                0x01,               // Alignment
                                0x08,               // Length
                                )
                            IRQNoFlags ()
                                {3,4,5,6,7,10,11,12}
                            DMA (Compatibility, NotBusMaster, Transfer8, )
                                {}
                        }
                        EndDependentFn ()
                    })
                }
                Method (UAR1._PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x08, 0x04))
                }
                Device (LDRC)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, Zero)
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y15)
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y16)
                    })
                    Name (CRS1, ResourceTemplate ()
                    {
                        FixedIO (
                            0x0060,             // Address
                            0x01,               // Length
                            )
                        FixedIO (
                            0x0064,             // Address
                            0x01,               // Length
                            )
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y17)
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y18)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        If (APIC)
                        {
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.LDRC._Y15._LEN, ML01)
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.LDRC._Y15._BAS, MB01)
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.LDRC._Y16._LEN, ML02)
                            CreateDWordField (CRS, \_SB.PCI0.SBRG.LDRC._Y16._BAS, MB02)
                            Store (0xFEC00000, MB01)
                            Store (0x1000, ML01)
                            Store (0xFEE00000, MB02)
                            Store (0x1000, ML02)
                            CreateDWordField (CRS1, \_SB.PCI0.SBRG.LDRC._Y17._LEN, ML03)
                            CreateDWordField (CRS1, \_SB.PCI0.SBRG.LDRC._Y17._BAS, MB03)
                            CreateDWordField (CRS1, \_SB.PCI0.SBRG.LDRC._Y18._LEN, ML04)
                            CreateDWordField (CRS1, \_SB.PCI0.SBRG.LDRC._Y18._BAS, MB04)
                            Store (0xFEC00000, MB03)
                            Store (0x1000, ML03)
                            Store (0xFEE00000, MB04)
                            Store (0x1000, ML04)
                        }
                        ShiftLeft (0x05, 0x0A, Local0)
                        If (And (IOST, Local0))
                        {
                            Return (CRS)
                        }
                        Else
                        {
                            Return (CRS1)
                        }
                    }
                }
                Device (^^RMEM)
                {
                    Name (_HID, EisaId ("PNP0C01"))
                    Name (_UID, One)
                    Name (CRS, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadWrite,
                            0x00000000,         // Address Base
                            0x000A0000,         // Address Length
                            )
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y19)
                        Memory32Fixed (ReadOnly,
                            0x000E0000,         // Address Base
                            0x00020000,         // Address Length
                            _Y1A)
                        Memory32Fixed (ReadWrite,
                            0x00100000,         // Address Base
                            0x00000000,         // Address Length
                            _Y1B)
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000000,         // Address Length
                            _Y1C)
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        CreateDWordField (CRS, \_SB.RMEM._Y19._BAS, BAS1)
                        CreateDWordField (CRS, \_SB.RMEM._Y19._LEN, LEN1)
                        CreateDWordField (CRS, \_SB.RMEM._Y1A._BAS, BAS2)
                        CreateDWordField (CRS, \_SB.RMEM._Y1A._LEN, LEN2)
                        CreateDWordField (CRS, \_SB.RMEM._Y1B._LEN, LEN3)
                        CreateDWordField (CRS, \_SB.RMEM._Y1C._BAS, BAS4)
                        CreateDWordField (CRS, \_SB.RMEM._Y1C._LEN, LEN4)
                        If (OSFL ()) {}
                        Else
                        {
                            If (MG1B)
                            {
                                If (LGreater (MG1B, 0x000C0000))
                                {
                                    Store (0x000C0000, BAS1)
                                    Subtract (MG1B, BAS1, LEN1)
                                }
                            }
                            Else
                            {
                                Store (0x000C0000, BAS1)
                                Store (0x00020000, LEN1)
                            }
                            If (Add (MG1B, MG1L, Local0))
                            {
                                Store (Local0, BAS2)
                                Subtract (0x00100000, BAS2, LEN2)
                            }
                        }
                        Subtract (MG2B, 0x00100000, LEN3)
                        Store (MH1B, BAS4)
                        Subtract (Zero, BAS4, LEN4)
                        Return (CRS)
                    }
                }
                Device (PS2K)
                {
                    Name (_HID, EisaId ("PNP0303"))
                    Name (_CID, EisaId ("PNP030B"))
                    Method (_STA, 0, NotSerialized)
                    {
                        ShiftLeft (One, 0x0A, Local0)
                        If (And (IOST, Local0))
                        {
                            Return (0x0F)
                        }
                        Return (Zero)
                    }
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {1}
                    })
                }
                Method (PS2K._PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x1B, 0x04))
                }
                Device (PS2M)
                {
                    Name (_HID, EisaId ("PNP0F03"))
                    Name (_CID, EisaId ("PNP0F13"))
                    Method (_STA, 0, NotSerialized)
                    {
                        ShiftLeft (One, 0x0C, Local0)
                        If (And (IOST, Local0))
                        {
                            Return (0x0F)
                        }
                        Return (Zero)
                    }
                    Name (M2R0, ResourceTemplate ()
                    {
                        IRQNoFlags ()
                            {12}
                    })
                    Name (M2R1, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IRQNoFlags ()
                            {12}
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        ShiftLeft (One, 0x0A, Local0)
                        If (And (IOST, Local0))
                        {
                            Return (M2R0)
                        }
                        Else
                        {
                            Return (M2R1)
                        }
                    }
                }
                Method (PS2M._PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x1C, 0x04))
                }
                Method (_DSM, 4, NotSerialized)
                {
                    Store (Package (0x02)
                        {
                            "device-id", 
                            Buffer (0x04)
                            {
                                0x09, 0x3B, 0x00, 0x00
                            }
                        }, Local0)
                    DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                    Return (Local0)
                }
                Device (HPET)
                {
                    Name (_HID, EisaId ("PNP0103"))
                    Name (CRS, ResourceTemplate ()
                    {
                        IRQNoFlags ()
                            {0}
                        IRQNoFlags ()
                            {8}
                        Memory32Fixed (ReadOnly,
                            0xFED00000,         // Address Base
                            0x00000400,         // Address Length
                            _Y09)
                    })
                    Method (_STA, 0, NotSerialized)
                    {
                        Return (0x0F)
                    }
                    Method (_CRS, 0, NotSerialized)
                    {
                        Return (CRS)
                    }
                }
            }
            Device (EHCI)
            {
                Name (_ADR, 0x001D0000)
                Device (RHUB)
                {
                    Name (_ADR, Zero)
                    Device (PRT1)
                    {
                        Name (_ADR, One)
                        Name (_UPC, Package (0x04)
                        {
                            0xFF, 
                            Zero, 
                            Zero, 
                            Zero
                        })
                        Name (_PLD, Package (0x10)
                        {
                            /* 0000 */    0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                            /* 0008 */    0x30, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
                        })
                    }
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0D, 0x04))
                }
            }
            Device (UHC1)
            {
                Name (_ADR, 0x001D0001)
                OperationRegion (BAR0, PCI_Config, 0xC4, One)
                Field (BAR0, ByteAcc, NoLock, Preserve)
                {
                    USBW,   2, 
                            Offset (0x01)
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (LOr (LEqual (OSFL (), One), LEqual (OSFL (), 0x02)))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }
                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, USBW)
                    }
                    Else
                    {
                        Store (Zero, USBW)
                    }
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x03, 0x04))
                }
            }
            Device (UHC2)
            {
                Name (_ADR, 0x001D0002)
                OperationRegion (BAR0, PCI_Config, 0xC4, One)
                Field (BAR0, ByteAcc, NoLock, Preserve)
                {
                    USBW,   2, 
                            Offset (0x01)
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (LOr (LEqual (OSFL (), One), LEqual (OSFL (), 0x02)))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }
                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, USBW)
                    }
                    Else
                    {
                        Store (Zero, USBW)
                    }
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x04, 0x04))
                }
            }
            Device (UHC3)
            {
                Name (_ADR, 0x001D0003)
                OperationRegion (BAR0, PCI_Config, 0xC4, One)
                Field (BAR0, ByteAcc, NoLock, Preserve)
                {
                    USBW,   2, 
                            Offset (0x01)
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (LOr (LEqual (OSFL (), One), LEqual (OSFL (), 0x02)))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }
                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, USBW)
                    }
                    Else
                    {
                        Store (Zero, USBW)
                    }
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0C, 0x04))
                }
            }
            Device (UHC4)
            {
                Name (_ADR, 0x001D0004)
                OperationRegion (BAR0, PCI_Config, 0xC4, One)
                Field (BAR0, ByteAcc, NoLock, Preserve)
                {
                    USBW,   2, 
                            Offset (0x01)
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (LOr (LEqual (OSFL (), One), LEqual (OSFL (), 0x02)))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }
                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, USBW)
                    }
                    Else
                    {
                        Store (Zero, USBW)
                    }
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0E, 0x04))
                }
            }
            Device (UCHI)
            {
                Name (_ADR, 0x001A0000)
                Device (RHUB)
                {
                    Name (_ADR, Zero)
                    Device (PRT1)
                    {
                        Name (_ADR, One)
                        Name (_UPC, Package (0x04)
                        {
                            0xFF, 
                            Zero, 
                            Zero, 
                            Zero
                        })
                        Name (_PLD, Package (0x10)
                        {
                            /* 0000 */    0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                            /* 0008 */    0x30, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
                        })
                    }
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x0D, 0x04))
                }
            }
            Device (UHC5)
            {
                Name (_ADR, 0x001A0001)
                OperationRegion (BAR0, PCI_Config, 0xC4, One)
                Field (BAR0, ByteAcc, NoLock, Preserve)
                {
                    USBW,   2, 
                            Offset (0x01)
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (LOr (LEqual (OSFL (), One), LEqual (OSFL (), 0x02)))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }
                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, USBW)
                    }
                    Else
                    {
                        Store (Zero, USBW)
                    }
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x05, 0x04))
                }
            }
            Device (UHC6)
            {
                Name (_ADR, 0x001A0002)
                OperationRegion (BAR0, PCI_Config, 0xC4, One)
                Field (BAR0, ByteAcc, NoLock, Preserve)
                {
                    USBW,   2, 
                            Offset (0x01)
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (LOr (LEqual (OSFL (), One), LEqual (OSFL (), 0x02)))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }
                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, USBW)
                    }
                    Else
                    {
                        Store (Zero, USBW)
                    }
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x20, 0x04))
                }
            }
            Device (UHC7)
            {
                Name (_ADR, 0x001A0003)
                OperationRegion (BAR0, PCI_Config, 0xC4, One)
                Field (BAR0, ByteAcc, NoLock, Preserve)
                {
                    USBW,   2, 
                            Offset (0x01)
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (LOr (LEqual (OSFL (), One), LEqual (OSFL (), 0x02)))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }
                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, USBW)
                    }
                    Else
                    {
                        Store (Zero, USBW)
                    }
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x25, 0x04))
                }
            }
            Device (P0P1)
            {
                Name (_ADR, 0x00010000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR01)
                    }
                    Return (PR01)
                }
            }
            Device (P0P3)
            {
                Name (_ADR, 0x00030000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR03)
                    }
                    Return (PR03)
                }
            }
            Device (P0P5)
            {
                Name (_ADR, 0x00050000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR05)
                    }
                    Return (PR05)
                }
            }
            Device (P0P6)
            {
                Name (_ADR, 0x00060000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR06)
                    }
                    Return (PR06)
                }
            }
            Device (USB8)
            {
                Name (_ADR, 0x001A0007)
                OperationRegion (BAR0, PCI_Config, 0xC4, One)
                Field (BAR0, ByteAcc, NoLock, Preserve)
                {
                    USBW,   2, 
                            Offset (0x01)
                }
                Method (_S3D, 0, NotSerialized)
                {
                    If (LOr (LEqual (OSFL (), One), LEqual (OSFL (), 0x02)))
                    {
                        Return (0x02)
                    }
                    Else
                    {
                        Return (0x03)
                    }
                }
                Method (_PSW, 1, NotSerialized)
                {
                    If (Arg0)
                    {
                        Store (0x03, USBW)
                    }
                    Else
                    {
                        Store (Zero, USBW)
                    }
                }
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x20, 0x04))
                }
                                Method (_DSM, 4, NotSerialized)
                                {
                                    Store (Package (0x04)
                                        {
                                            "device-id", 
                                            Buffer (0x04)
                                            {
                                                0x3c, 0x3a, 0x00, 0x00
                                            }, 
                                            "AAPL,clock-id", 
                                            Buffer (One)
                                            {
                                                0x02
                                            }
                                        }, Local0)
                                    DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                                    Return (Local0)
                                }
            }
            Device (BR20)
            {
                Name (_ADR, 0x001C0000)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR20)
                    }
                    Return (PR20)
                }
            }
            Device (BR24)
            {
                Name (_ADR, 0x001C0004)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR24)
                    }
                    Return (PR24)
                }
            }
            Device (BR25)
            {
                Name (_ADR, 0x001C0005)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR25)
                    }
                    Return (PR25)
                }
            }
            Device (BR26)
            {
                Name (_ADR, 0x001C0006)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR26)
                    }
                    Return (PR26)
                }
                Device (JMB0)
                {
                    Name (_ADR, Zero)
                    OperationRegion (CF40, PCI_Config, 0x40, 0x04)
                    Field (CF40, ByteAcc, NoLock, Preserve)
                    {
                        CHE0,   1, 
                        MULT,   1, 
                            ,   1, 
                        CAB0,   1, 
                        CHE1,   1, 
                                Offset (0x01), 
                        AHEN,   1, 
                            ,   3, 
                        PRT0,   1, 
                        AHM0,   1, 
                        PRT1,   1, 
                        AHM1,   1, 
                        CF42,   6, 
                        SWAP,   1, 
                        PATA,   1, 
                            ,   6, 
                        WTEN,   1, 
                                Offset (0x04)
                    }
                    Name (PIOT, Package (0x05)
                    {
                        0x0258, 
                        0x0186, 
                        0x014A, 
                        0xB4, 
                        0x78
                    })
                    Name (UDMA, Package (0x07)
                    {
                        0x78, 
                        0x50, 
                        0x3C, 
                        0x28, 
                        0x1E, 
                        0x14, 
                        0x0F
                    })
                    Name (MDMA, Package (0x03)
                    {
                        0x01E0, 
                        0x96, 
                        0x78
                    })
                    Name (IDEB, Buffer (0x14) {})
                    CreateDWordField (IDEB, Zero, GTM0)
                    CreateDWordField (IDEB, 0x04, GTM1)
                    CreateDWordField (IDEB, 0x08, GTM2)
                    CreateDWordField (IDEB, 0x0C, GTM3)
                    CreateDWordField (IDEB, 0x10, GTM4)
                    Name (PIO0, 0x04)
                    Name (DMA0, 0x06)
                    Name (MDA0, 0x02)
                    Name (PIO1, 0x04)
                    Name (DMA1, 0x06)
                    Name (MDA1, 0x02)
                    Name (PIO2, 0x04)
                    Name (DMA2, 0x06)
                    Name (MDA2, 0x02)
                    Name (PIO3, 0x04)
                    Name (DMA3, 0x06)
                    Name (MDA3, 0x02)
                    Name (FLGP, 0x1F)
                    Name (FLGS, 0x1F)
                    Device (IDE0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTM, 0, NotSerialized)
                        {
                            Store (DerefOf (Index (PIOT, PIO0)), Local0)
                            Store (DerefOf (Index (PIOT, PIO1)), Local2)
                            Store (0x1A, Local4)
                            If (LAnd (FLGP, One))
                            {
                                If (LNot (MULT))
                                {
                                    If (LAnd (CAB0, SWAP))
                                    {
                                        Store (0x02, DMA0)
                                    }
                                }
                                Store (DerefOf (Index (UDMA, DMA0)), Local1)
                                Or (Local4, One, Local4)
                            }
                            Else
                            {
                                Store (DerefOf (Index (MDMA, MDA0)), Local1)
                            }
                            If (LAnd (FLGP, 0x04))
                            {
                                If (LAnd (CAB0, SWAP))
                                {
                                    Store (0x02, DMA1)
                                }
                                Store (DerefOf (Index (UDMA, DMA1)), Local3)
                                Or (Local4, 0x04, Local4)
                            }
                            Else
                            {
                                Store (DerefOf (Index (MDMA, MDA1)), Local3)
                            }
                            Store (Local0, GTM0)
                            Store (Local1, GTM1)
                            Store (Local2, GTM2)
                            Store (Local3, GTM3)
                            Store (Local4, GTM4)
                            Return (IDEB)
                        }
                        Method (_STM, 3, NotSerialized)
                        {
                            Store (Arg0, IDEB)
                            Store (GTM0, Local0)
                            Store (GTM1, Local1)
                            Store (GTM2, Local2)
                            Store (GTM3, Local3)
                            Store (GTM4, Local4)
                            Store (Local4, FLGP)
                            If (LAnd (LNotEqual (Local0, Ones), LNotEqual (Local0, Zero)))
                            {
                                Store (Match (PIOT, MEQ, Local0, MTR, Zero, Zero), PIO0)
                            }
                            If (LAnd (LNotEqual (Local1, Ones), LNotEqual (Local1, Zero)))
                            {
                                If (LAnd (FLGP, One))
                                {
                                    Store (Match (UDMA, MEQ, Local1, MTR, Zero, Zero), DMA0)
                                }
                                Else
                                {
                                    Store (Match (MDMA, MEQ, Local1, MTR, Zero, Zero), MDA0)
                                }
                            }
                            If (LAnd (LNotEqual (Local2, Ones), LNotEqual (Local2, Zero)))
                            {
                                Store (Match (PIOT, MEQ, Local2, MTR, Zero, Zero), PIO1)
                            }
                            If (LAnd (LNotEqual (Local3, Ones), LNotEqual (Local3, Zero)))
                            {
                                If (LAnd (FLGP, 0x04))
                                {
                                    Store (Match (UDMA, MEQ, Local3, MTR, Zero, Zero), DMA1)
                                }
                                Else
                                {
                                    Store (Match (MDMA, MEQ, Local3, MTR, Zero, Zero), MDA1)
                                }
                            }
                        }
                        Device (DRV0)
                        {
                            Name (_ADR, Zero)
                            Method (_GTF, 0, NotSerialized)
                            {
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                    }, Local0)
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                    }, Local1)
                                CreateByteField (Local0, One, PIOM)
                                CreateByteField (Local1, One, DMAM)
                                Store (PIO0, PIOM)
                                Or (PIOM, 0x08, PIOM)
                                If (LAnd (FLGP, One))
                                {
                                    Store (DMA0, DMAM)
                                    Or (DMAM, 0x40, DMAM)
                                }
                                Else
                                {
                                    Store (MDA0, DMAM)
                                    Or (DMAM, 0x20, DMAM)
                                }
                                Concatenate (Local0, Local1, Local2)
                                Return (Local2)
                            }
                        }
                        Device (DRV1)
                        {
                            Name (_ADR, One)
                            Method (_GTF, 0, NotSerialized)
                            {
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                                    }, Local0)
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                                    }, Local1)
                                CreateByteField (Local0, One, PIOM)
                                CreateByteField (Local1, One, DMAM)
                                Store (PIO1, PIOM)
                                Or (PIOM, 0x08, PIOM)
                                If (LAnd (FLGP, 0x04))
                                {
                                    Store (DMA1, DMAM)
                                    Or (DMAM, 0x40, DMAM)
                                }
                                Else
                                {
                                    Store (MDA1, DMAM)
                                    Or (DMAM, 0x20, DMAM)
                                }
                                Concatenate (Local0, Local1, Local2)
                                Return (Local2)
                            }
                        }
                    }
                    Device (IDE1)
                    {
                        Name (_ADR, One)
                        Method (_GTM, 0, NotSerialized)
                        {
                            Store (DerefOf (Index (PIOT, PIO2)), Local0)
                            Store (DerefOf (Index (PIOT, PIO3)), Local2)
                            Store (0x1A, Local4)
                            If (LAnd (FLGS, One))
                            {
                                If (LNot (MULT))
                                {
                                    If (LAnd (CAB0, LNot (SWAP)))
                                    {
                                        Store (0x02, DMA2)
                                    }
                                }
                                Store (DerefOf (Index (UDMA, DMA2)), Local1)
                                Or (Local4, One, Local4)
                            }
                            Else
                            {
                                Store (DerefOf (Index (MDMA, MDA2)), Local1)
                            }
                            If (LAnd (FLGS, 0x04))
                            {
                                If (LAnd (CAB0, LNot (SWAP)))
                                {
                                    Store (0x02, DMA3)
                                }
                                Store (DerefOf (Index (UDMA, DMA3)), Local3)
                                Or (Local4, 0x04, Local4)
                            }
                            Else
                            {
                                Store (DerefOf (Index (MDMA, MDA3)), Local3)
                            }
                            Store (Local0, GTM0)
                            Store (Local1, GTM1)
                            Store (Local2, GTM2)
                            Store (Local3, GTM3)
                            Store (Local4, GTM4)
                            Return (IDEB)
                        }
                        Method (_STM, 3, NotSerialized)
                        {
                            Store (Arg0, IDEB)
                            Store (GTM0, Local0)
                            Store (GTM1, Local1)
                            Store (GTM2, Local2)
                            Store (GTM3, Local3)
                            Store (GTM4, Local4)
                            Store (Local4, FLGS)
                            If (LAnd (LNotEqual (Local0, Ones), LNotEqual (Local0, Zero)))
                            {
                                Store (Match (PIOT, MEQ, Local0, MTR, Zero, Zero), PIO2)
                            }
                            If (LAnd (LNotEqual (Local1, Ones), LNotEqual (Local1, Zero)))
                            {
                                If (LAnd (FLGS, One))
                                {
                                    Store (Match (UDMA, MEQ, Local1, MTR, Zero, Zero), DMA2)
                                }
                                Else
                                {
                                    Store (Match (MDMA, MEQ, Local1, MTR, Zero, Zero), MDA2)
                                }
                            }
                            If (LAnd (LNotEqual (Local2, Ones), LNotEqual (Local2, Zero)))
                            {
                                Store (Match (PIOT, MEQ, Local2, MTR, Zero, Zero), PIO3)
                            }
                            If (LAnd (LNotEqual (Local3, Ones), LNotEqual (Local3, Zero)))
                            {
                                If (LAnd (FLGS, 0x04))
                                {
                                    Store (Match (UDMA, MEQ, Local3, MTR, Zero, Zero), DMA3)
                                }
                                Else
                                {
                                    Store (Match (MDMA, MEQ, Local3, MTR, Zero, Zero), MDA3)
                                }
                            }
                        }
                        Device (DRV0)
                        {
                            Name (_ADR, Zero)
                            Method (_GTF, 0, NotSerialized)
                            {
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                    }, Local0)
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                    }, Local1)
                                CreateByteField (Local0, One, PIOM)
                                CreateByteField (Local1, One, DMAM)
                                Store (PIO2, PIOM)
                                Or (PIOM, 0x08, PIOM)
                                If (LAnd (FLGS, One))
                                {
                                    Store (DMA2, DMAM)
                                    Or (DMAM, 0x40, DMAM)
                                }
                                Else
                                {
                                    Store (MDA2, DMAM)
                                    Or (DMAM, 0x20, DMAM)
                                }
                                Concatenate (Local0, Local1, Local2)
                                Return (Local2)
                            }
                        }
                        Device (DRV1)
                        {
                            Name (_ADR, One)
                            Method (_GTF, 0, NotSerialized)
                            {
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                                    }, Local0)
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                                    }, Local1)
                                CreateByteField (Local0, One, PIOM)
                                CreateByteField (Local1, One, DMAM)
                                Store (PIO3, PIOM)
                                Or (PIOM, 0x08, PIOM)
                                If (LAnd (FLGS, 0x04))
                                {
                                    Store (DMA3, DMAM)
                                    Or (DMAM, 0x40, DMAM)
                                }
                                Else
                                {
                                    Store (MDA3, DMAM)
                                    Or (DMAM, 0x20, DMAM)
                                }
                                Concatenate (Local0, Local1, Local2)
                                Return (Local2)
                            }
                        }
                    }
                }
                Device (JMB1)
                {
                    Name (_ADR, One)
                    OperationRegion (CF40, PCI_Config, 0x40, 0x04)
                    Field (CF40, ByteAcc, NoLock, Preserve)
                    {
                        CHE0,   1, 
                        MULT,   1, 
                            ,   1, 
                        CAB0,   1, 
                        CHE1,   1, 
                                Offset (0x01), 
                        AHEN,   1, 
                            ,   3, 
                        PRT0,   1, 
                        AHM0,   1, 
                        PRT1,   1, 
                        AHM1,   1, 
                        CF42,   6, 
                        SWAP,   1, 
                        PATA,   1, 
                            ,   6, 
                        WTEN,   1, 
                                Offset (0x04)
                    }
                    Name (PIOT, Package (0x05)
                    {
                        0x0258, 
                        0x0186, 
                        0x014A, 
                        0xB4, 
                        0x78
                    })
                    Name (UDMA, Package (0x07)
                    {
                        0x78, 
                        0x50, 
                        0x3C, 
                        0x28, 
                        0x1E, 
                        0x14, 
                        0x0F
                    })
                    Name (MDMA, Package (0x03)
                    {
                        0x01E0, 
                        0x96, 
                        0x78
                    })
                    Name (IDEB, Buffer (0x14) {})
                    CreateDWordField (IDEB, Zero, GTM0)
                    CreateDWordField (IDEB, 0x04, GTM1)
                    CreateDWordField (IDEB, 0x08, GTM2)
                    CreateDWordField (IDEB, 0x0C, GTM3)
                    CreateDWordField (IDEB, 0x10, GTM4)
                    Name (PIO0, 0x04)
                    Name (DMA0, 0x06)
                    Name (MDA0, 0x02)
                    Name (PIO1, 0x04)
                    Name (DMA1, 0x06)
                    Name (MDA1, 0x02)
                    Name (PIO2, 0x04)
                    Name (DMA2, 0x06)
                    Name (MDA2, 0x02)
                    Name (PIO3, 0x04)
                    Name (DMA3, 0x06)
                    Name (MDA3, 0x02)
                    Name (FLGP, 0x1F)
                    Name (FLGS, 0x1F)
                    Device (IDE0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTM, 0, NotSerialized)
                        {
                            Store (DerefOf (Index (PIOT, PIO0)), Local0)
                            Store (DerefOf (Index (PIOT, PIO1)), Local2)
                            Store (0x1A, Local4)
                            If (LAnd (FLGP, One))
                            {
                                If (LAnd (CAB0, SWAP))
                                {
                                    Store (0x02, DMA0)
                                }
                                Store (DerefOf (Index (UDMA, DMA0)), Local1)
                                Or (Local4, One, Local4)
                            }
                            Else
                            {
                                Store (DerefOf (Index (MDMA, MDA0)), Local1)
                            }
                            If (LAnd (FLGP, 0x04))
                            {
                                If (LAnd (CAB0, SWAP))
                                {
                                    Store (0x02, DMA1)
                                }
                                Store (DerefOf (Index (UDMA, DMA1)), Local3)
                                Or (Local4, 0x04, Local4)
                            }
                            Else
                            {
                                Store (DerefOf (Index (MDMA, MDA1)), Local3)
                            }
                            Store (Local0, GTM0)
                            Store (Local1, GTM1)
                            Store (Local2, GTM2)
                            Store (Local3, GTM3)
                            Store (Local4, GTM4)
                            Return (IDEB)
                        }
                        Method (_STM, 3, NotSerialized)
                        {
                            Store (Arg0, IDEB)
                            Store (GTM0, Local0)
                            Store (GTM1, Local1)
                            Store (GTM2, Local2)
                            Store (GTM3, Local3)
                            Store (GTM4, Local4)
                            Store (Local4, FLGP)
                            If (LAnd (LNotEqual (Local0, Ones), LNotEqual (Local0, Zero)))
                            {
                                Store (Match (PIOT, MEQ, Local0, MTR, Zero, Zero), PIO0)
                            }
                            If (LAnd (LNotEqual (Local1, Ones), LNotEqual (Local1, Zero)))
                            {
                                If (LAnd (FLGP, One))
                                {
                                    Store (Match (UDMA, MEQ, Local1, MTR, Zero, Zero), DMA0)
                                }
                                Else
                                {
                                    Store (Match (MDMA, MEQ, Local1, MTR, Zero, Zero), MDA0)
                                }
                            }
                            If (LAnd (LNotEqual (Local2, Ones), LNotEqual (Local2, Zero)))
                            {
                                Store (Match (PIOT, MEQ, Local2, MTR, Zero, Zero), PIO1)
                            }
                            If (LAnd (LNotEqual (Local3, Ones), LNotEqual (Local3, Zero)))
                            {
                                If (LAnd (FLGP, 0x04))
                                {
                                    Store (Match (UDMA, MEQ, Local3, MTR, Zero, Zero), DMA1)
                                }
                                Else
                                {
                                    Store (Match (MDMA, MEQ, Local3, MTR, Zero, Zero), MDA1)
                                }
                            }
                        }
                        Device (DRV0)
                        {
                            Name (_ADR, Zero)
                            Method (_GTF, 0, NotSerialized)
                            {
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                    }, Local0)
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                    }, Local1)
                                CreateByteField (Local0, One, PIOM)
                                CreateByteField (Local1, One, DMAM)
                                Store (PIO0, PIOM)
                                Or (PIOM, 0x08, PIOM)
                                If (LAnd (FLGP, One))
                                {
                                    Store (DMA0, DMAM)
                                    Or (DMAM, 0x40, DMAM)
                                }
                                Else
                                {
                                    Store (MDA0, DMAM)
                                    Or (DMAM, 0x20, DMAM)
                                }
                                Concatenate (Local0, Local1, Local2)
                                Return (Local2)
                            }
                        }
                        Device (DRV1)
                        {
                            Name (_ADR, One)
                            Method (_GTF, 0, NotSerialized)
                            {
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                                    }, Local0)
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                                    }, Local1)
                                CreateByteField (Local0, One, PIOM)
                                CreateByteField (Local1, One, DMAM)
                                Store (PIO1, PIOM)
                                Or (PIOM, 0x08, PIOM)
                                If (LAnd (FLGP, 0x04))
                                {
                                    Store (DMA1, DMAM)
                                    Or (DMAM, 0x40, DMAM)
                                }
                                Else
                                {
                                    Store (MDA1, DMAM)
                                    Or (DMAM, 0x20, DMAM)
                                }
                                Concatenate (Local0, Local1, Local2)
                                Return (Local2)
                            }
                        }
                    }
                    Device (IDE1)
                    {
                        Name (_ADR, One)
                        Method (_GTM, 0, NotSerialized)
                        {
                            Store (DerefOf (Index (PIOT, PIO2)), Local0)
                            Store (DerefOf (Index (PIOT, PIO3)), Local2)
                            Store (0x1A, Local4)
                            If (LAnd (FLGS, One))
                            {
                                If (LAnd (CAB0, LNot (SWAP)))
                                {
                                    Store (0x02, DMA2)
                                }
                                Store (DerefOf (Index (UDMA, DMA2)), Local1)
                                Or (Local4, One, Local4)
                            }
                            Else
                            {
                                Store (DerefOf (Index (MDMA, MDA2)), Local1)
                            }
                            If (LAnd (FLGS, 0x04))
                            {
                                If (LAnd (CAB0, LNot (SWAP)))
                                {
                                    Store (0x02, DMA3)
                                }
                                Store (DerefOf (Index (UDMA, DMA3)), Local3)
                                Or (Local4, 0x04, Local4)
                            }
                            Else
                            {
                                Store (DerefOf (Index (MDMA, MDA3)), Local3)
                            }
                            Store (Local0, GTM0)
                            Store (Local1, GTM1)
                            Store (Local2, GTM2)
                            Store (Local3, GTM3)
                            Store (Local4, GTM4)
                            Return (IDEB)
                        }
                        Method (_STM, 3, NotSerialized)
                        {
                            Store (Arg0, IDEB)
                            Store (GTM0, Local0)
                            Store (GTM1, Local1)
                            Store (GTM2, Local2)
                            Store (GTM3, Local3)
                            Store (GTM4, Local4)
                            Store (Local4, FLGS)
                            If (LAnd (LNotEqual (Local0, Ones), LNotEqual (Local0, Zero)))
                            {
                                Store (Match (PIOT, MEQ, Local0, MTR, Zero, Zero), PIO2)
                            }
                            If (LAnd (LNotEqual (Local1, Ones), LNotEqual (Local1, Zero)))
                            {
                                If (LAnd (FLGS, One))
                                {
                                    Store (Match (UDMA, MEQ, Local1, MTR, Zero, Zero), DMA2)
                                }
                                Else
                                {
                                    Store (Match (MDMA, MEQ, Local1, MTR, Zero, Zero), MDA2)
                                }
                            }
                            If (LAnd (LNotEqual (Local2, Ones), LNotEqual (Local2, Zero)))
                            {
                                Store (Match (PIOT, MEQ, Local2, MTR, Zero, Zero), PIO3)
                            }
                            If (LAnd (LNotEqual (Local3, Ones), LNotEqual (Local3, Zero)))
                            {
                                If (LAnd (FLGS, 0x04))
                                {
                                    Store (Match (UDMA, MEQ, Local3, MTR, Zero, Zero), DMA3)
                                }
                                Else
                                {
                                    Store (Match (MDMA, MEQ, Local3, MTR, Zero, Zero), MDA3)
                                }
                            }
                        }
                        Device (DRV0)
                        {
                            Name (_ADR, Zero)
                            Method (_GTF, 0, NotSerialized)
                            {
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                    }, Local0)
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                    }, Local1)
                                CreateByteField (Local0, One, PIOM)
                                CreateByteField (Local1, One, DMAM)
                                Store (PIO2, PIOM)
                                Or (PIOM, 0x08, PIOM)
                                If (LAnd (FLGS, One))
                                {
                                    Store (DMA2, DMAM)
                                    Or (DMAM, 0x40, DMAM)
                                }
                                Else
                                {
                                    Store (MDA2, DMAM)
                                    Or (DMAM, 0x20, DMAM)
                                }
                                Concatenate (Local0, Local1, Local2)
                                Return (Local2)
                            }
                        }
                        Device (DRV1)
                        {
                            Name (_ADR, One)
                            Method (_GTF, 0, NotSerialized)
                            {
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                                    }, Local0)
                                Store (Buffer (0x07)
                                    {
                                        0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF
                                    }, Local1)
                                CreateByteField (Local0, One, PIOM)
                                CreateByteField (Local1, One, DMAM)
                                Store (PIO3, PIOM)
                                Or (PIOM, 0x08, PIOM)
                                If (LAnd (FLGS, 0x04))
                                {
                                    Store (DMA3, DMAM)
                                    Or (DMAM, 0x40, DMAM)
                                }
                                Else
                                {
                                    Store (MDA3, DMAM)
                                    Or (DMAM, 0x20, DMAM)
                                }
                                Concatenate (Local0, Local1, Local2)
                                Return (Local2)
                            }
                        }
                    }
                }
            }
            Device (BR27)
            {
                Name (_ADR, 0x001C0007)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR27)
                    }
                    Return (PR27)
                }
            }
            Device (SATA)
            {
                Name (_ADR, 0x001F0002)
                Name (^NATA, Package (0x01)
                {
                    0x001F0002
                })
                Name (\FZTF, Buffer (0x07)
                {
                    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF5
                })
                Name (REGF, One)
                Method (_REG, 2, NotSerialized)
                {
                    If (LEqual (Arg0, 0x02))
                    {
                        Store (Arg1, REGF)
                    }
                }
                Name (TIM0, Package (0x08)
                {
                    Package (0x04)
                    {
                        0x78, 
                        0xB4, 
                        0xF0, 
                        0x0384
                    }, 
                    Package (0x04)
                    {
                        0x23, 
                        0x21, 
                        0x10, 
                        Zero
                    }, 
                    Package (0x04)
                    {
                        0x0B, 
                        0x09, 
                        0x04, 
                        Zero
                    }, 
                    Package (0x06)
                    {
                        0x78, 
                        0x50, 
                        0x3C, 
                        0x28, 
                        0x1E, 
                        0x14
                    }, 
                    Package (0x06)
                    {
                        Zero, 
                        One, 
                        0x02, 
                        One, 
                        0x02, 
                        One
                    }, 
                    Package (0x06)
                    {
                        Zero, 
                        Zero, 
                        Zero, 
                        One, 
                        One, 
                        One
                    }, 
                    Package (0x04)
                    {
                        0x04, 
                        0x03, 
                        0x02, 
                        Zero
                    }, 
                    Package (0x04)
                    {
                        0x02, 
                        One, 
                        Zero, 
                        Zero
                    }
                })
                Name (TMD0, Buffer (0x14) {})
                CreateDWordField (TMD0, Zero, PIO0)
                CreateDWordField (TMD0, 0x04, DMA0)
                CreateDWordField (TMD0, 0x08, PIO1)
                CreateDWordField (TMD0, 0x0C, DMA1)
                CreateDWordField (TMD0, 0x10, CHNF)
                OperationRegion (CFG2, PCI_Config, 0x40, 0x20)
                Field (CFG2, DWordAcc, NoLock, Preserve)
                {
                    PMPT,   4, 
                    PSPT,   4, 
                    PMRI,   6, 
                            Offset (0x02), 
                    SMPT,   4, 
                    SSPT,   4, 
                    SMRI,   6, 
                            Offset (0x04), 
                    PSRI,   4, 
                    SSRI,   4, 
                            Offset (0x08), 
                    PM3E,   1, 
                    PS3E,   1, 
                    SM3E,   1, 
                    SS3E,   1, 
                            Offset (0x0A), 
                    PMUT,   2, 
                        ,   2, 
                    PSUT,   2, 
                            Offset (0x0B), 
                    SMUT,   2, 
                        ,   2, 
                    SSUT,   2, 
                            Offset (0x0C), 
                            Offset (0x14), 
                    PM6E,   1, 
                    PS6E,   1, 
                    SM6E,   1, 
                    SS6E,   1, 
                    PMCR,   1, 
                    PSCR,   1, 
                    SMCR,   1, 
                    SSCR,   1, 
                        ,   4, 
                    PMAE,   1, 
                    PSAE,   1, 
                    SMAE,   1, 
                    SSAE,   1
                }
                Name (GMPT, Zero)
                Name (GMUE, Zero)
                Name (GMUT, Zero)
                Name (GMCR, Zero)
                Name (GSPT, Zero)
                Name (GSUE, Zero)
                Name (GSUT, Zero)
                Name (GSCR, Zero)
                Device (PRT0)
                {
                    Name (_ADR, Zero)
                    Method (_GTM, 0, NotSerialized)
                    {
                        ShiftLeft (PSCR, One, Local1)
                        Or (PMCR, Local1, Local0)
                        ShiftLeft (PMAE, 0x02, Local3)
                        ShiftLeft (PM6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (PM3E, Local3, Local1)
                        ShiftLeft (PMPT, 0x04, Local3)
                        Or (Local1, Local3, Local1)
                        ShiftLeft (PSAE, 0x02, Local3)
                        ShiftLeft (PS6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (PS3E, Local3, Local2)
                        ShiftLeft (PSPT, 0x04, Local3)
                        Or (Local2, Local3, Local2)
                        Return (GTM (PMRI, Local1, PMUT, PSRI, Local2, PSUT, Local0))
                    }
                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, Debug)
                        Store (Arg0, TMD0)
                        ShiftLeft (PMAE, 0x02, Local3)
                        ShiftLeft (PM6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (PM3E, Local3, Local0)
                        ShiftLeft (PMPT, 0x04, Local3)
                        Or (Local0, Local3, Local0)
                        ShiftLeft (PSAE, 0x02, Local3)
                        ShiftLeft (PS6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (PS3E, Local3, Local1)
                        ShiftLeft (PSPT, 0x04, Local3)
                        Or (Local1, Local3, Local1)
                        Store (PMRI, GMPT)
                        Store (Local0, GMUE)
                        Store (PMUT, GMUT)
                        Store (PMCR, GMCR)
                        Store (PSRI, GSPT)
                        Store (Local1, GSUE)
                        Store (PSUT, GSUT)
                        Store (PSCR, GSCR)
                        STM ()
                        Store (GMPT, PMRI)
                        Store (GMUE, Local0)
                        Store (GMUT, PMUT)
                        Store (GMCR, PMCR)
                        Store (GSUE, Local1)
                        Store (GSUT, PSUT)
                        Store (GSCR, PSCR)
                        If (And (Local0, One))
                        {
                            Store (One, PM3E)
                        }
                        Else
                        {
                            Store (Zero, PM3E)
                        }
                        If (And (Local0, 0x02))
                        {
                            Store (One, PM6E)
                        }
                        Else
                        {
                            Store (Zero, PM6E)
                        }
                        If (And (Local0, 0x04))
                        {
                            Store (One, PMAE)
                        }
                        Else
                        {
                            Store (Zero, PMAE)
                        }
                        If (And (Local1, One))
                        {
                            Store (One, PS3E)
                        }
                        Else
                        {
                            Store (Zero, PS3E)
                        }
                        If (And (Local1, 0x02))
                        {
                            Store (One, PS6E)
                        }
                        Else
                        {
                            Store (Zero, PS6E)
                        }
                        If (And (Local1, 0x04))
                        {
                            Store (One, PSAE)
                        }
                        Else
                        {
                            Store (Zero, PSAE)
                        }
                        Store (GTF (Zero, Arg1), ATA0)
                        Store (GTF (One, Arg2), ATA1)
                    }
                    Device (DRV0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (RATA (ATA0))
                        }
                    }
                    Device (DRV1)
                    {
                        Name (_ADR, One)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (RATA (ATA1))
                        }
                    }
                }
                Device (PRT1)
                {
                    Name (_ADR, One)
                    Method (_GTM, 0, NotSerialized)
                    {
                        ShiftLeft (SSCR, One, Local1)
                        Or (SMCR, Local1, Local0)
                        ShiftLeft (SMAE, 0x02, Local3)
                        ShiftLeft (SM6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (SM3E, Local3, Local1)
                        ShiftLeft (SMPT, 0x04, Local3)
                        Or (Local1, Local3, Local1)
                        ShiftLeft (SSAE, 0x02, Local3)
                        ShiftLeft (SS6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (SS3E, Local3, Local2)
                        ShiftLeft (SSPT, 0x04, Local3)
                        Or (Local2, Local3, Local2)
                        Return (GTM (SMRI, Local1, SMUT, SSRI, Local2, SSUT, Local0))
                    }
                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, Debug)
                        Store (Arg0, TMD0)
                        ShiftLeft (SMAE, 0x02, Local3)
                        ShiftLeft (SM6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (SM3E, Local3, Local0)
                        ShiftLeft (SMPT, 0x04, Local3)
                        Or (Local0, Local3, Local0)
                        ShiftLeft (SSAE, 0x02, Local3)
                        ShiftLeft (SS6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (SS3E, Local3, Local1)
                        ShiftLeft (SSPT, 0x04, Local3)
                        Or (Local1, Local3, Local1)
                        Store (SMRI, GMPT)
                        Store (Local0, GMUE)
                        Store (SMUT, GMUT)
                        Store (SMCR, GMCR)
                        Store (SSRI, GSPT)
                        Store (Local1, GSUE)
                        Store (SSUT, GSUT)
                        Store (SSCR, GSCR)
                        STM ()
                        Store (GMPT, SMRI)
                        Store (GMUE, Local0)
                        Store (GMUT, SMUT)
                        Store (GMCR, SMCR)
                        Store (GSUE, Local1)
                        Store (GSUT, SSUT)
                        Store (GSCR, SSCR)
                        If (And (Local0, One))
                        {
                            Store (One, SM3E)
                        }
                        Else
                        {
                            Store (Zero, SM3E)
                        }
                        If (And (Local0, 0x02))
                        {
                            Store (One, SM6E)
                        }
                        Else
                        {
                            Store (Zero, SM6E)
                        }
                        If (And (Local0, 0x04))
                        {
                            Store (One, SMAE)
                        }
                        Else
                        {
                            Store (Zero, SMAE)
                        }
                        If (And (Local1, One))
                        {
                            Store (One, SS3E)
                        }
                        Else
                        {
                            Store (Zero, SS3E)
                        }
                        If (And (Local1, 0x02))
                        {
                            Store (One, SS6E)
                        }
                        Else
                        {
                            Store (Zero, SS6E)
                        }
                        If (And (Local1, 0x04))
                        {
                            Store (One, SSAE)
                        }
                        Else
                        {
                            Store (Zero, SSAE)
                        }
                        Store (GTF (Zero, Arg1), ATA2)
                        Store (GTF (One, Arg2), ATA3)
                    }
                    Device (DRV0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (RATA (ATA2))
                        }
                    }
                    Device (DRV1)
                    {
                        Name (_ADR, One)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (RATA (ATA3))
                        }
                    }
                }
                Method (GTM, 7, Serialized)
                {
                    Store (Ones, PIO0)
                    Store (Ones, PIO1)
                    Store (Ones, DMA0)
                    Store (Ones, DMA1)
                    Store (0x10, CHNF)
                    If (REGF) {}
                    Else
                    {
                        Return (TMD0)
                    }
                    If (And (Arg1, 0x20))
                    {
                        Or (CHNF, 0x02, CHNF)
                    }
                    Store (Match (DerefOf (Index (TIM0, One)), MEQ, Arg0, MTR, 
                        Zero, Zero), Local6)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, Zero)), Local6)), 
                        Local7)
                    Store (Local7, DMA0)
                    Store (Local7, PIO0)
                    If (And (Arg4, 0x20))
                    {
                        Or (CHNF, 0x08, CHNF)
                    }
                    Store (Match (DerefOf (Index (TIM0, 0x02)), MEQ, Arg3, MTR, 
                        Zero, Zero), Local6)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, Zero)), Local6)), 
                        Local7)
                    Store (Local7, DMA1)
                    Store (Local7, PIO1)
                    If (And (Arg1, 0x07))
                    {
                        Store (Arg2, Local5)
                        If (And (Arg1, 0x02))
                        {
                            Add (Local5, 0x02, Local5)
                        }
                        If (And (Arg1, 0x04))
                        {
                            Add (Local5, 0x04, Local5)
                        }
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x03)), Local5)), 
                            DMA0)
                        Or (CHNF, One, CHNF)
                    }
                    If (And (Arg4, 0x07))
                    {
                        Store (Arg5, Local5)
                        If (And (Arg4, 0x02))
                        {
                            Add (Local5, 0x02, Local5)
                        }
                        If (And (Arg4, 0x04))
                        {
                            Add (Local5, 0x04, Local5)
                        }
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x03)), Local5)), 
                            DMA1)
                        Or (CHNF, 0x04, CHNF)
                    }
                    Store (TMD0, Debug)
                    Return (TMD0)
                }
                Method (STM, 0, Serialized)
                {
                    If (REGF)
                    {
                        Store (Zero, GMUE)
                        Store (Zero, GMUT)
                        Store (Zero, GSUE)
                        Store (Zero, GSUT)
                        If (And (CHNF, One))
                        {
                            Store (Match (DerefOf (Index (TIM0, 0x03)), MLE, DMA0, MTR, 
                                Zero, Zero), Local0)
                            If (LGreater (Local0, 0x05))
                            {
                                Store (0x05, Local0)
                            }
                            Store (DerefOf (Index (DerefOf (Index (TIM0, 0x04)), Local0)), 
                                GMUT)
                            Or (GMUE, One, GMUE)
                            If (LGreater (Local0, 0x02))
                            {
                                Or (GMUE, 0x02, GMUE)
                            }
                            If (LGreater (Local0, 0x04))
                            {
                                And (GMUE, 0xFD, GMUE)
                                Or (GMUE, 0x04, GMUE)
                            }
                        }
                        Else
                        {
                            If (Or (LEqual (PIO0, Ones), LEqual (PIO0, Zero)))
                            {
                                If (And (LLess (DMA0, Ones), LGreater (DMA0, Zero)))
                                {
                                    Store (DMA0, PIO0)
                                    Or (GMUE, 0x80, GMUE)
                                }
                            }
                        }
                        If (And (CHNF, 0x04))
                        {
                            Store (Match (DerefOf (Index (TIM0, 0x03)), MLE, DMA1, MTR, 
                                Zero, Zero), Local0)
                            If (LGreater (Local0, 0x05))
                            {
                                Store (0x05, Local0)
                            }
                            Store (DerefOf (Index (DerefOf (Index (TIM0, 0x04)), Local0)), 
                                GSUT)
                            Or (GSUE, One, GSUE)
                            If (LGreater (Local0, 0x02))
                            {
                                Or (GSUE, 0x02, GSUE)
                            }
                            If (LGreater (Local0, 0x04))
                            {
                                And (GSUE, 0xFD, GSUE)
                                Or (GSUE, 0x04, GSUE)
                            }
                        }
                        Else
                        {
                            If (Or (LEqual (PIO1, Ones), LEqual (PIO1, Zero)))
                            {
                                If (And (LLess (DMA1, Ones), LGreater (DMA1, Zero)))
                                {
                                    Store (DMA1, PIO1)
                                    Or (GSUE, 0x80, GSUE)
                                }
                            }
                        }
                        If (And (CHNF, 0x02))
                        {
                            Or (GMUE, 0x20, GMUE)
                        }
                        If (And (CHNF, 0x08))
                        {
                            Or (GSUE, 0x20, GSUE)
                        }
                        And (Match (DerefOf (Index (TIM0, Zero)), MGE, PIO0, MTR, 
                            Zero, Zero), 0x07, Local0)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, One)), Local0)), 
                            Local1)
                        Store (Local1, GMPT)
                        If (LLess (Local0, 0x03))
                        {
                            Or (GMUE, 0x50, GMUE)
                        }
                        And (Match (DerefOf (Index (TIM0, Zero)), MGE, PIO1, MTR, 
                            Zero, Zero), 0x07, Local0)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x02)), Local0)), 
                            Local1)
                        Store (Local1, GSPT)
                        If (LLess (Local0, 0x03))
                        {
                            Or (GSUE, 0x50, GSUE)
                        }
                    }
                }
                Name (AT01, Buffer (0x07)
                {
                    0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0xEF
                })
                Name (AT02, Buffer (0x07)
                {
                    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90
                })
                Name (AT03, Buffer (0x07)
                {
                    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC6
                })
                Name (AT04, Buffer (0x07)
                {
                    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x91
                })
                Name (ATA0, Buffer (0x1D) {})
                Name (ATA1, Buffer (0x1D) {})
                Name (ATA2, Buffer (0x1D) {})
                Name (ATA3, Buffer (0x1D) {})
                Name (ATAB, Buffer (0x1D) {})
                CreateByteField (ATAB, Zero, CMDC)
                Method (GTFB, 3, Serialized)
                {
                    Multiply (CMDC, 0x38, Local0)
                    Add (Local0, 0x08, Local1)
                    CreateField (ATAB, Local1, 0x38, CMDX)
                    Multiply (CMDC, 0x07, Local0)
                    CreateByteField (ATAB, Add (Local0, 0x02), A001)
                    CreateByteField (ATAB, Add (Local0, 0x06), A005)
                    Store (Arg0, CMDX)
                    Store (Arg1, A001)
                    Store (Arg2, A005)
                    Increment (CMDC)
                }
                Method (GTF, 2, Serialized)
                {
                    Store (Arg1, Debug)
                    Store (Zero, CMDC)
                    Name (ID49, 0x0C00)
                    Name (ID59, Zero)
                    Name (ID53, 0x04)
                    Name (ID63, 0x0F00)
                    Name (ID88, 0x0F00)
                    Name (IRDY, One)
                    Name (PIOT, Zero)
                    Name (DMAT, Zero)
                    If (LEqual (SizeOf (Arg1), 0x0200))
                    {
                        CreateWordField (Arg1, 0x62, IW49)
                        Store (IW49, ID49)
                        CreateWordField (Arg1, 0x6A, IW53)
                        Store (IW53, ID53)
                        CreateWordField (Arg1, 0x7E, IW63)
                        Store (IW63, ID63)
                        CreateWordField (Arg1, 0x76, IW59)
                        Store (IW59, ID59)
                        CreateWordField (Arg1, 0xB0, IW88)
                        Store (IW88, ID88)
                    }
                    Store (0xA0, Local7)
                    If (Arg0)
                    {
                        Store (0xB0, Local7)
                        And (CHNF, 0x08, IRDY)
                        If (And (CHNF, 0x10))
                        {
                            Store (PIO1, PIOT)
                        }
                        Else
                        {
                            Store (PIO0, PIOT)
                        }
                        If (And (CHNF, 0x04))
                        {
                            If (And (CHNF, 0x10))
                            {
                                Store (DMA1, DMAT)
                            }
                            Else
                            {
                                Store (DMA0, DMAT)
                            }
                        }
                    }
                    Else
                    {
                        And (CHNF, 0x02, IRDY)
                        Store (PIO0, PIOT)
                        If (And (CHNF, One))
                        {
                            Store (DMA0, DMAT)
                        }
                    }
                    If (LAnd (LAnd (And (ID53, 0x04), And (ID88, 0xFF00
                        )), DMAT))
                    {
                        Store (Match (DerefOf (Index (TIM0, 0x03)), MLE, DMAT, MTR, 
                            Zero, Zero), Local1)
                        If (LGreater (Local1, 0x05))
                        {
                            Store (0x05, Local1)
                        }
                        GTFB (AT01, Or (0x40, Local1), Local7)
                    }
                    Else
                    {
                        If (LAnd (And (ID63, 0xFF00), PIOT))
                        {
                            And (Match (DerefOf (Index (TIM0, Zero)), MGE, PIOT, MTR, 
                                Zero, Zero), 0x03, Local0)
                            Or (0x20, DerefOf (Index (DerefOf (Index (TIM0, 0x07)), Local0
                                )), Local1)
                            GTFB (AT01, Local1, Local7)
                        }
                    }
                    If (IRDY)
                    {
                        And (Match (DerefOf (Index (TIM0, Zero)), MGE, PIOT, MTR, 
                            Zero, Zero), 0x07, Local0)
                        Or (0x08, DerefOf (Index (DerefOf (Index (TIM0, 0x06)), Local0
                            )), Local1)
                        GTFB (AT01, Local1, Local7)
                    }
                    Else
                    {
                        If (And (ID49, 0x0400))
                        {
                            GTFB (AT01, One, Local7)
                        }
                    }
                    If (LAnd (And (ID59, 0x0100), And (ID59, 0xFF)))
                    {
                        GTFB (AT03, And (ID59, 0xFF), Local7)
                    }
                    Store (ATAB, Debug)
                    Return (ATAB)
                }
                Method (RATA, 1, NotSerialized)
                {
                    CreateByteField (Arg0, Zero, CMDN)
                    Multiply (CMDN, 0x38, Local0)
                    CreateField (Arg0, 0x08, Local0, RETB)
                    Store (RETB, Debug)
                    Return (Concatenate (RETB, FZTF))
                }
            }
            Device (SAT1)
            {
                Name (_ADR, 0x001F0005)
                Name (REGF, One)
                Method (_REG, 2, NotSerialized)
                {
                    If (LEqual (Arg0, 0x02))
                    {
                        Store (Arg1, REGF)
                    }
                }
                Name (TIM0, Package (0x08)
                {
                    Package (0x04)
                    {
                        0x78, 
                        0xB4, 
                        0xF0, 
                        0x0384
                    }, 
                    Package (0x04)
                    {
                        0x23, 
                        0x21, 
                        0x10, 
                        Zero
                    }, 
                    Package (0x04)
                    {
                        0x0B, 
                        0x09, 
                        0x04, 
                        Zero
                    }, 
                    Package (0x06)
                    {
                        0x78, 
                        0x50, 
                        0x3C, 
                        0x28, 
                        0x1E, 
                        0x14
                    }, 
                    Package (0x06)
                    {
                        Zero, 
                        One, 
                        0x02, 
                        One, 
                        0x02, 
                        One
                    }, 
                    Package (0x06)
                    {
                        Zero, 
                        Zero, 
                        Zero, 
                        One, 
                        One, 
                        One
                    }, 
                    Package (0x04)
                    {
                        0x04, 
                        0x03, 
                        0x02, 
                        Zero
                    }, 
                    Package (0x04)
                    {
                        0x02, 
                        One, 
                        Zero, 
                        Zero
                    }
                })
                Name (TMD0, Buffer (0x14) {})
                CreateDWordField (TMD0, Zero, PIO0)
                CreateDWordField (TMD0, 0x04, DMA0)
                CreateDWordField (TMD0, 0x08, PIO1)
                CreateDWordField (TMD0, 0x0C, DMA1)
                CreateDWordField (TMD0, 0x10, CHNF)
                OperationRegion (CFG2, PCI_Config, 0x40, 0x20)
                Field (CFG2, DWordAcc, NoLock, Preserve)
                {
                    PMPT,   4, 
                    PSPT,   4, 
                    PMRI,   6, 
                            Offset (0x02), 
                    SMPT,   4, 
                    SSPT,   4, 
                    SMRI,   6, 
                            Offset (0x04), 
                    PSRI,   4, 
                    SSRI,   4, 
                            Offset (0x08), 
                    PM3E,   1, 
                    PS3E,   1, 
                    SM3E,   1, 
                    SS3E,   1, 
                            Offset (0x0A), 
                    PMUT,   2, 
                        ,   2, 
                    PSUT,   2, 
                            Offset (0x0B), 
                    SMUT,   2, 
                        ,   2, 
                    SSUT,   2, 
                            Offset (0x0C), 
                            Offset (0x14), 
                    PM6E,   1, 
                    PS6E,   1, 
                    SM6E,   1, 
                    SS6E,   1, 
                    PMCR,   1, 
                    PSCR,   1, 
                    SMCR,   1, 
                    SSCR,   1, 
                        ,   4, 
                    PMAE,   1, 
                    PSAE,   1, 
                    SMAE,   1, 
                    SSAE,   1
                }
                Name (GMPT, Zero)
                Name (GMUE, Zero)
                Name (GMUT, Zero)
                Name (GMCR, Zero)
                Name (GSPT, Zero)
                Name (GSUE, Zero)
                Name (GSUT, Zero)
                Name (GSCR, Zero)
                Device (CHN0)
                {
                    Name (_ADR, Zero)
                    Method (_GTM, 0, NotSerialized)
                    {
                        ShiftLeft (PSCR, One, Local1)
                        Or (PMCR, Local1, Local0)
                        ShiftLeft (PMAE, 0x02, Local3)
                        ShiftLeft (PM6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (PM3E, Local3, Local1)
                        ShiftLeft (PMPT, 0x04, Local3)
                        Or (Local1, Local3, Local1)
                        ShiftLeft (PSAE, 0x02, Local3)
                        ShiftLeft (PS6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (PS3E, Local3, Local2)
                        ShiftLeft (PSPT, 0x04, Local3)
                        Or (Local2, Local3, Local2)
                        Return (GTM (PMRI, Local1, PMUT, PSRI, Local2, PSUT, Local0))
                    }
                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, Debug)
                        Store (Arg0, TMD0)
                        ShiftLeft (PMAE, 0x02, Local3)
                        ShiftLeft (PM6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (PM3E, Local3, Local0)
                        ShiftLeft (PMPT, 0x04, Local3)
                        Or (Local0, Local3, Local0)
                        ShiftLeft (PSAE, 0x02, Local3)
                        ShiftLeft (PS6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (PS3E, Local3, Local1)
                        ShiftLeft (PSPT, 0x04, Local3)
                        Or (Local1, Local3, Local1)
                        Store (PMRI, GMPT)
                        Store (Local0, GMUE)
                        Store (PMUT, GMUT)
                        Store (PMCR, GMCR)
                        Store (PSRI, GSPT)
                        Store (Local1, GSUE)
                        Store (PSUT, GSUT)
                        Store (PSCR, GSCR)
                        STM ()
                        Store (GMPT, PMRI)
                        Store (GMUE, Local0)
                        Store (GMUT, PMUT)
                        Store (GMCR, PMCR)
                        Store (GSUE, Local1)
                        Store (GSUT, PSUT)
                        Store (GSCR, PSCR)
                        If (And (Local0, One))
                        {
                            Store (One, PM3E)
                        }
                        Else
                        {
                            Store (Zero, PM3E)
                        }
                        If (And (Local0, 0x02))
                        {
                            Store (One, PM6E)
                        }
                        Else
                        {
                            Store (Zero, PM6E)
                        }
                        If (And (Local0, 0x04))
                        {
                            Store (One, PMAE)
                        }
                        Else
                        {
                            Store (Zero, PMAE)
                        }
                        If (And (Local1, One))
                        {
                            Store (One, PS3E)
                        }
                        Else
                        {
                            Store (Zero, PS3E)
                        }
                        If (And (Local1, 0x02))
                        {
                            Store (One, PS6E)
                        }
                        Else
                        {
                            Store (Zero, PS6E)
                        }
                        If (And (Local1, 0x04))
                        {
                            Store (One, PSAE)
                        }
                        Else
                        {
                            Store (Zero, PSAE)
                        }
                        Store (GTF (Zero, Arg1), ATA0)
                        Store (GTF (One, Arg2), ATA1)
                    }
                    Device (DRV0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (RATA (ATA0))
                        }
                    }
                    Device (DRV1)
                    {
                        Name (_ADR, One)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (RATA (ATA1))
                        }
                    }
                }
                Device (CHN1)
                {
                    Name (_ADR, One)
                    Method (_GTM, 0, NotSerialized)
                    {
                        ShiftLeft (SSCR, One, Local1)
                        Or (SMCR, Local1, Local0)
                        ShiftLeft (SMAE, 0x02, Local3)
                        ShiftLeft (SM6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (SM3E, Local3, Local1)
                        ShiftLeft (SMPT, 0x04, Local3)
                        Or (Local1, Local3, Local1)
                        ShiftLeft (SSAE, 0x02, Local3)
                        ShiftLeft (SS6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (SS3E, Local3, Local2)
                        ShiftLeft (SSPT, 0x04, Local3)
                        Or (Local2, Local3, Local2)
                        Return (GTM (SMRI, Local1, SMUT, SSRI, Local2, SSUT, Local0))
                    }
                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, Debug)
                        Store (Arg0, TMD0)
                        ShiftLeft (SMAE, 0x02, Local3)
                        ShiftLeft (SM6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (SM3E, Local3, Local0)
                        ShiftLeft (SMPT, 0x04, Local3)
                        Or (Local0, Local3, Local0)
                        ShiftLeft (SSAE, 0x02, Local3)
                        ShiftLeft (SS6E, One, Local4)
                        Or (Local3, Local4, Local3)
                        Or (SS3E, Local3, Local1)
                        ShiftLeft (SSPT, 0x04, Local3)
                        Or (Local1, Local3, Local1)
                        Store (SMRI, GMPT)
                        Store (Local0, GMUE)
                        Store (SMUT, GMUT)
                        Store (SMCR, GMCR)
                        Store (SSRI, GSPT)
                        Store (Local1, GSUE)
                        Store (SSUT, GSUT)
                        Store (SSCR, GSCR)
                        STM ()
                        Store (GMPT, SMRI)
                        Store (GMUE, Local0)
                        Store (GMUT, SMUT)
                        Store (GMCR, SMCR)
                        Store (GSUE, Local1)
                        Store (GSUT, SSUT)
                        Store (GSCR, SSCR)
                        If (And (Local0, One))
                        {
                            Store (One, SM3E)
                        }
                        Else
                        {
                            Store (Zero, SM3E)
                        }
                        If (And (Local0, 0x02))
                        {
                            Store (One, SM6E)
                        }
                        Else
                        {
                            Store (Zero, SM6E)
                        }
                        If (And (Local0, 0x04))
                        {
                            Store (One, SMAE)
                        }
                        Else
                        {
                            Store (Zero, SMAE)
                        }
                        If (And (Local1, One))
                        {
                            Store (One, SS3E)
                        }
                        Else
                        {
                            Store (Zero, SS3E)
                        }
                        If (And (Local1, 0x02))
                        {
                            Store (One, SS6E)
                        }
                        Else
                        {
                            Store (Zero, SS6E)
                        }
                        If (And (Local1, 0x04))
                        {
                            Store (One, SSAE)
                        }
                        Else
                        {
                            Store (Zero, SSAE)
                        }
                        Store (GTF (Zero, Arg1), ATA2)
                        Store (GTF (One, Arg2), ATA3)
                    }
                    Device (DRV0)
                    {
                        Name (_ADR, Zero)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (RATA (ATA2))
                        }
                    }
                    Device (DRV1)
                    {
                        Name (_ADR, One)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (RATA (ATA3))
                        }
                    }
                }
                Method (GTM, 7, Serialized)
                {
                    Store (Ones, PIO0)
                    Store (Ones, PIO1)
                    Store (Ones, DMA0)
                    Store (Ones, DMA1)
                    Store (0x10, CHNF)
                    If (REGF) {}
                    Else
                    {
                        Return (TMD0)
                    }
                    If (And (Arg1, 0x20))
                    {
                        Or (CHNF, 0x02, CHNF)
                    }
                    Store (Match (DerefOf (Index (TIM0, One)), MEQ, Arg0, MTR, 
                        Zero, Zero), Local6)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, Zero)), Local6)), 
                        Local7)
                    Store (Local7, DMA0)
                    Store (Local7, PIO0)
                    If (And (Arg4, 0x20))
                    {
                        Or (CHNF, 0x08, CHNF)
                    }
                    Store (Match (DerefOf (Index (TIM0, 0x02)), MEQ, Arg3, MTR, 
                        Zero, Zero), Local6)
                    Store (DerefOf (Index (DerefOf (Index (TIM0, Zero)), Local6)), 
                        Local7)
                    Store (Local7, DMA1)
                    Store (Local7, PIO1)
                    If (And (Arg1, 0x07))
                    {
                        Store (Arg2, Local5)
                        If (And (Arg1, 0x02))
                        {
                            Add (Local5, 0x02, Local5)
                        }
                        If (And (Arg1, 0x04))
                        {
                            Add (Local5, 0x04, Local5)
                        }
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x03)), Local5)), 
                            DMA0)
                        Or (CHNF, One, CHNF)
                    }
                    If (And (Arg4, 0x07))
                    {
                        Store (Arg5, Local5)
                        If (And (Arg4, 0x02))
                        {
                            Add (Local5, 0x02, Local5)
                        }
                        If (And (Arg4, 0x04))
                        {
                            Add (Local5, 0x04, Local5)
                        }
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x03)), Local5)), 
                            DMA1)
                        Or (CHNF, 0x04, CHNF)
                    }
                    Store (TMD0, Debug)
                    Return (TMD0)
                }
                Method (STM, 0, Serialized)
                {
                    If (REGF)
                    {
                        Store (Zero, GMUE)
                        Store (Zero, GMUT)
                        Store (Zero, GSUE)
                        Store (Zero, GSUT)
                        If (And (CHNF, One))
                        {
                            Store (Match (DerefOf (Index (TIM0, 0x03)), MLE, DMA0, MTR, 
                                Zero, Zero), Local0)
                            If (LGreater (Local0, 0x05))
                            {
                                Store (0x05, Local0)
                            }
                            Store (DerefOf (Index (DerefOf (Index (TIM0, 0x04)), Local0)), 
                                GMUT)
                            Or (GMUE, One, GMUE)
                            If (LGreater (Local0, 0x02))
                            {
                                Or (GMUE, 0x02, GMUE)
                            }
                            If (LGreater (Local0, 0x04))
                            {
                                And (GMUE, 0xFD, GMUE)
                                Or (GMUE, 0x04, GMUE)
                            }
                        }
                        Else
                        {
                            If (Or (LEqual (PIO0, Ones), LEqual (PIO0, Zero)))
                            {
                                If (And (LLess (DMA0, Ones), LGreater (DMA0, Zero)))
                                {
                                    Store (DMA0, PIO0)
                                    Or (GMUE, 0x80, GMUE)
                                }
                            }
                        }
                        If (And (CHNF, 0x04))
                        {
                            Store (Match (DerefOf (Index (TIM0, 0x03)), MLE, DMA1, MTR, 
                                Zero, Zero), Local0)
                            If (LGreater (Local0, 0x05))
                            {
                                Store (0x05, Local0)
                            }
                            Store (DerefOf (Index (DerefOf (Index (TIM0, 0x04)), Local0)), 
                                GSUT)
                            Or (GSUE, One, GSUE)
                            If (LGreater (Local0, 0x02))
                            {
                                Or (GSUE, 0x02, GSUE)
                            }
                            If (LGreater (Local0, 0x04))
                            {
                                And (GSUE, 0xFD, GSUE)
                                Or (GSUE, 0x04, GSUE)
                            }
                        }
                        Else
                        {
                            If (Or (LEqual (PIO1, Ones), LEqual (PIO1, Zero)))
                            {
                                If (And (LLess (DMA1, Ones), LGreater (DMA1, Zero)))
                                {
                                    Store (DMA1, PIO1)
                                    Or (GSUE, 0x80, GSUE)
                                }
                            }
                        }
                        If (And (CHNF, 0x02))
                        {
                            Or (GMUE, 0x20, GMUE)
                        }
                        If (And (CHNF, 0x08))
                        {
                            Or (GSUE, 0x20, GSUE)
                        }
                        And (Match (DerefOf (Index (TIM0, Zero)), MGE, PIO0, MTR, 
                            Zero, Zero), 0x07, Local0)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, One)), Local0)), 
                            Local1)
                        Store (Local1, GMPT)
                        If (LLess (Local0, 0x03))
                        {
                            Or (GMUE, 0x50, GMUE)
                        }
                        And (Match (DerefOf (Index (TIM0, Zero)), MGE, PIO1, MTR, 
                            Zero, Zero), 0x07, Local0)
                        Store (DerefOf (Index (DerefOf (Index (TIM0, 0x02)), Local0)), 
                            Local1)
                        Store (Local1, GSPT)
                        If (LLess (Local0, 0x03))
                        {
                            Or (GSUE, 0x50, GSUE)
                        }
                    }
                }
                Name (AT01, Buffer (0x07)
                {
                    0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0xEF
                })
                Name (AT02, Buffer (0x07)
                {
                    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90
                })
                Name (AT03, Buffer (0x07)
                {
                    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC6
                })
                Name (AT04, Buffer (0x07)
                {
                    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x91
                })
                Name (ATA0, Buffer (0x1D) {})
                Name (ATA1, Buffer (0x1D) {})
                Name (ATA2, Buffer (0x1D) {})
                Name (ATA3, Buffer (0x1D) {})
                Name (ATAB, Buffer (0x1D) {})
                CreateByteField (ATAB, Zero, CMDC)
                Method (GTFB, 3, Serialized)
                {
                    Multiply (CMDC, 0x38, Local0)
                    Add (Local0, 0x08, Local1)
                    CreateField (ATAB, Local1, 0x38, CMDX)
                    Multiply (CMDC, 0x07, Local0)
                    CreateByteField (ATAB, Add (Local0, 0x02), A001)
                    CreateByteField (ATAB, Add (Local0, 0x06), A005)
                    Store (Arg0, CMDX)
                    Store (Arg1, A001)
                    Store (Arg2, A005)
                    Increment (CMDC)
                }
                Method (GTF, 2, Serialized)
                {
                    Store (Arg1, Debug)
                    Store (Zero, CMDC)
                    Name (ID49, 0x0C00)
                    Name (ID59, Zero)
                    Name (ID53, 0x04)
                    Name (ID63, 0x0F00)
                    Name (ID88, 0x0F00)
                    Name (IRDY, One)
                    Name (PIOT, Zero)
                    Name (DMAT, Zero)
                    If (LEqual (SizeOf (Arg1), 0x0200))
                    {
                        CreateWordField (Arg1, 0x62, IW49)
                        Store (IW49, ID49)
                        CreateWordField (Arg1, 0x6A, IW53)
                        Store (IW53, ID53)
                        CreateWordField (Arg1, 0x7E, IW63)
                        Store (IW63, ID63)
                        CreateWordField (Arg1, 0x76, IW59)
                        Store (IW59, ID59)
                        CreateWordField (Arg1, 0xB0, IW88)
                        Store (IW88, ID88)
                    }
                    Store (0xA0, Local7)
                    If (Arg0)
                    {
                        Store (0xB0, Local7)
                        And (CHNF, 0x08, IRDY)
                        If (And (CHNF, 0x10))
                        {
                            Store (PIO1, PIOT)
                        }
                        Else
                        {
                            Store (PIO0, PIOT)
                        }
                        If (And (CHNF, 0x04))
                        {
                            If (And (CHNF, 0x10))
                            {
                                Store (DMA1, DMAT)
                            }
                            Else
                            {
                                Store (DMA0, DMAT)
                            }
                        }
                    }
                    Else
                    {
                        And (CHNF, 0x02, IRDY)
                        Store (PIO0, PIOT)
                        If (And (CHNF, One))
                        {
                            Store (DMA0, DMAT)
                        }
                    }
                    If (LAnd (LAnd (And (ID53, 0x04), And (ID88, 0xFF00
                        )), DMAT))
                    {
                        Store (Match (DerefOf (Index (TIM0, 0x03)), MLE, DMAT, MTR, 
                            Zero, Zero), Local1)
                        If (LGreater (Local1, 0x05))
                        {
                            Store (0x05, Local1)
                        }
                        GTFB (AT01, Or (0x40, Local1), Local7)
                    }
                    Else
                    {
                        If (LAnd (And (ID63, 0xFF00), PIOT))
                        {
                            And (Match (DerefOf (Index (TIM0, Zero)), MGE, PIOT, MTR, 
                                Zero, Zero), 0x03, Local0)
                            Or (0x20, DerefOf (Index (DerefOf (Index (TIM0, 0x07)), Local0
                                )), Local1)
                            GTFB (AT01, Local1, Local7)
                        }
                    }
                    If (IRDY)
                    {
                        And (Match (DerefOf (Index (TIM0, Zero)), MGE, PIOT, MTR, 
                            Zero, Zero), 0x07, Local0)
                        Or (0x08, DerefOf (Index (DerefOf (Index (TIM0, 0x06)), Local0
                            )), Local1)
                        GTFB (AT01, Local1, Local7)
                    }
                    Else
                    {
                        If (And (ID49, 0x0400))
                        {
                            GTFB (AT01, One, Local7)
                        }
                    }
                    If (LAnd (And (ID59, 0x0100), And (ID59, 0xFF)))
                    {
                        GTFB (AT03, And (ID59, 0xFF), Local7)
                    }
                    Store (ATAB, Debug)
                    Return (ATAB)
                }
                Method (RATA, 1, NotSerialized)
                {
                    CreateByteField (Arg0, Zero, CMDN)
                    Multiply (CMDN, 0x38, Local0)
                    CreateField (Arg0, 0x08, Local0, RETB)
                    Store (RETB, Debug)
                    Return (Concatenate (RETB, FZTF))
                }
            }
            Device (BR21)
            {
                Name (_ADR, 0x001C0001)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR21)
                    }
                    Return (PR21)
                }
            }
            Device (BR22)
            {
                Name (_ADR, 0x001C0002)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR22)
                    }
                    Return (PR22)
                }
            }
            Device (BR23)
            {
                Name (_ADR, 0x001C0003)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (GPRW (0x09, 0x04))
                }
                Method (_PRT, 0, NotSerialized)
                {
                    If (PICM)
                    {
                        Return (AR23)
                    }
                    Return (PR23)
                }
            }
        }
        Scope (\_GPE)
        {
            Method (_L09, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.P0P4, 0x02)
                Notify (\_SB.PCI0.P0P1, 0x02)
                Notify (\_SB.PCI0.P0P3, 0x02)
                Notify (\_SB.PCI0.P0P5, 0x02)
                Notify (\_SB.PCI0.P0P6, 0x02)
                Notify (\_SB.PCI0.BR20, 0x02)
                Notify (\_SB.PCI0.BR24, 0x02)
                Notify (\_SB.PCI0.BR25, 0x02)
                Notify (\_SB.PCI0.BR26, 0x02)
                Notify (\_SB.PCI0.BR27, 0x02)
                Notify (\_SB.PCI0.BR21, 0x02)
                Notify (\_SB.PCI0.BR22, 0x02)
                Notify (\_SB.PCI0.BR23, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L0B, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.BR1E, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L08, 0, NotSerialized)
            {
                \_SB.PCI0.SBRG.SIOH ()
            }
            Method (_L1B, 0, NotSerialized)
            {
                \_SB.PCI0.SBRG.SIOH ()
            }
            Method (_L1C, 0, NotSerialized)
            {
                \_SB.PCI0.SBRG.SIOH ()
            }
            Method (_L0D, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.EHCI, 0x02)
                Notify (\_SB.PCI0.UCHI, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L03, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.UHC1, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L04, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.UHC2, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L0C, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.UHC3, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L0E, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.UHC4, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L05, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.UHC5, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L20, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.UHC6, 0x02)
                Notify (\_SB.PCI0.USB8, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
            Method (_L25, 0, NotSerialized)
            {
                Notify (\_SB.PCI0.UHC7, 0x02)
                Notify (\_SB.PWRB, 0x02)
            }
        }
        Device (PWRB)
        {
            Name (_CID, EisaId ("PNP0C0C"))
            Name (_UID, 0xAA)
            Name (_STA, 0x0B)
        }
    }
    Scope (\)
    {
        Field (RAMW, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x38), 
            EPPF,   32
        }
    }
    Scope (_SB.PCI0.SBRG.ASOC)
    {
        Name (G0T3, Package (0x07)
        {
            0x00070005, 
            "New CPU Installed", 
            One, 
            Zero, 
            Zero, 
            One, 
            0x02
        })
        Name (G0T8, Package (0x07)
        {
            0x00060008, 
            "Item capability", 
            0x40000000, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (G0T9, Package (0x07)
        {
            0x00060009, 
            "Item control", 
            0x40000000, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (G0TB, Package (0x07)
        {
            0x0006000B, 
            "System boot mode", 
            One, 
            Zero, 
            Zero, 
            One, 
            0x02
        })
        Name (GRP0, Package (0x04)
        {
            G0T3, 
            G0T8, 
            G0T9, 
            G0TB
        })
        Method (GIT0, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, 0x05))
            {
                Store (GNVS (0x170A), ASB1)
            }
            Else
            {
                If (LEqual (T_0, 0x08))
                {
                    Store (Zero, Local0)
                    If (LEqual (EPPF, One))
                    {
                        Or (Local0, 0x08, Local0)
                    }
                    Store (Local0, ASB1)
                }
                Else
                {
                    If (LEqual (T_0, 0x09))
                    {
                        Store (Zero, Local0)
                        If (LEqual (GNVS (0x343D), 0x05))
                        {
                            Or (Local0, 0x08, Local0)
                        }
                        Store (Local0, ASB1)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x0B))
                        {
                            Store (GNVS (0x16E7), ASB1)
                        }
                        Else
                        {
                            Store (Zero, ASB0)
                        }
                    }
                }
            }
        }
        Method (SIT0, 3, NotSerialized)
        {
            If (And (Arg2, 0xFFFF))
            {
                Name (T_0, Zero)
                Store (And (Arg0, 0xFFFF), T_0)
                If (LEqual (T_0, 0x05))
                {
                    SNVS (0x170A, Arg1)
                    Store (0x03, ASB0)
                }
                Else
                {
                    Store (Zero, ASB0)
                }
            }
            Else
            {
                Store (0x03, ASB0)
            }
        }
        Method (GCPR, 0, NotSerialized)
        {
            Store (GNVS (0x8290), Local0)
            If (Local0)
            {
                Return (ShiftRight (Local0, One))
            }
            Else
            {
                Return (And (ShiftRight (GMAX (0xCE), 0x08), 0xFF))
            }
        }
        Method (GPRE, 1, Serialized)
        {
            Store (Arg0, PAR0)
            ISMI (0x7F)
            Return (PAR0)
        }
        Method (UCPS, 1, NotSerialized)
        {
            If (LAnd (LOr (LGreaterEqual (Arg0, 0x89), LLessEqual (Arg0, 
                0x81)), LNot (And (CB30, 0x08))))
            {
                Or (CB30, 0x08, CB30)
            }
            If (LAnd (LAnd (LLess (Arg0, 0x89), LGreater (Arg0, 0x81)), And (
                CB30, 0x08)))
            {
                And (CB30, 0xF7, CB30)
            }
        }
    }
    Scope (\)
    {
        Field (RAMW, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x24), 
            ECGP,   32
        }
        Field (RAMW, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x28), 
            DMFQ,   32
        }
        Field (RAMW, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x2C), 
            VIDI,   32
        }
        Field (RAMW, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x3C), 
            D4CR,   32
        }
    }
    Scope (_SB.PCI0.SBRG.ASOC)
    {
        Name (G3U0, Package (0x09)
        {
            0x03860000, 
            "Uncore Clock Ratio", 
            Zero, 
            Zero, 
            0x0C, 
            One, 
            0x1F, 
            One, 
            "Auto"
        })
        Name (G3Q0, Package (0x09)
        {
            0x03080001, 
            "QPI Frequency", 
            0x40000000, 
            Zero, 
            0x04, 
            "Auto", 
            "4.800GT", 
            "5.866GT", 
            "6.400GT"
        })
        Name (G3C0, Package (0x07)
        {
            0x03010011, 
            "BCLK Frequency", 
            Zero, 
            0x35, 
            Ones, 
            0x64, 
            0x01A5
        })
        Name (G3C1, Package (0x07)
        {
            0x03020012, 
            "CPU Voltage", 
            Zero, 
            Zero, 
            0xFE014C08, 
            0x0271, 
            0x89
        })
        Name (G3C2, Package (0x07)
        {
            0x03060013, 
            "CPU Ratio", 
            0x40000000, 
            Zero, 
            Zero, 
            One, 
            0x1C
        })
        Name (G3C5, Package (0x07)
        {
            0x030600F9, 
            "CPU rated ratio", 
            0x40000000, 
            Zero, 
            Zero, 
            One, 
            0x1C
        })
        Name (G3C3, Package (0x07)
        {
            0x03020015, 
            "IMC Voltage", 
            Zero, 
            Zero, 
            0x044C, 
            0x14, 
            0x29
        })
        Name (G3D1, Package (0x0B)
        {
            0x03080031, 
            "DRAM Frequency", 
            0x40000000, 
            Zero, 
            0x06, 
            "Auto", 
            "800 MHz", 
            "1066 MHz", 
            "1333 MHz", 
            "1600 MHz", 
            "1866 MHz"
        })
        Name (G3C4, Package (0x07)
        {
            0x03020016, 
            "CPU PLL", 
            Zero, 
            Zero, 
            0x0708, 
            0x14, 
            0x15
        })
        Name (G3SF, Package (0x07)
        {
            0x03010017, 
            "CPU Safeboot Frequency", 
            0x40000000, 
            Zero, 
            Zero, 
            One, 
            0x0100
        })
        Name (G3D2, Package (0x07)
        {
            0x03020032, 
            "DRAM Bus Voltage", 
            Zero, 
            Zero, 
            0x04B0, 
            0x14, 
            0x33
        })
        Name (G3S0, Package (0x07)
        {
            0x030200B1, 
            "PCH", 
            0x40000000, 
            Zero, 
            0xFF002904, 
            0x7D, 
            0x4D
        })
        Name (G3DS, Package (0x07)
        {
            0x030600F0, 
            "Device Select", 
            0x40000000, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (G3PS, Package (0x07)
        {
            0x030600F2, 
            "Pad Scan", 
            0x40000000, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (G3D4, Package (0x07)
        {
            0x030C0034, 
            "CHA DATA", 
            Zero, 
            0x15, 
            0x018B, 
            0x05, 
            0x30
        })
        Name (G3D6, Package (0x07)
        {
            0x030C0036, 
            "CHB DATA", 
            Zero, 
            0x15, 
            0x018B, 
            0x05, 
            0x30
        })
        Name (GRP3, Package (0x0E)
        {
            G3C0, 
            G3C1, 
            G3C2, 
            G3C5, 
            G3C3, 
            G3C4, 
            G3D2, 
            G3S0, 
            G3DS, 
            G3PS, 
            G3D1, 
            G3D4, 
            G3D6, 
            G3SF
        })
        Name (GODS, Zero)
        Name (TBRT, Buffer (0x08)
        {
            /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        })
        Name (TBMK, Buffer (0x08)
        {
            /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        })
        Name (ITAD, 0x37)
        Name (DVMS, Zero)
        Name (CVIO, Zero)
        Name (ATFG, Zero)
        Name (VCBI, Zero)
        Name (PSFG, Zero)
        Name (PSCL, 0x163D)
        Name (PCRS, Buffer (0x03)
        {
            0xFF, 0x00, 0x00
        })
        Name (DMCS, Buffer (0x02)
        {
            0x00, 0x00
        })
        Name (DMRS, Package (0x02)
        {
            Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                Zero
            }, 
            Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                Zero
            }
        })
        Name (PSWI, Package (0x04)
        {
            Package (0x04)
            {
                0x14A2, 
                0x024F, 
                0x05E3, 
                0x0B
            }, 
            Package (0x04)
            {
                0x1464, 
                0x024F, 
                0x05E3, 
                0x0B
            }, 
            Package (0x04)
            {
                0x13D9, 
                0x024F, 
                0x05E3, 
                0x0B
            }, 
            Package (0x04)
            {
                0x0A40, 
                0x0A49, 
                0x0A52, 
                0x0A5B
            }
        })
        Name (BPS0, Package (0x04)
        {
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                Zero
            }
        })
        Name (BPS1, Package (0x04)
        {
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                Zero
            }
        })
        Name (CPS0, Package (0x04)
        {
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                Zero
            }
        })
        Name (CPS1, Package (0x04)
        {
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }, 
                Package (0x08)
                {
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                }
            }, 
            Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                Zero
            }
        })
        Name (CHRF, Buffer (0x06)
        {
            0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
        })
        Method (GIT3, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, Zero))
            {
                Store (GNVS (0x53A8), ASB1)
            }
            Else
            {
                If (LEqual (T_0, One)) {}
                Else
                {
                    If (LEqual (T_0, 0x11))
                    {
                        If (LEqual (RBCK, Zero))
                        {
                            Subtract (GNVS (0xA6D8), 0x50, RBCK)
                        }
                        Store (RBCK, ASB1)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x12))
                        {
                            Store (GCVV (), ASB1)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x13))
                            {
                                If (And (ShiftRight (GMAX (0xCE), 0x1C), One))
                                {
                                    If (LNotEqual (GODS, 0xFF))
                                    {
                                        If (LLess (GODS, 0x04))
                                        {
                                            Store (GMAX (0x01AD), Local1)
                                        }
                                        Else
                                        {
                                            Store (GMDX (0x01AD), Local1)
                                            Subtract (GODS, 0x04, GODS)
                                        }
                                        ShiftLeft (GODS, 0x03, Local5)
                                        ShiftRight (Local1, Local5, Local0)
                                        Subtract (And (Local0, 0xFF), DerefOf (Index (G3C2, 0x04)), 
                                            Local0)
                                        Store (Local0, ASB1)
                                    }
                                }
                                Else
                                {
                                    Store (GCPR (), ASB1)
                                }
                            }
                            Else
                            {
                                If (LEqual (T_0, 0xF9))
                                {
                                    Store (GCPR (), ASB1)
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x15))
                                    {
                                        Store (GVCV (), ASB1)
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x16))
                                        {
                                            Store (GCPV (), ASB1)
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x31))
                                            {
                                                Store (DMFQ, ASB1)
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x32))
                                                {
                                                    Store (GDRV (), ASB1)
                                                }
                                                Else
                                                {
                                                    If (LEqual (T_0, 0x34))
                                                    {
                                                        Store (VDAD, ASB1)
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (T_0, 0x36))
                                                        {
                                                            Store (VDBD, ASB1)
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (T_0, 0xB1))
                                                            {
                                                                Store (GSCV (), ASB1)
                                                            }
                                                            Else
                                                            {
                                                                If (LEqual (T_0, 0xF0)) {}
                                                                Else
                                                                {
                                                                    Store (Zero, ASB0)
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        Method (SIT3, 3, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, Zero))
            {
                If (LNotEqual (GNVS (0x53A8), Arg1))
                {
                    If (And (Arg2, One))
                    {
                        SNVS (0x53A8, Arg1)
                    }
                    Or (ASB0, 0x02, ASB0)
                }
            }
            Else
            {
                If (LEqual (T_0, One))
                {
                    If (And (Arg2, One)) {}
                    Or (ASB0, 0x02, ASB0)
                }
                Else
                {
                    If (LEqual (T_0, 0x11))
                    {
                        If (And (Arg2, One))
                        {
                            SNVS (0xA6D8, Add (Arg1, 0x50))
                            If (LEqual (GNVS (0x343D), One))
                            {
                                SNVS (0x343D, Zero)
                            }
                        }
                        If (And (Arg2, 0x02))
                        {
                            WBCK (Arg1)
                            SNVS (0x170A, One)
                        }
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x12))
                        {
                            If (And (Arg2, 0x02))
                            {
                                SCVV (Arg1)
                            }
                            If (And (Arg2, One))
                            {
                                WCVV (Arg1)
                            }
                            If (ATFG)
                            {
                                Store (Zero, ATFG)
                            }
                            Else
                            {
                                Store (Arg1, VCBI)
                            }
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x13))
                            {
                                If (And (ShiftRight (GMAX (0xCE), 0x1C), One))
                                {
                                    If (And (Arg2, 0x03))
                                    {
                                        If (And (GMDX (0x0199), One))
                                        {
                                            Store (0x99, DBG8)
                                        }
                                        Else
                                        {
                                            If (LNotEqual (GODS, 0xFF))
                                            {
                                                Store (GNVS (0x82A0), Local0)
                                                Add (Local0, Arg1, Local0)
                                                Store (Local0, Index (TBRT, GODS))
                                                Store (0xFF, Index (TBMK, GODS))
                                            }
                                            Else
                                            {
                                                CreateDWordField (TBRT, Zero, TRAX)
                                                CreateDWordField (TBRT, 0x04, TRDX)
                                                CreateDWordField (TBMK, Zero, TRMA)
                                                CreateDWordField (TBMK, 0x04, TRMD)
                                                Store (GMAX (0x01AD), Local1)
                                                Store (GMDX (0x01AD), Local2)
                                                Or (And (Local1, Not (TRMA)), TRAX, Local1)
                                                Or (And (Local2, Not (TRMD)), TRDX, Local2)
                                                SMSR (0x01AD, Local1, Local2)
                                                Store (Zero, Local0)
                                                While (LLess (Local0, 0x08))
                                                {
                                                    Store (Zero, Index (TBRT, Local0))
                                                    Store (Zero, Index (TBMK, Local0))
                                                    Increment (Local0)
                                                }
                                                If (LLessEqual (GNVS (0x82A0), And (GMAX (0x0199), 0xFF)))
                                                {
                                                    Store (GMDX (0x01A0), Local3)
                                                    And (Local3, 0xFFFFFFBF, Local3)
                                                    SMSR (0x01A0, GMAX (0x01A0), Local3)
                                                    Add (GNVS (0x82A0), One, Local2)
                                                    Store (GMAX (0x0199), Local3)
                                                    Or (And (Local3, 0xFFFFFF00), Local2, Local2)
                                                    SMSR (0x0199, Local2, GMDX (0x0199))
                                                }
                                            }
                                        }
                                    }
                                    If (And (Arg2, One))
                                    {
                                        SNVS (0x8290, ShiftLeft (Arg1, One))
                                    }
                                }
                                Else
                                {
                                    If (And (Arg2, One))
                                    {
                                        SNVS (0x8290, ShiftLeft (Arg1, One))
                                    }
                                }
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x15))
                                {
                                    If (And (Arg2, 0x02))
                                    {
                                        SVCV (Arg1)
                                    }
                                    If (And (Arg2, One))
                                    {
                                        SNVS (0x5490, Increment (Arg1))
                                    }
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x16))
                                    {
                                        If (And (Arg2, 0x02))
                                        {
                                            SCPV (Arg1)
                                        }
                                        If (And (Arg2, One))
                                        {
                                            SNVS (0x6378, Increment (Arg1))
                                        }
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x31))
                                        {
                                            If (And (Arg2, One))
                                            {
                                                SNVS (0x457C, Arg1)
                                                SNVS (0x4580, Arg1)
                                                Or (ASB0, 0x02, ASB0)
                                            }
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x32))
                                            {
                                                If (And (Arg2, 0x02))
                                                {
                                                    SDRV (Arg1)
                                                }
                                                If (And (Arg2, One))
                                                {
                                                    SNVS (0x6368, Increment (Arg1))
                                                }
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x34))
                                                {
                                                    If (And (Arg2, 0x02))
                                                    {
                                                        WDPS (Zero, Arg1)
                                                        Store (Arg1, VDAD)
                                                    }
                                                    If (And (Arg2, One))
                                                    {
                                                        SNVS (0x7340, Increment (Arg1))
                                                    }
                                                }
                                                Else
                                                {
                                                    If (LEqual (T_0, 0x36))
                                                    {
                                                        If (And (Arg2, 0x02))
                                                        {
                                                            WDPS (One, Arg1)
                                                            Store (Arg1, VDBD)
                                                        }
                                                        If (And (Arg2, One))
                                                        {
                                                            SNVS (0x7348, Increment (Arg1))
                                                        }
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (T_0, 0xB1))
                                                        {
                                                            If (And (Arg2, 0x02))
                                                            {
                                                                SSCV (Arg1)
                                                            }
                                                            If (And (Arg2, One))
                                                            {
                                                                SNVS (0x5488, Increment (Arg1))
                                                            }
                                                        }
                                                        Else
                                                        {
                                                            If (LEqual (T_0, 0xF0))
                                                            {
                                                                Store (Arg1, GODS)
                                                            }
                                                            Else
                                                            {
                                                                If (LEqual (T_0, 0xF2))
                                                                {
                                                                    GCPS ()
                                                                    If (And (Arg1, 0xFF))
                                                                    {
                                                                        If (DerefOf (Index (DMCS, And (Arg1, 0xFF))))
                                                                        {
                                                                            If (SPSL (And (Arg1, 0xFF), And (ShiftRight (Arg1, 0x10
                                                                                ), 0xFFFF)))
                                                                            {
                                                                                Store (DerefOf (Index (PCRS, Zero)), Local0)
                                                                                Store (DerefOf (Index (PCRS, One)), Local1)
                                                                                Store (DerefOf (Index (PCRS, 0x02)), Local2)
                                                                                Add (And (ShiftRight (Arg2, 0x10), 0xFFFF), DerefOf (Index (
                                                                                    DerefOf (Index (DerefOf (Index (BPS1, Local0)), Local1)), Local2)), 
                                                                                    Local3)
                                                                                If (LNotEqual (Local3, DerefOf (Index (DerefOf (Index (DerefOf (Index (
                                                                                    CPS1, Local0)), Local1)), Local2))))
                                                                                {
                                                                                    SPSV (And (Arg1, 0xFF), And (ShiftRight (Arg1, 0x10), 
                                                                                        0xFFFF), And (Arg2, 0xFF), Local3)
                                                                                    Store (Local3, Index (DerefOf (Index (DerefOf (Index (CPS0, Local0)), 
                                                                                        Local1)), Local2))
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                    Else
                                                                    {
                                                                        If (DerefOf (Index (DMCS, And (Arg1, 0xFF))))
                                                                        {
                                                                            If (SPSL (And (Arg1, 0xFF), And (ShiftRight (Arg1, 0x10
                                                                                ), 0xFFFF)))
                                                                            {
                                                                                Store (DerefOf (Index (PCRS, Zero)), Local0)
                                                                                Store (DerefOf (Index (PCRS, One)), Local1)
                                                                                Store (DerefOf (Index (PCRS, 0x02)), Local2)
                                                                                Add (And (ShiftRight (Arg2, 0x10), 0xFFFF), DerefOf (Index (
                                                                                    DerefOf (Index (DerefOf (Index (BPS0, Local0)), Local1)), Local2)), 
                                                                                    Local3)
                                                                                If (LNotEqual (Local3, DerefOf (Index (DerefOf (Index (DerefOf (Index (
                                                                                    CPS0, Local0)), Local1)), Local2))))
                                                                                {
                                                                                    SPSV (And (Arg1, 0xFF), And (ShiftRight (Arg1, 0x10), 
                                                                                        0xFFFF), And (Arg2, 0xFF), Local3)
                                                                                    Store (Local3, Index (DerefOf (Index (DerefOf (Index (CPS0, Local0)), 
                                                                                        Local1)), Local2))
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                                Else
                                                                {
                                                                    Store (Zero, ASB0)
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        Method (GTMN, 1, NotSerialized)
        {
            Add (Arg0, 0x50, Local3)
            If (LGreaterEqual (Local3, 0x012D))
            {
                Store (DerefOf (Index (DerefOf (Index (MNTD, One)), One)), 
                    Local0)
                Store (DerefOf (Index (DerefOf (Index (MNTD, One)), 0x02)), 
                    Local1)
                If (LAnd (LLessEqual (Local3, Local1), LGreaterEqual (Local3, Local0)))
                {
                    Store (DerefOf (Index (DerefOf (Index (MN31, Subtract (Local3, Local0)
                        )), Zero)), TGTM)
                    Store (DerefOf (Index (DerefOf (Index (MN31, Subtract (Local3, Local0)
                        )), One)), TGTN)
                }
                Else
                {
                    If (LLess (Local3, Local0))
                    {
                        Store (DerefOf (Index (DerefOf (Index (MN31, Zero)), Zero)), 
                            TGTM)
                        Store (DerefOf (Index (DerefOf (Index (MN31, Zero)), One)), 
                            TGTN)
                    }
                    Else
                    {
                        Store (DerefOf (Index (DerefOf (Index (MN31, Subtract (Local1, Local0)
                            )), Zero)), TGTM)
                        Store (DerefOf (Index (DerefOf (Index (MN31, Subtract (Local1, Local0)
                            )), One)), TGTN)
                    }
                }
            }
            Else
            {
                Store (DerefOf (Index (DerefOf (Index (MNTD, Zero)), One)), 
                    Local0)
                Store (DerefOf (Index (DerefOf (Index (MNTD, Zero)), 0x02)), 
                    Local1)
                If (LAnd (LLessEqual (Local3, Local1), LGreaterEqual (Local3, Local0)))
                {
                    Store (DerefOf (Index (DerefOf (Index (MND3, Subtract (Local3, Local0)
                        )), Zero)), TGTM)
                    Store (DerefOf (Index (DerefOf (Index (MND3, Subtract (Local3, Local0)
                        )), One)), TGTN)
                }
                Else
                {
                    If (LLess (Local3, Local0))
                    {
                        Store (DerefOf (Index (DerefOf (Index (MND3, Zero)), Zero)), 
                            TGTM)
                        Store (DerefOf (Index (DerefOf (Index (MND3, Zero)), One)), 
                            TGTN)
                    }
                    Else
                    {
                        Store (DerefOf (Index (DerefOf (Index (MND3, Subtract (Local1, Local0)
                            )), Zero)), TGTM)
                        Store (DerefOf (Index (DerefOf (Index (MND3, Subtract (Local1, Local0)
                            )), One)), TGTN)
                    }
                }
            }
        }
        Method (MDMN, 1, NotSerialized)
        {
            And (TGTM, 0x3F, Local0)
            Multiply (Add (RBCK, 0x50), And (CDIV, 0xFF), Local1)
            Multiply (Local1, Local0, Local2)
            ShiftRight (Local2, 0x05, Local2)
            Or (Local2, One, Local2)
            And (TGTM, 0x3F, Local4)
            Divide (ShiftLeft (Or (Add (ShiftLeft (CB12, 0x03), ShiftRight (And (
                CB11, 0xC0), 0x05)), One), 0x06), And (
                CB11, 0x3F), Local0, Local5)
            Divide (ShiftLeft (Local2, 0x06), Local4, Local0, Local6)
            While (LAnd (LGreater (Arg0, RBCK), LLess (Local6, Local5)))
            {
                Increment (Local2)
                Increment (Local2)
                Divide (ShiftLeft (Local2, 0x06), Local4, Local0, Local6)
            }
            While (LAnd (LLess (Arg0, RBCK), LGreater (Local6, Local5)))
            {
                Decrement (Local2)
                Decrement (Local2)
                Divide (ShiftLeft (Local2, 0x06), Local4, Local0, Local6)
            }
            Or (Local4, ShiftLeft (And (Local2, 0x06), 0x05), CB11)
            Store (ShiftRight (Local2, 0x03), CB12)
            Store (And (CB00, 0xDF), CB00)
            Store (Or (CB01, 0x10), CB01)
            WBLK (0xD2, Zero, 0x1F, CLKB)
        }
        Method (FLMN, 1, NotSerialized)
        {
            Store (And (CB00, 0xDF), CB00)
            Store (Or (CB01, 0x10), CB01)
            Store (TGTM, CB11)
            Store (TGTN, CB12)
            UCPS (Add (Arg0, 0x50))
            WBLK (0xD2, Zero, 0x1F, CLKB)
        }
        Method (WBCK, 1, NotSerialized)
        {
            Store (RBLK (0xD2, Zero, 0x1F), CLKB)
            Store (DerefOf (Index (CDTB, And (CB29, 0x0F))), CDIV)
            GTMN (Arg0)
            MDMN (Arg0)
            FLMN (Arg0)
            Store (Arg0, RBCK)
        }
        Method (GCVV, 0, NotSerialized)
        {
            Return (And (0x7FFFFFFF, RVCR))
        }
        Method (DOJP, 1, NotSerialized)
        {
            Store (Arg0, Local0)
            If (LGreater (Local0, 0x78))
            {
                Subtract (Local0, 0x10, Local0)
                SSGP (0x5C, Zero)
            }
            Else
            {
                SSGP (0x5C, One)
            }
            ENFG (0x0D)
            Return (Local0)
        }
        Method (SCVV, 1, NotSerialized)
        {
            Store (Or (Arg0, 0x80000000), RVCR)
            ENFG (0x0D)
            Store (And (CRE4, 0xC0), Local0)
            If (LEqual (Local0, Zero))
            {
                If (LEqual (GNVS (0x16CA), Zero))
                {
                    Store (DOJP (Arg0), Local0)
                    Subtract (Local0, DerefOf (Index (G3C1, 0x03)), CRE1)
                    Or (0x40, CRE4, CRE4)
                }
                Else
                {
                    Store (DOJP (Arg0), Local0)
                    Subtract (0x7A, Local0, CRE0)
                    Or (0x80, CRE4, CRE4)
                }
            }
            Else
            {
                If (LEqual (Local0, 0x40))
                {
                    Store (DOJP (Arg0), Local0)
                    Subtract (Local0, DerefOf (Index (G3C1, 0x03)), CRE1)
                }
                Else
                {
                    If (LEqual (Local0, 0x80))
                    {
                        Store (DOJP (Arg0), Local0)
                        Subtract (0x7A, Local0, CRE0)
                    }
                }
            }
            EXFG ()
            Return (One)
        }
        Method (WCVV, 1, NotSerialized)
        {
            If (LEqual (GNVS (0x16CA), Zero))
            {
                Subtract (Arg0, VIDI, Local0)
                If (LGreater (VIDI, Arg0))
                {
                    SNVS (0x16CB, One)
                    Add (Not (Local0), One, Local0)
                    And (Local0, 0xFF, Local0)
                    SNVS (0x8318, Local0)
                }
                Else
                {
                    SNVS (0x16CB, Zero)
                    SNVS (0x8318, Local0)
                }
            }
            Else
            {
                SNVS (0x8310, Increment (Arg0))
            }
        }
        Method (GSGP, 1, NotSerialized)
        {
            Divide (Arg0, 0x0A, Local0, Local1)
            Name (T_0, Zero)
            Store (Local1, T_0)
            If (LEqual (T_0, 0x04))
            {
                ENFG (0x09)
                And (ShiftRight (OPT0, Local0), One, Local0)
            }
            Else
            {
                If (LEqual (T_0, 0x08))
                {
                    ENFG (0x07)
                    And (ShiftRight (CRE4, Local0), One, Local0)
                }
                Else
                {
                    If (LEqual (T_0, 0x09))
                    {
                        ENFG (0x07)
                        And (ShiftRight (CRE8, Local0), One, Local0)
                    }
                    Else
                    {
                        Store (0xFF, Local0)
                    }
                }
            }
            EXFG ()
            Return (Local0)
        }
        Method (SSGP, 2, NotSerialized)
        {
            Divide (Arg0, 0x0A, Local0, Local1)
            ShiftLeft (One, Local0, Local0)
            Name (T_0, Zero)
            Store (Local1, T_0)
            If (LEqual (T_0, 0x04))
            {
                ENFG (0x09)
                If (LEqual (Arg1, Zero))
                {
                    And (OPT0, Not (Local0), OPT0)
                    And (OPT1, Not (Local0), OPT1)
                }
                Else
                {
                    Or (OPT0, Local0, OPT0)
                }
            }
            Else
            {
                If (LEqual (T_0, 0x08))
                {
                    ENFG (0x07)
                    If (LEqual (Arg1, Zero))
                    {
                        And (CRE4, Not (Local0), CRE4)
                        And (CRE5, Not (Local0), CRE5)
                    }
                    Else
                    {
                        Or (CRE4, Local0, CRE4)
                    }
                }
                Else
                {
                    If (LEqual (T_0, 0x09))
                    {
                        ENFG (0x07)
                        If (LEqual (Arg1, Zero))
                        {
                            And (CRE8, Not (Local0), CRE8)
                            And (CRE9, Not (Local0), CRE9)
                        }
                        Else
                        {
                            Or (CRE8, Local0, CRE8)
                        }
                    }
                    Else
                    {
                        Store (0xFF, Local0)
                    }
                }
            }
            EXFG ()
            DY40 ()
        }
        OperationRegion (DLYP, SystemIO, 0xE1, One)
        Field (DLYP, ByteAcc, NoLock, Preserve)
        {
            DELY,   8
        }
        Method (DY40, 0, NotSerialized)
        {
            Store (0x80, Local0)
            While (Local0)
            {
                Store (0xFF, DELY)
                Decrement (Local0)
            }
        }
        Method (GPGP, 1, NotSerialized)
        {
            Divide (Arg0, 0x08, Local0, Local1)
            Name (T_0, Zero)
            Store (Local1, T_0)
            If (LEqual (T_0, Zero))
            {
                Store (GPSA, Local2)
            }
            Else
            {
                If (LEqual (T_0, One))
                {
                    Store (GPSB, Local2)
                }
                Else
                {
                    If (LEqual (T_0, 0x02))
                    {
                        Store (GPSC, Local2)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x03))
                        {
                            Store (GPSD, Local2)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x04))
                            {
                                Store (GPSE, Local2)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x05))
                                {
                                    Store (GPSF, Local2)
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x06))
                                    {
                                        Store (GPSG, Local2)
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x07))
                                        {
                                            Store (GPSH, Local2)
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x08))
                                            {
                                                Store (GPSI, Local2)
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x09))
                                                {
                                                    Store (GPSJ, Local2)
                                                }
                                                Else
                                                {
                                                    If (LEqual (T_0, 0x0A))
                                                    {
                                                        Store (GPSK, Local2)
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (T_0, 0x0B))
                                                        {
                                                            Store (GPSL, Local2)
                                                        }
                                                        Else
                                                        {
                                                            Store (0xFF, Local2)
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            Return (And (ShiftRight (Local2, Local0), One))
        }
        Method (SPGP, 2, NotSerialized)
        {
            Divide (Arg0, 0x08, Local0, Local1)
            ShiftLeft (One, Local0, Local0)
            Name (T_0, Zero)
            Store (Local1, T_0)
            If (LEqual (T_0, Zero))
            {
                If (LEqual (Arg1, Zero))
                {
                    And (GPSA, Not (Local0), GPSA)
                    And (GPLA, Not (Local0), GPLA)
                }
                Else
                {
                    Or (GPSA, Local0, GPSA)
                }
            }
            Else
            {
                If (LEqual (T_0, One))
                {
                    If (LEqual (Arg1, Zero))
                    {
                        And (GPSB, Not (Local0), GPSB)
                        And (GPLB, Not (Local0), GPLB)
                    }
                    Else
                    {
                        Or (GPSB, Local0, GPSB)
                    }
                }
                Else
                {
                    If (LEqual (T_0, 0x02))
                    {
                        If (LEqual (Arg1, Zero))
                        {
                            And (GPSC, Not (Local0), GPSC)
                            And (GPLC, Not (Local0), GPLC)
                        }
                        Else
                        {
                            Or (GPSC, Local0, GPSC)
                        }
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x03))
                        {
                            If (LEqual (Arg1, Zero))
                            {
                                And (GPSD, Not (Local0), GPSD)
                                And (GPLD, Not (Local0), GPLD)
                            }
                            Else
                            {
                                Or (GPSD, Local0, GPSD)
                            }
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x04))
                            {
                                If (LEqual (Arg1, Zero))
                                {
                                    And (GPSE, Not (Local0), GPSE)
                                    And (GPLE, Not (Local0), GPLE)
                                }
                                Else
                                {
                                    Or (GPSE, Local0, GPSE)
                                }
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x05))
                                {
                                    If (LEqual (Arg1, Zero))
                                    {
                                        And (GPSF, Not (Local0), GPSF)
                                        And (GPLF, Not (Local0), GPLF)
                                    }
                                    Else
                                    {
                                        Or (GPSF, Local0, GPSF)
                                    }
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x06))
                                    {
                                        If (LEqual (Arg1, Zero))
                                        {
                                            And (GPSG, Not (Local0), GPSG)
                                            And (GPLG, Not (Local0), GPLG)
                                        }
                                        Else
                                        {
                                            Or (GPSG, Local0, GPSG)
                                        }
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x07))
                                        {
                                            If (LEqual (Arg1, Zero))
                                            {
                                                And (GPSH, Not (Local0), GPSH)
                                                And (GPLH, Not (Local0), GPLH)
                                            }
                                            Else
                                            {
                                                Or (GPSH, Local0, GPSH)
                                            }
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x08))
                                            {
                                                If (LEqual (Arg1, Zero))
                                                {
                                                    And (GPSI, Not (Local0), GPSI)
                                                    And (GPLI, Not (Local0), GPLI)
                                                }
                                                Else
                                                {
                                                    Or (GPSI, Local0, GPSI)
                                                }
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x09))
                                                {
                                                    If (LEqual (Arg1, Zero))
                                                    {
                                                        And (GPSJ, Not (Local0), GPSJ)
                                                        And (GPLJ, Not (Local0), GPLJ)
                                                    }
                                                    Else
                                                    {
                                                        Or (GPSJ, Local0, GPSJ)
                                                    }
                                                }
                                                Else
                                                {
                                                    If (LEqual (T_0, 0x0A))
                                                    {
                                                        If (LEqual (Arg1, Zero))
                                                        {
                                                            And (GPSK, Not (Local0), GPSK)
                                                            And (GPLK, Not (Local0), GPLK)
                                                        }
                                                        Else
                                                        {
                                                            Or (GPSK, Local0, GPSK)
                                                        }
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (T_0, 0x0B))
                                                        {
                                                            If (LEqual (Arg1, Zero))
                                                            {
                                                                And (GPSL, Not (Local0), GPSL)
                                                                And (GPLL, Not (Local0), GPLL)
                                                            }
                                                            Else
                                                            {
                                                                Or (GPSL, Local0, GPSL)
                                                            }
                                                        }
                                                        Else
                                                        {
                                                            Store (0xFF, Local0)
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            DY40 ()
        }
        Method (GVCV, 0, NotSerialized)
        {
            Store (RBYT (0x3C, 0x10), Local0)
            Return (Local0)
        }
        Method (SVCV, 1, NotSerialized)
        {
            WBYT (0x3C, 0x10, Arg0)
            WBYT (0x3C, 0x11, One)
            WBYT (0x3C, 0x12, One)
            WBYT (0x3C, 0x40, 0x02)
            Return (One)
         }
        Method (GCPV, 0, NotSerialized)
        {
            Return (RBYT (0x3C, 0x30))
        }
        Method (SCPV, 1, NotSerialized)
        {
            WBYT (0x3C, 0x30, Arg0)
            WBYT (0x3C, 0x31, One)
            WBYT (0x3C, 0x32, One)
            WBYT (0x3C, 0x40, 0x08)
            Return (One)
        }
        Method (GSCV, 0, NotSerialized)
        {
            Return (Or (ShiftLeft (RBYT (0x3C, Zero), One), GSGP (0x5A)
                ))
        }
        Method (SSCV, 1, NotSerialized)
        {
            Divide (Arg0, 0x02, Local0, Local1)
            If (LEqual (Local0, Zero))
            {
                SSGP (0x5A, Zero)
            }
            Else
            {
                SSGP (0x5A, One)
            }
            WBYT (0x3C, Zero, Local1)
            WBYT (0x3C, One, One)
            WBYT (0x3C, 0x02, One)
            WBYT (0x3C, 0x40, One)
            Return (One)
        }
        Method (SDRV, 1, NotSerialized)
        {
            If (LGreaterEqual (Arg0, 0x0F))
            {
                SSGP (0x2A, One)
                SSGP (0x2A, One)
                WBYT (0x3C, 0x20, Subtract (Arg0, 0x0F, Arg0))
                WBYT (0x3C, 0x21, One)
                WBYT (0x3C, 0x22, One)
                WBYT (0x3C, 0x40, 0x04)
            }
            Else
            {
                WBYT (0x3C, 0x20, Arg0)
                WBYT (0x3C, 0x21, One)
                WBYT (0x3C, 0x22, One)
                WBYT (0x3C, 0x40, 0x04)
                SSGP (0x2A, Zero)
                SSGP (0x2F, Zero)
            }
            Return (One)
        }
        Method (GDRV, 0, NotSerialized)
        {
            If (LEqual (GSGP (0x2A), One))
            {
                Add (RBYT (0x3C, 0x20), 0x0F, Local0)
                Return (Local0)
            }
            Else
            {
                Return (RBYT (0x3C, 0x20))
            }
            Return (Local0)
        }
        Method (GCPS, 0, NotSerialized)
        {
            If (LNot (PSFG))
            {
                Store (One, PSFG)
                Store (GPRE (0x003F207C), Local0)
                If (Local0)
                {
                    Store (One, Index (DMCS, Zero))
                    Store (0x04, Local1)
                    While (Local1)
                    {
                        If (Or (Local0, One))
                        {
                            Store (One, Index (DerefOf (Index (DMRS, Zero)), Subtract (0x04, 
                                Local1)))
                            LPSV (Zero, Subtract (0x04, Local1), BPS0)
                        }
                        If (LEqual (Local1, 0x03))
                        {
                            ShiftRight (Local0, 0x03, Local0)
                        }
                        Else
                        {
                            ShiftRight (Local0, One, Local0)
                        }
                        Subtract (Local1, One, Local1)
                    }
                }
                Store (GPRE (0x003F287C), Local0)
                If (Local0)
                {
                    Store (One, Index (DMCS, One))
                    Store (0x04, Local1)
                    While (Local1)
                    {
                        If (Or (Local0, One))
                        {
                            Store (One, Index (DerefOf (Index (DMRS, One)), Subtract (0x04, 
                                Local1)))
                            LPSV (One, Subtract (0x04, Local1), BPS1)
                        }
                        If (LEqual (Local1, 0x03))
                        {
                            ShiftRight (Local0, 0x03, Local0)
                        }
                        Else
                        {
                            ShiftRight (Local0, One, Local0)
                        }
                        Subtract (Local1, One, Local1)
                    }
                }
            }
        }
        Method (SPSL, 2, NotSerialized)
        {
            Store (0xFF, Index (PCRS, Zero))
            Store (Zero, Local0)
            While (LAnd (LLessEqual (Local0, 0x02), LEqual (DerefOf (Index (PCRS, 
                Zero)), 0xFF)))
            {
                Store (Zero, Local1)
                While (LAnd (LLessEqual (Local1, 0x03), LEqual (DerefOf (Index (PCRS, 
                    Zero)), 0xFF)))
                {
                    If (DerefOf (Index (DerefOf (Index (DMRS, Arg0)), Local1)))
                    {
                        Store (Zero, Local2)
                        Add (DerefOf (Index (DerefOf (Index (PSWI, Local0)), Zero)), 
                            Multiply (DerefOf (Index (DerefOf (Index (PSWI, Local0)), 0x03)), Local1
                            ), Local3)
                        While (LLessEqual (Local2, 0x07))
                        {
                            If (LEqual (Arg1, Local3))
                            {
                                Store (Local0, Index (PCRS, Zero))
                                Store (Local1, Index (PCRS, One))
                                Store (Local2, Index (PCRS, 0x02))
                                Return (One)
                            }
                            If (LEqual (Local2, 0x03))
                            {
                                Subtract (Local3, DerefOf (Index (DerefOf (Index (PSWI, Local0)), 0x02
                                    )), Local3)
                            }
                            Else
                            {
                                Subtract (Local3, DerefOf (Index (DerefOf (Index (PSWI, Local0)), One
                                    )), Local3)
                            }
                            Add (Local2, One, Local2)
                        }
                    }
                    Add (Local1, One, Local1)
                }
                Add (Local0, One, Local0)
            }
            Return (Zero)
        }
        Method (GPSV, 3, NotSerialized)
        {
            Store (Arg1, PAR0)
            Store (Or (ShiftLeft (Arg0, 0x10), Arg2), PAR1)
            ISMI (0x80)
            Return (PAR1)
        }
        Method (SPSV, 4, NotSerialized)
        {
            Store (Arg1, PAR0)
            Store (Or (ShiftLeft (Arg0, 0x10), Arg2), PAR1)
            Subtract (Arg2, 0x03, Local0)
            Store (0x03, Local1)
            While (Local0)
            {
                ShiftLeft (Local1, One, Local1)
                Or (Local1, One, Local1)
                Subtract (Local0, One, Local0)
            }
            Store (And (Arg3, Local1), PAR2)
            ISMI (0x81)
        }
        Method (LPSV, 3, NotSerialized)
        {
            Store (Arg2, Local0)
            Store (Zero, Local1)
            While (LLessEqual (Local1, 0x02))
            {
                Subtract (PSCL, Add (DerefOf (Index (DerefOf (Index (PSWI, Local1)), 
                    Zero)), Multiply (Arg1, DerefOf (Index (DerefOf (Index (PSWI, Local1)), 
                    0x03)))), Local3)
                Store (Zero, Local2)
                While (LLessEqual (Local2, 0x07))
                {
                    If (Arg0)
                    {
                        Store (GPSV (Arg0, Local3, 0x0B), Index (DerefOf (Index (DerefOf (Index (
                            BPS1, Local1)), Arg1)), Local2))
                    }
                    Else
                    {
                        Store (GPSV (Arg0, Local3, 0x0B), Index (DerefOf (Index (DerefOf (Index (
                            BPS0, Local1)), Arg1)), Local2))
                    }
                    If (LEqual (Local2, 0x03))
                    {
                        Add (Local3, DerefOf (Index (DerefOf (Index (PSWI, Local1)), 0x02
                            )), Local3)
                    }
                    Else
                    {
                        Add (Local3, DerefOf (Index (DerefOf (Index (PSWI, Local1)), One
                            )), Local3)
                    }
                    Add (Local2, One, Local2)
                }
                Add (Local1, One, Local1)
            }
            Subtract (PSCL, DerefOf (Index (DerefOf (Index (PSWI, Local1)), Arg1
                )), Local3)
            If (Arg0)
            {
                Store (GPSV (Arg0, Local3, 0x09), Index (DerefOf (Index (BPS1, Local1
                    )), Arg1))
            }
            Else
            {
                Store (GPSV (Arg0, Local3, 0x09), Index (DerefOf (Index (BPS0, Local1
                    )), Arg1))
            }
        }
        Method (WKOC, 1, NotSerialized)
        {
        }
        Method (PSOC, 1, NotSerialized)
        {
            If (LEqual (Arg0, 0x04))
            {
                Store (Zero, RBCK)
                Store (Zero, RVCR)
            }
        }
        Method (CDRV, 2, NotSerialized)
        {
            Store (RBYT (Arg0, Arg1), Local0)
            Store (GDRV (), Local1)
            Multiply (Local1, 0x7D, Local1)
            Add (Local1, 0x3A98, Local1)
            If (LGreaterEqual (Local0, 0x40))
            {
                Subtract (Local0, 0x40, Local0)
                If (LGreater (Local0, 0x10))
                {
                    Store (0x10, Local0)
                }
                Multiply (Local0, 0x30D4, Local0)
                Divide (Local0, Local1, Local1, Local0)
                Add (Local0, 0x15, Local0)
            }
            Else
            {
                Multiply (Local0, 0x1388, Local0)
                Divide (Local0, Local1, Local1, Local0)
            }
            Return (Local0)
        }
        Method (WDRV, 3, NotSerialized)
        {
            Store (GDRV (), Local1)
            Multiply (Local1, 0x7D, Local1)
            Add (Local1, 0x3A98, Local1)
            If (LGreaterEqual (Arg2, 0x15))
            {
                Subtract (Arg2, 0x15, Local0)
                Multiply (Local0, Local1, Local0)
                Divide (Local0, 0x30D4, Local1, Local0)
                If (LGreater (Local0, 0x10))
                {
                    Store (0x10, Local0)
                }
                Add (Local0, 0x40, Local0)
            }
            Else
            {
                Subtract (0x15, Arg2, Local0)
                Multiply (Local0, Local1, Local0)
                Divide (Local0, 0x1388, Local1, Local0)
                If (LGreater (Local0, 0x3F))
                {
                    Store (0x3F, Local0)
                }
            }
            WBYT (Arg0, Arg1, Local0)
        }
        Method (WDPS, 2, NotSerialized)
        {
            If (LGreater (Arg1, 0x14))
            {
                Subtract (Arg1, 0x15, Local1)
            }
            Else
            {
                Subtract (0x35, Arg1, Local1)
            }
            Or (Local1, 0x0140, Local1)
            SPSV (Arg0, 0x1616, 0x0A, Local1)
        }
        Name (RBCK, Zero)
        Name (RVCR, Zero)
        Name (TGTM, Zero)
        Name (TGTN, Zero)
        Name (VIMC, Zero)
        Name (VDAD, Zero)
        Name (VDBD, Zero)
    }
    Scope (_SB.PCI0.SBRG.ASOC)
    {
        Name (G4T0, Package (0x04)
        {
            0x04070010, 
            "CPU Q-FAN Control", 
            0x80000000, 
            Zero
        })
        Name (G4T1, Package (0x08)
        {
            0x04080011, 
            "CPU Q-FAN Profile", 
            0x00100001, 
            Zero, 
            0x03, 
            "Optimal", 
            "Silent", 
            "Performance"
        })
        Name (G4T2, Package (0x07)
        {
            0x04030017, 
            "CPU T-Control reference", 
            0x40000000, 
            Zero, 
            Zero, 
            One, 
            0x64
        })
        Name (G420, Package (0x04)
        {
            0x04070070, 
            "Chassis Q-FAN Control", 
            0x80000000, 
            Zero
        })
        Name (G421, Package (0x08)
        {
            0x04080071, 
            "Chassis Q-FAN Profile", 
            0x00710001, 
            Zero, 
            0x03, 
            "Optimal", 
            "Silent", 
            "Performance"
        })
        Name (GRP4, Package (0x05)
        {
            G4T0, 
            G4T1, 
            G4T2, 
            G420, 
            G421
        })
        Method (GIT4, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, 0x10))
            {
                Store (GNVS (0x16AA), ASB1)
            }
            Else
            {
                If (LEqual (T_0, 0x11))
                {
                    Store (GNVS (0x2626), ASB1)
                }
                Else
                {
                    If (LEqual (T_0, 0x17))
                    {
                        Store (0x3C, ASB1)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x70))
                        {
                            Store (GNVS (0x16AD), ASB1)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x71))
                            {
                                Store (GNVS (0x2628), ASB1)
                            }
                            Else
                            {
                                Store (Zero, ASB0)
                            }
                        }
                    }
                }
            }
        }
        Method (SIT4, 3, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, 0x10))
            {
                If (LNotEqual (GNVS (0x16AA), Arg1))
                {
                    If (And (Arg2, One))
                    {
                        SNVS (0x16AA, Arg1)
                    }
                    Or (ASB0, 0x02, ASB0)
                }
            }
            Else
            {
                If (LEqual (T_0, 0x11))
                {
                    If (LNotEqual (GNVS (0x2626), Arg1))
                    {
                        If (And (Arg2, One))
                        {
                            SNVS (0x2626, Arg1)
                        }
                        Or (ASB0, 0x02, ASB0)
                    }
                }
                Else
                {
                    If (LEqual (T_0, 0x70))
                    {
                        If (LNotEqual (GNVS (0x16AD), Arg1))
                        {
                            If (And (Arg2, One))
                            {
                                SNVS (0x16AD, Arg1)
                            }
                            Or (ASB0, 0x02, ASB0)
                        }
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x71))
                        {
                            If (LNotEqual (GNVS (0x2628), Arg1))
                            {
                                If (And (Arg2, One))
                                {
                                    SNVS (0x2628, Arg1)
                                }
                                Or (ASB0, 0x02, ASB0)
                            }
                        }
                        Else
                        {
                            Store (Zero, ASB0)
                        }
                    }
                }
            }
        }
    }
    Scope (_SB.PCI0.SBRG.ASOC)
    {
        Name (G5T0, Package (0x07)
        {
            0x05080000, 
            "AI Profile", 
            Zero, 
            Zero, 
            0x02, 
            "Auto", 
            Zero
        })
        Name (G5T2, Package (0x08)
        {
            0x05080002, 
            "AI Profile Key", 
            Zero, 
            Zero, 
            0x03, 
            "Performance", 
            "Superior", 
            "Ultimate"
        })
        Name (G5T4, Package (0x07)
        {
            0x05080004, 
            "EZ Tune", 
            Zero, 
            Zero, 
            0x03, 
            "Auto", 
            Zero
        })
        Name (C0R0, Package (0x07)
        {
            0x05080010, 
            "PadScan Channel0 Rank0", 
            Zero, 
            Zero, 
            0x03, 
            "Auto", 
            Zero
        })
        Name (C0R1, Package (0x07)
        {
            0x05080011, 
            "PadScan Channel0 Rank1", 
            Zero, 
            Zero, 
            0x03, 
            "Auto", 
            Zero
        })
        Name (C0R2, Package (0x07)
        {
            0x05080012, 
            "PadScan Channel0 Rank2", 
            Zero, 
            Zero, 
            0x03, 
            "Auto", 
            Zero
        })
        Name (C0R3, Package (0x07)
        {
            0x05080013, 
            "PadScan Channel0 Rank3", 
            Zero, 
            Zero, 
            0x03, 
            "Auto", 
            Zero
        })
        Name (C1R0, Package (0x07)
        {
            0x05080020, 
            "PadScan Channel1 Rank0", 
            Zero, 
            Zero, 
            0x03, 
            "Auto", 
            Zero
        })
        Name (C1R1, Package (0x07)
        {
            0x05080021, 
            "PadScan Channel1 Rank1", 
            Zero, 
            Zero, 
            0x03, 
            "Auto", 
            Zero
        })
        Name (C1R2, Package (0x07)
        {
            0x05080022, 
            "PadScan Channel1 Rank2", 
            Zero, 
            Zero, 
            0x03, 
            "Auto", 
            Zero
        })
        Name (C1R3, Package (0x07)
        {
            0x05080023, 
            "PadScan Channel1 Rank3", 
            Zero, 
            Zero, 
            0x03, 
            "Auto", 
            Zero
        })
        Name (GRP5, Package (0x0B)
        {
            G5T0, 
            G5T2, 
            G5T4, 
            C0R0, 
            C0R1, 
            C0R2, 
            C0R3, 
            C1R0, 
            C1R1, 
            C1R2, 
            C1R3
        })
        Name (MANF, Zero)
        Name (OBID, Zero)
        Name (DRAO, Zero)
        Name (BUF6, Package (0x02)
        {
            0x03010011, 
            Ones
        })
        Method (GIT5, 2, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, Zero))
            {
                Store (One, ASB1)
            }
            Else
            {
                If (LEqual (T_0, 0x02))
                {
                    UDBF (Arg1)
                    MVBF (Arg1)
                    Store (0x05, ASB1)
                }
                Else
                {
                    If (LEqual (T_0, 0x03))
                    {
                        SBF (Arg1)
                        Store (0x05, ASB1)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x04))
                        {
                            SEBF (Arg1)
                            Store (0x05, ASB1)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x10))
                            {
                                PSR (Arg1, Zero, Zero)
                                Store (0x05, ASB1)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x11))
                                {
                                    PSR (Arg1, Zero, One)
                                    Store (0x05, ASB1)
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x12))
                                    {
                                        PSR (Arg1, Zero, 0x02)
                                        Store (0x05, ASB1)
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x13))
                                        {
                                            PSR (Arg1, Zero, 0x03)
                                            Store (0x05, ASB1)
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x20))
                                            {
                                                PSR (Arg1, One, Zero)
                                                Store (0x05, ASB1)
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x21))
                                                {
                                                    PSR (Arg1, One, One)
                                                    Store (0x05, ASB1)
                                                }
                                                Else
                                                {
                                                    If (LEqual (T_0, 0x22))
                                                    {
                                                        PSR (Arg1, One, 0x02)
                                                        Store (0x05, ASB1)
                                                    }
                                                    Else
                                                    {
                                                        If (LEqual (T_0, 0x23))
                                                        {
                                                            PSR (Arg1, One, 0x03)
                                                            Store (0x05, ASB1)
                                                        }
                                                        Else
                                                        {
                                                            Store (Zero, ASB0)
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        Method (SIT5, 3, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, Zero))
            {
                Store (0x03, ASB0)
            }
            Else
            {
                Store (Zero, ASB0)
            }
        }
        Name (BUF1, Package (0x01)
        {
            Package (0x02)
            {
                0x10, 
                0x30
            }
        })
        Name (BUF4, Package (0x01)
        {
            Package (0x04)
            {
                0x03020015, 
                0x02, 
                0x030200B1, 
                Zero
            }
        })
        Name (BUF2, Package (0x0B)
        {
            Package (0x02)
            {
                0x03020032, 
                Zero
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x04
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x04
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x05
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x05
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x06
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x06
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x07
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x07
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x08
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x08
            }
        })
        Name (BUF5, Package (0x04)
        {
            Package (0x03)
            {
                Package (0x04)
                {
                    Package (0x03)
                    {
                        0x03, 
                        0x05, 
                        0x07
                    }, 
                    Package (0x03)
                    {
                        0x03, 
                        0x05, 
                        0x07
                    }, 
                    Package (0x03)
                    {
                        0x03, 
                        0x05, 
                        0x07
                    }, 
                    Package (0x03)
                    {
                        0x03, 
                        0x05, 
                        0x07
                    }
                }, 
                Package (0x04)
                {
                    Package (0x03)
                    {
                        0x05, 
                        0x09, 
                        0x0C
                    }, 
                    Package (0x03)
                    {
                        0x04, 
                        0x08, 
                        0x0C
                    }, 
                    Package (0x03)
                    {
                        0x05, 
                        0x09, 
                        0x0C
                    }, 
                    Package (0x03)
                    {
                        0x04, 
                        0x08, 
                        0x0C
                    }
                }, 
                Package (0x04)
                {
                    Package (0x03)
                    {
                        0x07, 
                        0x0C, 
                        0x10
                    }, 
                    Package (0x03)
                    {
                        0x06, 
                        0x0B, 
                        0x10
                    }, 
                    Package (0x03)
                    {
                        0x07, 
                        0x0C, 
                        0x10
                    }, 
                    Package (0x03)
                    {
                        0x06, 
                        0x0B, 
                        0x10
                    }
                }
            }, 
            Package (0x03)
            {
                Package (0x04)
                {
                    Package (0x03)
                    {
                        0x03, 
                        0x05, 
                        0x07
                    }, 
                    Package (0x03)
                    {
                        0x03, 
                        0x05, 
                        0x07
                    }, 
                    Package (0x03)
                    {
                        0x03, 
                        0x05, 
                        0x07
                    }, 
                    Package (0x03)
                    {
                        0x03, 
                        0x05, 
                        0x07
                    }
                }, 
                Package (0x04)
                {
                    Package (0x03)
                    {
                        0x05, 
                        0x09, 
                        0x0C
                    }, 
                    Package (0x03)
                    {
                        0x04, 
                        0x08, 
                        0x0C
                    }, 
                    Package (0x03)
                    {
                        0x05, 
                        0x09, 
                        0x0C
                    }, 
                    Package (0x03)
                    {
                        0x04, 
                        0x08, 
                        0x0C
                    }
                }, 
                Package (0x04)
                {
                    Package (0x03)
                    {
                        0x07, 
                        0x0C, 
                        0x10
                    }, 
                    Package (0x03)
                    {
                        0x06, 
                        0x0B, 
                        0x10
                    }, 
                    Package (0x03)
                    {
                        0x07, 
                        0x0C, 
                        0x10
                    }, 
                    Package (0x03)
                    {
                        0x06, 
                        0x0B, 
                        0x10
                    }
                }
            }, 
            Package (0x03)
            {
                Package (0x04)
                {
                    Package (0x03)
                    {
                        0x0D, 
                        0x0F, 
                        0x10
                    }, 
                    Package (0x03)
                    {
                        0x0D, 
                        0x0F, 
                        0x11
                    }, 
                    Package (0x03)
                    {
                        0x0D, 
                        0x0F, 
                        0x10
                    }, 
                    Package (0x03)
                    {
                        0x0D, 
                        0x0F, 
                        0x11
                    }
                }, 
                Package (0x04)
                {
                    Package (0x03)
                    {
                        0x02, 
                        0x05, 
                        0x07
                    }, 
                    Package (0x03)
                    {
                        One, 
                        0x03, 
                        0x04
                    }, 
                    Package (0x03)
                    {
                        0x02, 
                        0x05, 
                        0x07
                    }, 
                    Package (0x03)
                    {
                        One, 
                        0x03, 
                        0x04
                    }
                }, 
                Package (0x04)
                {
                    Package (0x03)
                    {
                        0xFFE0, 
                        0xFFE4, 
                        0xFFE7
                    }, 
                    Package (0x03)
                    {
                        0xFFE0, 
                        0xFFE3, 
                        0xFFE5
                    }, 
                    Package (0x03)
                    {
                        0xFFE0, 
                        0xFFE4, 
                        0xFFE7
                    }, 
                    Package (0x03)
                    {
                        0xFFE0, 
                        0xFFE3, 
                        0xFFE5
                    }
                }
            }, 
            Package (0x01)
            {
                Package (0x03)
                {
                    Package (0x04)
                    {
                        One, 
                        Zero, 
                        One, 
                        Zero
                    }, 
                    Package (0x04)
                    {
                        0x02, 
                        One, 
                        One, 
                        Zero
                    }, 
                    Package (0x04)
                    {
                        0x02, 
                        One, 
                        0x02, 
                        One
                    }
                }
            }
        })
        Method (SBF, 1, NotSerialized)
        {
            Store (One, ATFG)
            If (LNot (VCBI))
            {
                Store (DerefOf (Index (G3C1, 0x03)), VCBI)
            }
            Store (GNVS (0x16CA), MANF)
            Store (DerefOf (Index (DerefOf (Index (BUF1, Zero)), MANF)), 
                Local2)
            If (LNot (MANF))
            {
                If (LNotEqual (GPRE (0x00FF1800), Ones))
                {
                    Store (Zero, Local1)
                    Store (GNVS (0x16B8), Local0)
                    If (Local0)
                    {
                        Store (GNVS (0x8290), Local1)
                        If (LNot (Local1))
                        {
                            Store (GNVS (0x16BA), Local0)
                            If (Local0)
                            {
                                Store (One, Local2)
                            }
                        }
                    }
                    Add (Local2, VCBI, Local2)
                    If (LOr (LNot (Local0), Local1))
                    {
                        If (LGreater (Local2, 0x38))
                        {
                            Store (0x38, Local2)
                        }
                    }
                }
                Else
                {
                    Add (Local2, VCBI, Local2)
                }
            }
            Store (0x08, OBID)
            BOBF (OBID, 0x03020012)
            Add (OBID, 0x04, OBID)
            BOBF (OBID, Local2)
            Add (OBID, 0x04, OBID)
            Store (Zero, Local1)
            Store (SizeOf (Index (BUF4, Local1)), Local2)
            Store (Zero, Local3)
            While (LNotEqual (Local2, Local3))
            {
                Store (DerefOf (Index (DerefOf (Index (BUF4, Local1)), Local3)), 
                    Local5)
                BOBF (OBID, Local5)
                Add (OBID, 0x04, OBID)
                Add (Local3, One, Local3)
            }
            Store (Zero, Local0)
            Store (0x03, Local1)
            Store (Zero, Local3)
            While (LLessEqual (Local0, Local1))
            {
                Add (0xA0, Multiply (0x02, Local0), Local2)
                If (LNotEqual (RBYT (Local2, Zero), 0xFF))
                {
                    If (LEqual (RBYT (Local2, 0xB3), 0x12))
                    {
                        Store (One, Local3)
                        Store (RBYT (Local2, 0xB9), Local0)
                        Add (Multiply (ShiftRight (Local0, 0x05), 0x2710), Multiply (And (
                            Local0, 0x1F), 0x01F4), Local0)
                        Subtract (Local0, And (DerefOf (Index (G3D2, 0x04)), 0xFFFF), 
                            Local0)
                        Divide (Local0, 0x03E8, Local5, Local0)
                        BOBF (OBID, 0x03020032)
                        Add (OBID, 0x04, OBID)
                        BOBF (OBID, Local0)
                        Add (OBID, 0x04, OBID)
                    }
                    Break
                }
                Add (Local0, One, Local0)
            }
            If (LNot (Local3))
            {
                Multiply (Arg0, 0x64, Local1)
                Divide (Local1, GCPR (), Local0, Local1)
                If (LEqual (DRAO, Zero))
                {
                    If (LNotEqual (GPRE (0x00FF1800), Ones))
                    {
                        Store (GPRE (0x00FF20E0), Local2)
                        If (LNot (Local2))
                        {
                            Store (GPRE (0x00FF28E0), Local2)
                        }
                        Store (And (ShiftRight (Local2, 0x08), 0xFF), Local0)
                    }
                    Else
                    {
                        OperationRegion (MCHB, SystemMemory, 0xFED14000, 0x3000)
                        Field (MCHB, ByteAcc, Lock, Preserve)
                        {
                                    Offset (0x2C20), 
                            MEMR,   8, 
                                ,   2, 
                            HALF,   1
                        }
                        Store (ShiftRight (MEMR, One), Local0)
                        If (HALF)
                        {
                            ShiftRight (Local0, One, Local0)
                        }
                    }
                    Store (Local0, DRAO)
                }
                Else
                {
                    Store (DRAO, Local0)
                }
                Multiply (Local1, Local0, Local1)
                If (LNotEqual (GPRE (0x00FF1800), Ones))
                {
                    Multiply (Local1, 0x02, Local1)
                }
                Divide (Local1, 0x64, Local0, Local1)
                If (LLessEqual (Local1, 0x0497))
                {
                    Store (Zero, Local0)
                }
                Else
                {
                    If (LLessEqual (Local1, 0x0528))
                    {
                        Store (One, Local0)
                    }
                    Else
                    {
                        If (LLessEqual (Local1, 0x0582))
                        {
                            Store (0x02, Local0)
                        }
                        Else
                        {
                            If (LLessEqual (Local1, 0x05B4))
                            {
                                Store (0x03, Local0)
                            }
                            Else
                            {
                                If (LLessEqual (Local1, 0x05F0))
                                {
                                    Store (0x04, Local0)
                                }
                                Else
                                {
                                    If (LLessEqual (Local1, 0x062C))
                                    {
                                        Store (0x05, Local0)
                                    }
                                    Else
                                    {
                                        If (LLessEqual (Local1, 0x069A))
                                        {
                                            Store (0x06, Local0)
                                        }
                                        Else
                                        {
                                            If (LLessEqual (Local1, 0x06C2))
                                            {
                                                Store (0x07, Local0)
                                            }
                                            Else
                                            {
                                                If (LLessEqual (Local1, 0x06E0))
                                                {
                                                    Store (0x08, Local0)
                                                }
                                                Else
                                                {
                                                    If (LLessEqual (Local1, 0x0707))
                                                    {
                                                        Store (0x09, Local0)
                                                    }
                                                    Else
                                                    {
                                                        Store (0x0A, Local0)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                Store (SizeOf (Index (BUF2, Local0)), Local2)
                Store (Zero, Local3)
                While (LNotEqual (Local2, Local3))
                {
                    Store (DerefOf (Index (DerefOf (Index (BUF2, Local0)), Local3)), 
                        Local5)
                    BOBF (OBID, Local5)
                    Add (OBID, 0x04, OBID)
                    Add (Local3, One, Local3)
                }
            }
            BOBF (OBID, Ones)
        }
        Name (EBF1, Package (0x0B)
        {
            Package (0x02)
            {
                Zero, 
                Zero
            }, 
            Package (0x02)
            {
                0x02, 
                0x38
            }, 
            Package (0x02)
            {
                0x04, 
                0x3C
            }, 
            Package (0x02)
            {
                0x08, 
                0x40
            }, 
            Package (0x02)
            {
                0x0C, 
                0x44
            }, 
            Package (0x02)
            {
                0x10, 
                0x48
            }, 
            Package (0x02)
            {
                0x14, 
                0x4C
            }, 
            Package (0x02)
            {
                0x18, 
                0x50
            }, 
            Package (0x02)
            {
                0x20, 
                0x58
            }, 
            Package (0x02)
            {
                0x24, 
                0x5C
            }, 
            Package (0x02)
            {
                0x28, 
                0x60
            }
        })
        Name (EBF3, Package (0x07)
        {
            Package (0x02)
            {
                Zero, 
                Zero
            }, 
            Package (0x02)
            {
                0x02, 
                0x30
            }, 
            Package (0x02)
            {
                0x04, 
                0x34
            }, 
            Package (0x02)
            {
                0x06, 
                0x36
            }, 
            Package (0x02)
            {
                0x08, 
                0x38
            }, 
            Package (0x02)
            {
                0x0C, 
                0x3C
            }, 
            Package (0x02)
            {
                0x10, 
                0x40
            }
        })
        Name (EBF4, Package (0x04)
        {
            Package (0x04)
            {
                0x03020015, 
                Zero, 
                0x030200B1, 
                Zero
            }, 
            Package (0x04)
            {
                0x03020015, 
                One, 
                0x030200B1, 
                Zero
            }, 
            Package (0x04)
            {
                0x03020015, 
                0x02, 
                0x030200B1, 
                Zero
            }, 
            Package (0x04)
            {
                0x03020015, 
                0x03, 
                0x030200B1, 
                Zero
            }
        })
        Name (EBF2, Package (0x0B)
        {
            Package (0x02)
            {
                0x03020032, 
                0x03
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x04
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x04
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x05
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x05
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x06
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x06
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x07
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x07
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x08
            }, 
            Package (0x02)
            {
                0x03020032, 
                0x08
            }
        })
        Method (SEBF, 1, NotSerialized)
        {
            Store (One, ATFG)
            If (LNot (VCBI))
            {
                Store (DerefOf (Index (G3C1, 0x03)), VCBI)
            }
            Store (GNVS (0x16CA), MANF)
            If (LLessEqual (Arg0, 0x0C1C))
            {
                Store (Zero, Local0)
            }
            Else
            {
                If (LGreaterEqual (Arg0, 0x0FA1))
                {
                    Store (0x0A, Local0)
                }
                Else
                {
                    Subtract (Arg0, 0x0BB9, Local1)
                    Divide (Local1, 0x64, Local3, Local0)
                }
            }
            Divide (Arg0, GCPR (), Local1, Local3)
            If (LLessEqual (Local3, 0x98))
            {
                Store (Zero, Local1)
            }
            Else
            {
                If (LLessEqual (Local3, 0xA8))
                {
                    Store (One, Local1)
                }
                Else
                {
                    If (LLessEqual (Local3, 0xB4))
                    {
                        Store (0x02, Local1)
                    }
                    Else
                    {
                        If (LLessEqual (Local3, 0xBD))
                        {
                            Store (0x03, Local1)
                        }
                        Else
                        {
                            If (LLessEqual (Local3, 0xC8))
                            {
                                Store (0x04, Local1)
                            }
                            Else
                            {
                                If (LLessEqual (Local3, 0xD2))
                                {
                                    Store (0x05, Local1)
                                }
                                Else
                                {
                                    Store (0x06, Local1)
                                }
                            }
                        }
                    }
                }
            }
            If (LGreaterEqual (DerefOf (Index (DerefOf (Index (EBF1, Local0)), 
                MANF)), DerefOf (Index (DerefOf (Index (EBF3, Local1)), MANF))))
            {
                Store (DerefOf (Index (DerefOf (Index (EBF1, Local0)), MANF)), 
                    Local2)
            }
            Else
            {
                Store (DerefOf (Index (DerefOf (Index (EBF3, Local1)), MANF)), 
                    Local2)
            }
            If (LNot (MANF))
            {
                Add (Local2, VCBI, Local2)
            }
            Store (0x08, OBID)
            BOBF (OBID, 0x03020012)
            Add (OBID, 0x04, OBID)
            BOBF (OBID, Local2)
            Add (OBID, 0x04, OBID)
            Store (GNVS (0x53A8), Local1)
            If (Local1)
            {
                Multiply (Add (Local1, 0x0B), Local3, Local0)
            }
            Else
            {
                Multiply (And (GPRE (0x00FF00C0), 0x7F), Local3, Local0)
            }
            If (LLessEqual (Local0, 0x0A8B))
            {
                Store (Zero, Local1)
            }
            Else
            {
                If (LLessEqual (Local0, 0x0AE5))
                {
                    Store (One, Local1)
                }
                Else
                {
                    If (LLessEqual (Local0, 0x0BB7))
                    {
                        Store (0x02, Local1)
                    }
                    Else
                    {
                        Store (0x03, Local1)
                    }
                }
            }
            Store (SizeOf (Index (EBF4, Local1)), Local2)
            Store (Zero, Local3)
            While (LNotEqual (Local2, Local3))
            {
                Store (DerefOf (Index (DerefOf (Index (EBF4, Local1)), Local3)), 
                    Local5)
                BOBF (OBID, Local5)
                Add (OBID, 0x04, OBID)
                Add (Local3, One, Local3)
            }
            Store (Zero, Local0)
            Store (0x03, Local1)
            Store (Zero, Local3)
            While (LLessEqual (Local0, Local1))
            {
                Add (0xA0, Multiply (0x02, Local0), Local2)
                If (LNotEqual (RBYT (Local2, Zero), 0xFF))
                {
                    If (LEqual (RBYT (Local2, 0xB3), 0x12))
                    {
                        Store (One, Local3)
                        Store (RBYT (Local2, 0xB9), Local0)
                        Add (Multiply (ShiftRight (Local0, 0x05), 0x2710), Multiply (And (
                            Local0, 0x1F), 0x01F4), Local0)
                        Subtract (Local0, And (DerefOf (Index (G3D2, 0x04)), 0xFFFF), 
                            Local0)
                        Divide (Local0, 0x03E8, Local5, Local0)
                        BOBF (OBID, 0x03020032)
                        Add (OBID, 0x04, OBID)
                        BOBF (OBID, Local0)
                        Add (OBID, 0x04, OBID)
                    }
                    Break
                }
                Add (Local0, One, Local0)
            }
            If (LNot (Local3))
            {
                Multiply (Arg0, 0x64, Local1)
                Divide (Local1, GCPR (), Local0, Local1)
                If (LEqual (DRAO, Zero))
                {
                    If (LNotEqual (GPRE (0x00FF1800), Ones))
                    {
                        Store (GPRE (0x00FF20E0), Local2)
                        If (LNot (Local2))
                        {
                            Store (GPRE (0x00FF28E0), Local2)
                        }
                        Store (And (ShiftRight (Local2, 0x08), 0xFF), Local0)
                    }
                    Else
                    {
                        OperationRegion (MCHB, SystemMemory, 0xFED14000, 0x3000)
                        Field (MCHB, ByteAcc, Lock, Preserve)
                        {
                                    Offset (0x2C20), 
                            MEMR,   8, 
                                ,   2, 
                            HALF,   1
                        }
                        Store (ShiftRight (MEMR, One), Local0)
                        If (HALF)
                        {
                            ShiftRight (Local0, One, Local0)
                        }
                    }
                    Store (Local0, DRAO)
                }
                Else
                {
                    Store (DRAO, Local0)
                }
                Multiply (Local1, Local0, Local1)
                If (LNotEqual (GPRE (0x00FF1800), Ones))
                {
                    Multiply (Local1, 0x02, Local1)
                }
                Divide (Local1, 0x64, Local0, Local1)
                If (LLessEqual (Local1, 0x0497))
                {
                    Store (Zero, Local0)
                }
                Else
                {
                    If (LLessEqual (Local1, 0x0528))
                    {
                        Store (One, Local0)
                    }
                    Else
                    {
                        If (LLessEqual (Local1, 0x0582))
                        {
                            Store (0x02, Local0)
                        }
                        Else
                        {
                            If (LLessEqual (Local1, 0x05B4))
                            {
                                Store (0x03, Local0)
                            }
                            Else
                            {
                                If (LLessEqual (Local1, 0x05F0))
                                {
                                    Store (0x04, Local0)
                                }
                                Else
                                {
                                    If (LLessEqual (Local1, 0x062C))
                                    {
                                        Store (0x05, Local0)
                                    }
                                    Else
                                    {
                                        If (LLessEqual (Local1, 0x069A))
                                        {
                                            Store (0x06, Local0)
                                        }
                                        Else
                                        {
                                            If (LLessEqual (Local1, 0x06C2))
                                            {
                                                Store (0x07, Local0)
                                            }
                                            Else
                                            {
                                                If (LLessEqual (Local1, 0x06E0))
                                                {
                                                    Store (0x08, Local0)
                                                }
                                                Else
                                                {
                                                    If (LLessEqual (Local1, 0x0707))
                                                    {
                                                        Store (0x09, Local0)
                                                    }
                                                    Else
                                                    {
                                                        Store (0x0A, Local0)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                Store (SizeOf (Index (EBF2, Local0)), Local2)
                Store (Zero, Local3)
                While (LNotEqual (Local2, Local3))
                {
                    Store (DerefOf (Index (DerefOf (Index (EBF2, Local0)), Local3)), 
                        Local5)
                    BOBF (OBID, Local5)
                    Add (OBID, 0x04, OBID)
                    Add (Local3, One, Local3)
                }
            }
            BOBF (OBID, Ones)
        }
        Method (PSR, 3, NotSerialized)
        {
            If (LNotEqual (GPRE (0x003F1800), Ones))
            {
                If (LEqual (DRAO, Zero))
                {
                    Store (GPRE (0x003F20E0), Local2)
                    If (LNot (Local2))
                    {
                        Store (GPRE (0x003F28E0), Local2)
                    }
                    Store (And (ShiftRight (Local2, 0x08), 0xFF), DRAO)
                }
                Multiply (And (DRAO, 0xFF), And (Arg0, 0xFFFF), Local0)
                Multiply (Local0, 0x02, Local2)
                Divide (Local2, And (GCPR (), 0xFF), Local0, Local3)
                And (Local3, 0x07FF, Local1)
                Store (0x08, OBID)
                If (LGreaterEqual (Local1, 0x0578))
                {
                    If (LLessEqual (Local1, 0x05A9))
                    {
                        Store (Zero, Local0)
                    }
                    Else
                    {
                        If (LLessEqual (Local1, 0x05DB))
                        {
                            Store (One, Local0)
                        }
                        Else
                        {
                            Store (0x02, Local0)
                        }
                    }
                    GCPS ()
                    If (DerefOf (Index (DMCS, Arg1)))
                    {
                        PSOB (Local0, Arg1, Arg2)
                    }
                }
            }
            Else
            {
                Store (0x08, OBID)
            }
            BOBF (OBID, Ones)
        }
        Method (PSOB, 3, NotSerialized)
        {
            Store (Arg0, Local0)
            Store (Zero, Local1)
            While (LLess (Local1, 0x03))
            {
                Store (Arg2, Local2)
                If (DerefOf (Index (DerefOf (Index (DMRS, Arg1)), Local2)))
                {
                    Add (DerefOf (Index (DerefOf (Index (PSWI, Local1)), Zero)), 
                        Multiply (DerefOf (Index (DerefOf (Index (PSWI, Local1)), 0x03)), Local2
                        ), Local5)
                    Store (Zero, Local3)
                    While (LLess (Local3, 0x08))
                    {
                        BOBF (OBID, 0x030600F2)
                        Add (OBID, 0x04, OBID)
                        BOBF (OBID, Arg1)
                        Add (OBID, 0x02, OBID)
                        BOBF (OBID, Local5)
                        Add (OBID, 0x02, OBID)
                        BOBF (OBID, DerefOf (Index (DerefOf (Index (PSWI, Local1)), 0x03
                            )))
                        Add (OBID, 0x02, OBID)
                        If (LLessEqual (Local3, One))
                        {
                            BOBF (OBID, DerefOf (Index (DerefOf (Index (DerefOf (Index (DerefOf (Index (
                                BUF5, Local1)), Local0)), Local2)), Zero)))
                        }
                        Else
                        {
                            If (LLessEqual (Local3, 0x04))
                            {
                                BOBF (OBID, DerefOf (Index (DerefOf (Index (DerefOf (Index (DerefOf (Index (
                                    BUF5, Local1)), Local0)), Local2)), One)))
                            }
                            Else
                            {
                                BOBF (OBID, DerefOf (Index (DerefOf (Index (DerefOf (Index (DerefOf (Index (
                                    BUF5, Local1)), Local0)), Local2)), 0x02)))
                            }
                        }
                        Add (OBID, 0x02, OBID)
                        If (LEqual (Local3, 0x03))
                        {
                            Subtract (Local5, DerefOf (Index (DerefOf (Index (PSWI, Local1)), 0x02
                                )), Local5)
                        }
                        Else
                        {
                            Subtract (Local5, DerefOf (Index (DerefOf (Index (PSWI, Local1)), One
                                )), Local5)
                        }
                        Add (Local3, One, Local3)
                    }
                }
                Add (Local1, One, Local1)
            }
            If (DerefOf (Index (DerefOf (Index (DMRS, Arg1)), Local2)))
            {
                BOBF (OBID, 0x030600F2)
                Add (OBID, 0x04, OBID)
                BOBF (OBID, Arg1)
                Add (OBID, 0x02, OBID)
                BOBF (OBID, DerefOf (Index (DerefOf (Index (PSWI, Local1)), Local2
                    )))
                Add (OBID, 0x02, OBID)
                BOBF (OBID, 0x09)
                Add (OBID, 0x02, OBID)
                BOBF (0x015C, DerefOf (Index (DerefOf (Index (DerefOf (Index (DerefOf (Index (
                    BUF5, Local1)), Zero)), Local0)), Local2)))
                BOBF (OBID, DerefOf (Index (DerefOf (Index (DerefOf (Index (DerefOf (Index (
                    BUF5, Local1)), Zero)), Local0)), Local2)))
                Add (OBID, 0x02, OBID)
            }
        }
        Method (BOBF, 2, NotSerialized)
        {
            Store (Arg1, Local0)
            Store (Arg0, Local1)
            Store (Local0, Index (ASBF, Local1))
            ShiftRight (Local0, 0x08, Local0)
            Add (Local1, One, Local1)
            Store (Local0, Index (ASBF, Local1))
            ShiftRight (Local0, 0x08, Local0)
            Add (Local1, One, Local1)
            Store (Local0, Index (ASBF, Local1))
            ShiftRight (Local0, 0x08, Local0)
            Add (Local1, One, Local1)
            Store (Local0, Index (ASBF, Local1))
        }
        Method (UDBF, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, Zero))
            {
                Store (0x36, Index (BUF6, One))
            }
            Else
            {
                If (LEqual (T_0, One))
                {
                    Store (0x39, Index (BUF6, One))
                }
                Else
                {
                    If (LEqual (T_0, 0x02))
                    {
                        Store (0x3C, Index (BUF6, One))
                    }
                }
            }
        }
        Method (MVBF, 1, NotSerialized)
        {
            Store (Zero, Local0)
            Store (0x08, Local2)
            Store (SizeOf (BUF6), Local3)
            While (LNotEqual (Local0, Local3))
            {
                Add (Local0, One, Local1)
                If (LNotEqual (DerefOf (Index (BUF6, Local1)), Ones))
                {
                    STBF (DerefOf (Index (BUF6, Local0)), Local2)
                    Add (Local2, 0x04, Local2)
                    STBF (DerefOf (Index (BUF6, Local1)), Local2)
                    Add (Local2, 0x04, Local2)
                }
                STBF (Ones, Local2)
                Add (Local0, 0x02, Local0)
            }
        }
        Method (STBF, 2, NotSerialized)
        {
            Store (Arg0, Local0)
            Store (Arg1, Local1)
            Store (Zero, Local2)
            While (LNotEqual (Local2, 0x20))
            {
                Store (ShiftRight (Local0, Local2), Index (ASBF, Local1))
                Add (Local2, 0x08, Local2)
                Add (Local1, One, Local1)
            }
        }
    }
    Scope (_SB.PCI0.SBRG.ASOC)
    {
        Name (G611, Package (0x07)
        {
            0x06020011, 
            "Vcore Voltage", 
            0x20000000, 
            Zero, 
            0x0320, 
            0x0320, 
            0x02
        })
        Name (G663, Package (0x07)
        {
            0x06020063, 
            "+3.3V Voltage", 
            0x20000000, 
            Zero, 
            0x0B9A, 
            0x0294, 
            0x02
        })
        Name (G662, Package (0x07)
        {
            0x06020062, 
            "+5V Voltage", 
            0x20000000, 
            Zero, 
            0x1194, 
            0x03E8, 
            0x02
        })
        Name (G661, Package (0x07)
        {
            0x06020061, 
            "+12V Voltage", 
            0x20000000, 
            Zero, 
            0x27D8, 
            0x0E10, 
            0x02
        })
        Name (G612, Package (0x07)
        {
            0x06030012, 
            "CPU Temperature", 
            0x20000000, 
            Zero, 
            0x01C2, 
            0x05, 
            0x3D
        })
        Name (G614, Package (0x07)
        {
            0x06030014, 
            "MB Temperature", 
            0x20000000, 
            Zero, 
            0x01C2, 
            0x0A, 
            0x1F
        })
        Name (G613, Package (0x07)
        {
            0x06040013, 
            "CPU Fan Speed", 
            0x20000000, 
            Zero, 
            0x0258, 
            0x19C8, 
            0x02
        })
        Name (G673, Package (0x07)
        {
            0x06040073, 
            "Chassis1 Fan Speed", 
            0x20000000, 
            Zero, 
            0x0258, 
            0x19C8, 
            0x02
        })
        Name (G683, Package (0x07)
        {
            0x06040083, 
            "Chassis2 Fan Speed", 
            0x20000000, 
            Zero, 
            0x0258, 
            0x19C8, 
            0x02
        })
        Name (G6C3, Package (0x07)
        {
            0x060400C3, 
            "Power Fan Speed", 
            0x20000000, 
            Zero, 
            Zero, 
            0x1C20, 
            0x02
        })
        Name (GRP6, Package (0x0A)
        {
            G611, 
            G663, 
            G662, 
            G661, 
            G612, 
            G614, 
            G613, 
            G673, 
            G683, 
            G6C3
        })
        Method (GIT6, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, 0x11))
            {
                Store (RVLT (Zero), ASB1)
            }
            Else
            {
                If (LEqual (T_0, 0x63))
                {
                    Store (RVLT (One), ASB1)
                }
                Else
                {
                    If (LEqual (T_0, 0x62))
                    {
                        Store (RVLT (0x02), ASB1)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x61))
                        {
                            Store (RVLT (0x03), ASB1)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x12))
                            {
                                Store (^^SIOR.HWT1 (), ASB1)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x14))
                                {
                                    Store (^^SIOR.HWT0 (), ASB1)
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x13))
                                    {
                                        Store (^^SIOR.HWF1 (), ASB1)
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x73))
                                        {
                                            Store (^^SIOR.HWF0 (), ASB1)
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x83))
                                            {
                                                Store (^^SIOR.HWF3 (), ASB1)
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0xC3))
                                                {
                                                    Store (^^SIOR.HWF2 (), ASB1)
                                                }
                                                Else
                                                {
                                                    Store (Zero, ASB0)
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        Method (SIT6, 3, NotSerialized)
        {
        }
    }
    Scope (_SB.PCI0.SBRG.ASOC)
    {
        Name (G9T0, Package (0x0C)
        {
            0x09080000, 
            "AI Overclocking", 
            Zero, 
            One, 
            0x07, 
            "Manual", 
            "Auto", 
            "Standard", 
            Zero, 
            "N.O.S.", 
            Zero, 
            "CPU Level Up"
        })
        Name (GRP9, Package (0x01)
        {
            G9T0
        })
        Method (GIT9, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, Zero))
            {
                If (LEqual (GNVS (0x56E2), Zero))
                {
                    If (LEqual (GNVS (0x343D), 0x06))
                    {
                        SNVS (0x343D, One)
                    }
                }
                Store (GNVS (0x343D), ASB1)
            }
            Else
            {
                Store (Zero, ASB0)
            }
        }
        Method (SIT9, 3, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, Zero))
            {
                If (LNotEqual (GNVS (0x343D), Arg1))
                {
                    If (And (Arg2, One))
                    {
                        If (LEqual (Arg1, 0x06))
                        {
                            If (LEqual (GNVS (0x3465), Zero))
                            {
                                Store (Zero, ASB0)
                                Return (Zero)
                            }
                        }
                        If (LEqual (GNVS (0x343D), 0x06))
                        {
                            SNVS (0x3465, Zero)
                        }
                        SNVS (0x343D, Arg1)
                    }
                    Or (ASB0, 0x02, ASB0)
                }
            }
            Else
            {
                Store (Zero, ASB0)
            }
             Return (Zero)
        }
    }
    Scope (_SB.PCI0.SBRG.ASOC)
    {
        Name (GBT0, Package (0x07)
        {
            0x0B060001, 
            "System Performance", 
            Zero, 
            Zero, 
            0x03, 
            One, 
            0x04
        })
        Name (GBT1, Package (0x07)
        {
            0x0B060002, 
            "System Performance Control", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GBT2, Package (0x07)
        {
            0x0B060003, 
            "System GUI", 
            0x08, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GBTA, Package (0x07)
        {
            0x0B060080, 
            "EPU Chip", 
            0x7000, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GBT5, Package (0x07)
        {
            0x0B060010, 
            "Level Switch", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GBT8, Package (0x07)
        {
            0x0B060022, 
            "AI Gear load line select", 
            Zero, 
            Zero, 
            Zero, 
            One, 
            0x02
        })
        Name (GBT9, Package (0x07)
        {
            0x0B060023, 
            "AI Gear CPU voltage", 
            Zero, 
            Zero, 
            Zero, 
            One, 
            0x03
        })
        Name (GRPB, Package (0x07)
        {
            GBT0, 
            GBT1, 
            GBT2, 
            GBTA, 
            GBT5, 
            GBT8, 
            GBT9
        })
        Method (GITB, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, One))
            {
                Store (And (DerefOf (Index (GBT0, 0x02)), 0xFFFF), ASB1)
            }
            Else
            {
                If (LEqual (T_0, 0x02))
                {
                    Store (DerefOf (Index (GBT1, 0x02)), ASB1)
                }
                Else
                {
                    If (LEqual (T_0, 0x03))
                    {
                        Store (DerefOf (Index (GBT2, 0x02)), ASB1)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x80))
                        {
                            Store (0x7000, ASB1)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x80))
                            {
                                Store (0x7000, ASB1)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x22))
                                {
                                    Store (GDEF (0x04), ASB1)
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x23))
                                    {
                                        Store (GDEF (0x02), ASB1)
                                    }
                                    Else
                                    {
                                        Store (Zero, ASB0)
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        Method (SITB, 3, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, One))
            {
                Name (T_1, Zero)
                Store (And (Arg2, 0xFFFF), T_1)
                If (LEqual (T_1, Zero))
                {
                    Store (And (DerefOf (Index (GBT0, 0x02)), 0xFFFF), Local0)
                    If (LEqual (Local0, Zero))
                    {
                        Store (Local0, PAR0)
                    }
                }
                Else
                {
                    If (LEqual (T_1, One))
                    {
                        And (Arg1, 0xFFFF, Local0)
                        Store (Local0, Index (GBT0, 0x02))
                        Store (SICL (Local0), ASB0)
                        Store (Local0, PAR0)
                    }
                    Else
                    {
                        Store (Zero, ASB0)
                    }
                }
            }
            Else
            {
                If (LEqual (T_0, 0x02))
                {
                    Store (And (Arg1, 0xFF), Local0)
                    If (LEqual (STCG (Local0), One))
                    {
                        Store (Local0, Index (GBT1, 0x02))
                    }
                    Else
                    {
                        Store (Zero, ASB0)
                    }
                }
                Else
                {
                    If (LEqual (T_0, 0x10))
                    {
                        Store (And (Arg1, 0xFF), Local0)
                        AGLS (Local0)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x22))
                        {
                            Store (And (Arg1, 0xFF), Local0)
                            AGLI (Local0)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x23))
                            {
                                Store (And (Arg1, 0xFF), Local0)
                                AGCV (Local0)
                            }
                            Else
                            {
                                Store (Zero, ASB0)
                            }
                        }
                    }
                }
            }
        }
    }
    Scope (_GPE)
    {
        Method (_L10, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.SBRG.ASOC, 0x05)
            If (LEqual (\_SB.PCI0.SBRG.ASOC.AIGC, One))
            {
                \_SB.PCI0.SBRG.ASOC.GITE (0x0E060001)
                \_SB.PCI0.SBRG.ASOC.SICL (Or (0x8010, \_SB.PCI0.SBRG.ASOC.ASB1))
            }
            \_SB.PCI0.SBRG.SIOR.GAUT ()
            \_SB.PCI0.SBRG.ASOC.RCAS ()
        }
    }
    OperationRegion (GPS0, SystemIO, GPBS, 0x40)
    Field (GPS0, ByteAcc, NoLock, Preserve)
    {
                Offset (0x0C), 
                Offset (0x38), 
            ,   5, 
        PWTH,   1
    }
    OperationRegion (GPS1, SystemIO, GPBS, 0x50)
    Field (GPS1, ByteAcc, NoLock, Preserve)
    {
                Offset (0x04), 
        GPSA,   8, 
        GPSB,   8, 
        GPSC,   8, 
        GPSD,   8, 
                Offset (0x0C), 
        GPLA,   8, 
        GPLB,   8, 
        GPLC,   8, 
        GPLD,   8, 
                Offset (0x34), 
        GPSE,   8, 
        GPSF,   8, 
        GPSG,   8, 
        GPSH,   8, 
        GPLE,   8, 
        GPLF,   8, 
        GPLG,   8, 
        GPLH,   8, 
                Offset (0x44), 
        GPSI,   8, 
        GPSJ,   8, 
        GPSK,   8, 
        GPSL,   8, 
        GPLI,   8, 
        GPLJ,   8, 
        GPLK,   8, 
        GPLL,   8
    }
    Scope (_SB.PCI0.SBRG.ASOC)
    {
        Name (GET1, Package (0x07)
        {
            0x0E060001, 
            "OC Status", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GET2, Package (0x07)
        {
            0x0E0A0011, 
            "ICPU Value", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GET3, Package (0x07)
        {
            0x0E020012, 
            "VCPU Value", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GET4, Package (0x07)
        {
            0x0E0B0013, 
            "PCPU Value", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GET5, Package (0x07)
        {
            0x0E0A0014, 
            "Lower Threshold1", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GET6, Package (0x07)
        {
            0x0E0A0015, 
            "Lower Threshold2", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GET7, Package (0x07)
        {
            0x0E0A0016, 
            "Lower Threshold3", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GET8, Package (0x07)
        {
            0x0E0A0017, 
            "Upper Threshold1", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GET9, Package (0x07)
        {
            0x0E0A0018, 
            "Upper Threshold2", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GETA, Package (0x07)
        {
            0x0E0A0019, 
            "Upper Threshold3", 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (GRPE, Package (0x07)
        {
            GET1, 
            GET2, 
            GET3, 
            GET4, 
            GET5, 
            GET6, 
            GET7
        })
        Name (ADP3, Package (0x0B)
        {
            0x60, 
            0xF5, 
            0xF1, 
            0x8B, 
            0x96, 
            0xEE, 
            0xEF, 
            0xF0, 
            0x03, 
            One, 
            Zero
        })
        Name (OCST, Buffer (0x04)
        {
            0x00, 0x01, 0x02, 0x03
        })
        Method (GITE, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, One))
            {
                If (^^SIOR.GATS ())
                {
                    Store (0x03, ASB1)
                }
                Else
                {
                    Store (One, ASB1)
                }
            }
            Else
            {
                If (LEqual (T_0, 0x11))
                {
                    Store (^^SIOR.HWT2 (), ASB1)
                }
                Else
                {
                    If (LEqual (T_0, 0x13))
                    {
                        Store (^^SIOR.GAUP (), ASB1)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x14))
                        {
                            Store (^^SIOR.GATH (), ASB1)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x15))
                            {
                                Store (^^SIOR.GATO (), ASB1)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x16))
                                {
                                    Store (Zero, ASB1)
                                }
                                Else
                                {
                                    Store (Zero, ASB0)
                                }
                            }
                        }
                    }
                }
            }
        }
        Method (SITE, 3, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, 0x14))
            {
                ^^SIOR.SATH (Arg1)
            }
            Else
            {
                If (LEqual (T_0, 0x15))
                {
                    ^^SIOR.SATO (Arg1)
                }
                Else
                {
                    If (LEqual (T_0, 0x16)) {}
                    Else
                    {
                        Store (Zero, ASB0)
                    }
                }
            }
        }
        Name (OMNB, Buffer (0x02)
        {
            0x00, 0x00
        })
        Name (CDTB, Buffer (0x10)
        {
            /* 0000 */    0x02, 0x03, 0x05, 0x09, 0x04, 0x06, 0x0A, 0x12, 
            /* 0008 */    0x08, 0x0C, 0x14, 0x24, 0x10, 0x18, 0x28, 0x48
        })
        Name (OMST, Buffer (0x08)
        {
            /* 0000 */    0x01, 0x00, 0x01, 0x01, 0x00, 0x00, 0x02, 0x03
        })
        Name (FSBL, Package (0x01)
        {
            Package (0x04)
            {
                0x4D, 
                0x14, 
                0x4D, 
                0x14
            }
        })
        Name (DFSB, Buffer (0x08)
        {
            /* 0000 */    0x00, 0x00, 0x0A, 0x0A, 0x05, 0x00, 0x03, 0x05
        })
        Name (OLTB, Buffer (0x14)
        {
            /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0008 */    0x00, 0x00, 0x00, 0x01, 0x01, 0x00, 0x01, 0x00, 
            /* 0010 */    0x01, 0x01, 0x00, 0x01
        })
        Name (LDLE, Package (0x04)
        {
            Package (0x03)
            {
                0x19, 
                0x19, 
                0x19
            }, 
            Package (0x03)
            {
                0x42, 
                0x42, 
                0x42
            }, 
            Package (0x03)
            {
                0x0A, 
                0x0D, 
                0x11
            }, 
            Package (0x03)
            {
                0x40, 
                0x40, 
                0x40
            }
        })
        Name (CUVR, Package (0x04)
        {
            Package (0x03)
            {
                Zero, 
                Zero, 
                Zero
            }, 
            Package (0x03)
            {
                Zero, 
                Zero, 
                Zero
            }, 
            Package (0x03)
            {
                Zero, 
                Zero, 
                Zero
            }, 
            Package (0x03)
            {
                0x41, 
                0x42, 
                0x43
            }
        })
        Name (CLKB, Buffer (0x24)
        {
            /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
            /* 0020 */    0x00, 0x00, 0x00, 0x00
        })
        CreateByteField (CLKB, Zero, CB00)
        CreateByteField (CLKB, One, CB01)
        CreateByteField (CLKB, 0x09, CB09)
        CreateByteField (CLKB, 0x0A, CB10)
        CreateByteField (CLKB, 0x0B, CB11)
        CreateByteField (CLKB, 0x0C, CB12)
        CreateWordField (CLKB, 0x0B, CBMN)
        CreateByteField (CLKB, 0x14, CB20)
        CreateByteField (CLKB, 0x16, CB22)
        CreateByteField (CLKB, 0x17, CB23)
        CreateByteField (CLKB, 0x18, CB24)
        CreateByteField (CLKB, 0x19, CB25)
        CreateByteField (CLKB, 0x1D, CB29)
        CreateByteField (CLKB, 0x1E, CB30)
        Name (FSBT, Zero)
        Name (AIGC, Zero)
        Name (PICL, One)
        Name (LVIC, Zero)
        Name (CDIV, Zero)
        Name (NBVT, Zero)
        Method (STCG, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFF), T_0)
            If (LEqual (T_0, Zero))
            {
                Store (Zero, Local0)
            }
            Else
            {
                If (LEqual (T_0, One))
                {
                    Store (Zero, Local0)
                }
                Else
                {
                    Return (Zero)
                }
            }
            Return (One)
        }
        Method (COMS, 2, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, 0x8000))
            {
                Return (And (Arg1, 0xFB, Arg1))
            }
            Else
            {
                If (LEqual (T_0, 0x4000))
                {
                    If (LEqual (DerefOf (Index (OMST, Zero)), One))
                    {
                        Return (And (Arg1, 0xFB, Arg1))
                    }
                }
                Else
                {
                    If (LEqual (T_0, Zero))
                    {
                        If (LEqual (DerefOf (Index (OMST, One)), One))
                        {
                            Return (And (Arg1, 0xFB, Arg1))
                        }
                    }
                    Else
                    {
                        If (LEqual (T_0, One))
                        {
                            If (LEqual (DerefOf (Index (OMST, 0x02)), One))
                            {
                                Return (And (Arg1, 0xFB, Arg1))
                            }
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x02))
                            {
                                If (LEqual (DerefOf (Index (OMST, 0x03)), One))
                                {
                                    Return (And (Arg1, 0xFB, Arg1))
                                }
                            }
                            Else
                            {
                                Return (Or (Arg1, 0x04, Arg1))
                            }
                        }
                    }
                }
            }
            Return (Or (Arg1, 0x04, Arg1))
        }
        Method (GDEF, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFF), T_0)
            If (LEqual (T_0, Zero))
            {
                Return (DerefOf (Index (DFSB, Add (LVIC, 0x04))))
            }
            Else
            {
                If (LEqual (T_0, One))
                {
                    Return (GVOT (One, LVIC))
                }
                Else
                {
                    If (LEqual (T_0, 0x02))
                    {
                        Return (GVOT (0x02, LVIC))
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x03))
                        {
                            Return (GVOT (0x03, LVIC))
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x04))
                            {
                                Return (GVOT (0x04, LVIC))
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x05))
                                {
                                    Return (DerefOf (Index (DFSB, Add (LVIC, 0x04))))
                                }
                                Else
                                {
                                    Return (Zero)
                                }
                            }
                        }
                    }
                }
            }
        }
        Method (CAMN, 1, NotSerialized)
        {
            If (LEqual (GNVS (0x343D), Zero))
            {
                And (DerefOf (Index (OMNB, Zero)), 0x3F, Local0)
                Store (DerefOf (Index (OMNB, One)), Local1)
                Or (ShiftLeft (Local1, 0x03, Local2), ShiftLeft (ShiftRight (DerefOf (Index (OMNB, 
                    Zero)), 0x06, Local2), One, Local2), Local1)
            }
            Else
            {
                And (DerefOf (Index (DerefOf (Index (FSBL, FSBT)), Zero)), 
                    0x3F, Local0)
                Store (DerefOf (Index (DerefOf (Index (FSBL, FSBT)), One)), 
                    Local1)
                Or (ShiftLeft (Local1, 0x03, Local2), ShiftLeft (ShiftRight (DerefOf (Index (DerefOf (
                    Index (FSBL, FSBT)), Zero)), 0x06, Local2), One, Local2), Local1)
            }
            Store (GNVS (0xA6D8), Local2)
            Multiply (0x0598, Local1, Local4)
            Divide (Local4, 0x64, Local5, Local3)
            Divide (Local3, Local0, Local5, Local3)
            Store (CDIV, Local4)
            Multiply (Arg0, Local4, Local7)
            Multiply (Multiply (Local7, Local0, Local0), 0x64, Local0)
            Divide (Local0, 0x0598, Local5, Local0)
            ShiftRight (Local0, 0x03, Local0)
            If (LGreater (Local0, 0xFF))
            {
                Return (0xFF)
            }
            Else
            {
                Return (Local0)
            }
        }
        Method (AGPU, 2, NotSerialized)
        {
            If (LGreater (Arg0, Zero))
            {
                SVOT (Zero, LVIC, CAFS (One, Arg0, Arg1))
            }
            Return (One)
        }
        Method (AGPD, 2, NotSerialized)
        {
            If (LGreater (Arg0, Zero))
            {
                SVOT (Zero, LVIC, CAFS (Zero, Arg0, Arg1))
            }
            Return (One)
        }
        Method (AGLS, 1, NotSerialized)
        {
            Store (Arg0, LVIC)
            Return (One)
        }
        Method (AGDV, 1, NotSerialized)
        {
            SVOT (0x03, LVIC, Arg0)
            Return (One)
        }
        Method (AGNV, 1, NotSerialized)
        {
            SVOT (One, LVIC, Arg0)
            Return (One)
        }
        Method (AGLI, 1, NotSerialized)
        {
            SVOT (0x04, LVIC, Arg0)
            Return (One)
        }
        Method (AGCV, 1, NotSerialized)
        {
            SVOT (0x02, LVIC, Arg0)
            Return (One)
        }
        Method (SVOT, 3, NotSerialized)
        {
            Add (Arg0, Multiply (Arg1, 0x05), Local0)
            Store (Arg2, Index (OLTB, Local0))
            Return (One)
        }
        Method (GVOT, 2, NotSerialized)
        {
            Add (Arg0, Multiply (Arg1, 0x05), Local0)
            Store (DerefOf (Index (OLTB, Local0)), Local1)
            Return (Local1)
        }
        Method (CAFS, 3, NotSerialized)
        {
            Store (GVOT (Zero, One), Local1)
            Multiply (Arg1, Arg2, Local0)
            Name (T_0, Zero)
            Store (And (Arg0, 0xFF), T_0)
            If (LEqual (T_0, Zero))
            {
                Subtract (Local1, Local0, Local0)
            }
            Else
            {
                If (LEqual (T_0, One))
                {
                    Add (Local1, Local0, Local0)
                }
            }
            Return (Local0)
        }
        Method (SICL, 1, NotSerialized)
        {
            If (And (Arg0, 0x8000))
            {
                Store (One, AIGC)
                Name (T_0, Zero)
                Store (And (Arg0, 0xFF), T_0)
                If (LEqual (T_0, Zero))
                {
                    ITAT ()
                }
                Else
                {
                    If (LEqual (T_0, 0x10))
                    {
                        SPIC (One)
                        Store (One, PICL)
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x11))
                        {
                            SPIC (One)
                            Store (One, PICL)
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x12))
                            {
                                SPIC (0x02)
                                Store (0x02, PICL)
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x13))
                                {
                                    SPIC (0x03)
                                    Store (0x03, PICL)
                                }
                                Else
                                {
                                    Return (Zero)
                                }
                            }
                        }
                    }
                }
            }
            Else
            {
                Store (Zero, AIGC)
                Name (T_1, Zero)
                Store (And (Arg0, 0xFF), T_1)
                If (LEqual (T_1, Zero))
                {
                    SPIC (One)
                    Store (One, PICL)
                }
                Else
                {
                    If (LEqual (T_1, One))
                    {
                        SPIC (0x02)
                        Store (0x02, PICL)
                    }
                    Else
                    {
                        If (LEqual (T_1, 0x02))
                        {
                            SPIC (0x03)
                            Store (0x03, PICL)
                        }
                        Else
                        {
                            Return (Zero)
                        }
                    }
                }
            }
            Return (One)
        }
        Name (PSLB, Package (0x04)
        {
            Package (0x03)
            {
                0xFF, 
                0xFF, 
                0xFF
            }, 
            Package (0x03)
            {
                0xFF, 
                0xFF, 
                0xFF
            }, 
            Package (0x03)
            {
                0xFF, 
                0xFF, 
                0xFF
            }, 
            Package (0x03)
            {
                0xFF, 
                0xFF, 
                0xFF
            }
        })
        Name (PSLV, Package (0x04)
        {
            Package (0x02)
            {
                0x04F6, 
                0x04E2
            }, 
            Package (0x02)
            {
                0x04F6, 
                0x04E2
            }, 
            Package (0x02)
            {
                0x39, 
                0x35
            }, 
            Package (0x02)
            {
                0x39, 
                0x35
            }
        })
        Name (MNTD, Package (0x02)
        {
            Package (0x04)
            {
                0x03, 
                0x46, 
                0x012C, 
                0x85
            }, 
            Package (0x04)
            {
                0x03, 
                0x012D, 
                0x01F4, 
                0x0190
            }
        })
        Name (MND3, Package (0xE7)
        {
            Package (0x03)
            {
                0x49, 
                0x07, 
                0xD2
            }, 
            Package (0x03)
            {
                0x8F, 
                0x0C, 
                0xD5
            }, 
            Package (0x03)
            {
                0x0C, 
                0x0A, 
                0xD8
            }, 
            Package (0x03)
            {
                0x0D, 
                0x0B, 
                0xDB
            }, 
            Package (0x03)
            {
                0x0F, 
                0x0D, 
                0xDE
            }, 
            Package (0x03)
            {
                0x0F, 
                0x0D, 
                0xE1
            }, 
            Package (0x03)
            {
                0x08, 
                0x07, 
                0xE4
            }, 
            Package (0x03)
            {
                0x09, 
                0x08, 
                0xE7
            }, 
            Package (0x03)
            {
                0xCD, 
                0x0B, 
                0xEA
            }, 
            Package (0x03)
            {
                0xCF, 
                0x0D, 
                0xED
            }, 
            Package (0x03)
            {
                0x0F, 
                0x0E, 
                0xF0
            }, 
            Package (0x03)
            {
                0x4D, 
                0x0C, 
                0xF3
            }, 
            Package (0x03)
            {
                0x8A, 
                0x09, 
                0xF6
            }, 
            Package (0x03)
            {
                0x8F, 
                0x0E, 
                0xF9
            }, 
            Package (0x03)
            {
                0xCA, 
                0x09, 
                0xFC
            }, 
            Package (0x03)
            {
                0xD0, 
                0x0F, 
                0xFF
            }, 
            Package (0x03)
            {
                0x0B, 
                0x0B, 
                0x0102
            }, 
            Package (0x03)
            {
                0x50, 
                0x10, 
                0x0105
            }, 
            Package (0x03)
            {
                0x4B, 
                0x0B, 
                0x0108
            }, 
            Package (0x03)
            {
                0x48, 
                0x08, 
                0x010B
            }, 
            Package (0x03)
            {
                0xCF, 
                0x0F, 
                0x010E
            }, 
            Package (0x03)
            {
                0x89, 
                0x09, 
                0x0111
            }, 
            Package (0x03)
            {
                0x0E, 
                0x0F, 
                0x0114
            }, 
            Package (0x03)
            {
                0x0C, 
                0x0D, 
                0x0117
            }, 
            Package (0x03)
            {
                0x86, 
                0x06, 
                0x011A
            }, 
            Package (0x03)
            {
                0xD0, 
                0x11, 
                0x011D
            }, 
            Package (0x03)
            {
                0xCF, 
                0x10, 
                0x0120
            }, 
            Package (0x03)
            {
                0x08, 
                0x09, 
                0x0123
            }, 
            Package (0x03)
            {
                0x0E, 
                0x10, 
                0x0126
            }, 
            Package (0x03)
            {
                0x0D, 
                0x0F, 
                0x0129
            }, 
            Package (0x03)
            {
                0x8F, 
                0x11, 
                0x012C
            }, 
            Package (0x03)
            {
                0x8E, 
                0x10, 
                0x012F
            }, 
            Package (0x03)
            {
                0x4C, 
                0x0E, 
                0x0132
            }, 
            Package (0x03)
            {
                0x50, 
                0x13, 
                0x0135
            }, 
            Package (0x03)
            {
                0x0E, 
                0x11, 
                0x0138
            }, 
            Package (0x03)
            {
                0xC8, 
                0x09, 
                0x013B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x13, 
                0x013E
            }, 
            Package (0x03)
            {
                0x10, 
                0x14, 
                0x0141
            }, 
            Package (0x03)
            {
                0x86, 
                0x07, 
                0x0144
            }, 
            Package (0x03)
            {
                0x4C, 
                0x0F, 
                0x0147
            }, 
            Package (0x03)
            {
                0x4F, 
                0x13, 
                0x014A
            }, 
            Package (0x03)
            {
                0xD0, 
                0x14, 
                0x014D
            }, 
            Package (0x03)
            {
                0x0D, 
                0x11, 
                0x0150
            }, 
            Package (0x03)
            {
                0x88, 
                0x0A, 
                0x0153
            }, 
            Package (0x03)
            {
                0x47, 
                0x09, 
                0x0156
            }, 
            Package (0x03)
            {
                0x90, 
                0x15, 
                0x0159
            }, 
            Package (0x03)
            {
                0x8A, 
                0x0D, 
                0x015C
            }, 
            Package (0x03)
            {
                0x8F, 
                0x14, 
                0x015F
            }, 
            Package (0x03)
            {
                0xCA, 
                0x0D, 
                0x0162
            }, 
            Package (0x03)
            {
                0x50, 
                0x16, 
                0x0165
            }, 
            Package (0x03)
            {
                0xC7, 
                0x09, 
                0x0168
            }, 
            Package (0x03)
            {
                0x48, 
                0x0B, 
                0x016B
            }, 
            Package (0x03)
            {
                0x8D, 
                0x12, 
                0x016E
            }, 
            Package (0x03)
            {
                0x10, 
                0x17, 
                0x0171
            }, 
            Package (0x03)
            {
                0xCF, 
                0x15, 
                0x0174
            }, 
            Package (0x03)
            {
                0x8C, 
                0x11, 
                0x0177
            }, 
            Package (0x03)
            {
                0x47, 
                0x0A, 
                0x017A
            }, 
            Package (0x03)
            {
                0xD0, 
                0x17, 
                0x017D
            }, 
            Package (0x03)
            {
                0x10, 
                0x18, 
                0x0180
            }, 
            Package (0x03)
            {
                0x08, 
                0x0C, 
                0x0183
            }, 
            Package (0x03)
            {
                0xC9, 
                0x0D, 
                0x0186
            }, 
            Package (0x03)
            {
                0x90, 
                0x18, 
                0x0189
            }, 
            Package (0x03)
            {
                0x8C, 
                0x12, 
                0x018C
            }, 
            Package (0x03)
            {
                0x4D, 
                0x14, 
                0x0190
            }, 
            Package (0x03)
            {
                0xCC, 
                0x12, 
                0x0192
            }, 
            Package (0x03)
            {
                0x50, 
                0x19, 
                0x0195
            }, 
            Package (0x03)
            {
                0x49, 
                0x0E, 
                0x0198
            }, 
            Package (0x03)
            {
                0x0F, 
                0x18, 
                0x019B
            }, 
            Package (0x03)
            {
                0x4F, 
                0x18, 
                0x019E
            }, 
            Package (0x03)
            {
                0x10, 
                0x1A, 
                0x01A1
            }, 
            Package (0x03)
            {
                0x4D, 
                0x15, 
                0x01A4
            }, 
            Package (0x03)
            {
                0xCF, 
                0x18, 
                0x01A7
            }, 
            Package (0x03)
            {
                0x4E, 
                0x17, 
                0x01AA
            }, 
            Package (0x03)
            {
                0x09, 
                0x0F, 
                0x01AD
            }, 
            Package (0x03)
            {
                0x8B, 
                0x12, 
                0x01B0
            }, 
            Package (0x03)
            {
                0xCE, 
                0x17, 
                0x01B3
            }, 
            Package (0x03)
            {
                0xCB, 
                0x12, 
                0x01B6
            }, 
            Package (0x03)
            {
                0x90, 
                0x1B, 
                0x01B9
            }, 
            Package (0x03)
            {
                0xCC, 
                0x14, 
                0x01BC
            }, 
            Package (0x03)
            {
                0x10, 
                0x1C, 
                0x01BF
            }, 
            Package (0x03)
            {
                0xC9, 
                0x0F, 
                0x01C2
            }, 
            Package (0x03)
            {
                0x8F, 
                0x1A, 
                0x01C5
            }, 
            Package (0x03)
            {
                0xCA, 
                0x11, 
                0x01C8
            }, 
            Package (0x03)
            {
                0x4D, 
                0x17, 
                0x01CB
            }, 
            Package (0x03)
            {
                0x0F, 
                0x1B, 
                0x01CE
            }, 
            Package (0x03)
            {
                0xCC, 
                0x15, 
                0x01D1
            }, 
            Package (0x03)
            {
                0x50, 
                0x1D, 
                0x01D4
            }, 
            Package (0x03)
            {
                0x0C, 
                0x16, 
                0x01D7
            }, 
            Package (0x03)
            {
                0x0D, 
                0x18, 
                0x01DA
            }, 
            Package (0x03)
            {
                0xD0, 
                0x1D, 
                0x01DD
            }, 
            Package (0x03)
            {
                0x10, 
                0x1E, 
                0x01E0
            }, 
            Package (0x03)
            {
                0x4F, 
                0x1C, 
                0x01E3
            }, 
            Package (0x03)
            {
                0x09, 
                0x11, 
                0x01E6
            }, 
            Package (0x03)
            {
                0x90, 
                0x1E, 
                0x01E9
            }, 
            Package (0x03)
            {
                0x0C, 
                0x17, 
                0x01EC
            }, 
            Package (0x03)
            {
                0x0E, 
                0x1B, 
                0x01EF
            }, 
            Package (0x03)
            {
                0x4D, 
                0x19, 
                0x01F2
            }, 
            Package (0x03)
            {
                0x8A, 
                0x13, 
                0x01F5
            }, 
            Package (0x03)
            {
                0x8F, 
                0x1D, 
                0x01F8
            }, 
            Package (0x03)
            {
                0xC9, 
                0x11, 
                0x01FB
            }, 
            Package (0x03)
            {
                0x10, 
                0x20, 
                0x01FE
            }, 
            Package (0x03)
            {
                0x0D, 
                0x1A, 
                0x0201
            }, 
            Package (0x03)
            {
                0x06, 
                0x0C, 
                0x0204
            }, 
            Package (0x03)
            {
                0x4B, 
                0x16, 
                0x0207
            }, 
            Package (0x03)
            {
                0x8E, 
                0x1C, 
                0x020A
            }, 
            Package (0x03)
            {
                0x8B, 
                0x16, 
                0x020D
            }, 
            Package (0x03)
            {
                0x89, 
                0x12, 
                0x0210
            }, 
            Package (0x03)
            {
                0x0E, 
                0x1D, 
                0x0213
            }, 
            Package (0x03)
            {
                0x4F, 
                0x1F, 
                0x0216
            }, 
            Package (0x03)
            {
                0x86, 
                0x0C, 
                0x0219
            }, 
            Package (0x03)
            {
                0x8E, 
                0x1D, 
                0x021C
            }, 
            Package (0x03)
            {
                0xCF, 
                0x1F, 
                0x021F
            }, 
            Package (0x03)
            {
                0x4A, 
                0x15, 
                0x0222
            }, 
            Package (0x03)
            {
                0x0E, 
                0x1E, 
                0x0225
            }, 
            Package (0x03)
            {
                0x8A, 
                0x15, 
                0x0228
            }, 
            Package (0x03)
            {
                0x8F, 
                0x20, 
                0x022B
            }, 
            Package (0x03)
            {
                0x8E, 
                0x1E, 
                0x022E
            }, 
            Package (0x03)
            {
                0x4C, 
                0x1A, 
                0x0231
            }, 
            Package (0x03)
            {
                0x50, 
                0x23, 
                0x0234
            }, 
            Package (0x03)
            {
                0xCD, 
                0x1C, 
                0x0237
            }, 
            Package (0x03)
            {
                0x87, 
                0x0F, 
                0x023A
            }, 
            Package (0x03)
            {
                0xD0, 
                0x23, 
                0x023D
            }, 
            Package (0x03)
            {
                0x10, 
                0x24, 
                0x0240
            }, 
            Package (0x03)
            {
                0xC7, 
                0x0F, 
                0x0243
            }, 
            Package (0x03)
            {
                0x4C, 
                0x1B, 
                0x0246
            }, 
            Package (0x03)
            {
                0x4F, 
                0x22, 
                0x0249
            }, 
            Package (0x03)
            {
                0x07, 
                0x10, 
                0x024C
            }, 
            Package (0x03)
            {
                0xCF, 
                0x22, 
                0x024F
            }, 
            Package (0x03)
            {
                0x88, 
                0x12, 
                0x0252
            }, 
            Package (0x03)
            {
                0x47, 
                0x10, 
                0x0255
            }, 
            Package (0x03)
            {
                0x90, 
                0x25, 
                0x0258
            }, 
            Package (0x03)
            {
                0x8A, 
                0x17, 
                0x025B
            }, 
            Package (0x03)
            {
                0x8F, 
                0x23, 
                0x025E
            }, 
            Package (0x03)
            {
                0x8C, 
                0x1C, 
                0x0261
            }, 
            Package (0x03)
            {
                0x4B, 
                0x1A, 
                0x0264
            }, 
            Package (0x03)
            {
                0x8B, 
                0x1A, 
                0x0267
            }, 
            Package (0x03)
            {
                0x48, 
                0x13, 
                0x026A
            }, 
            Package (0x03)
            {
                0x8D, 
                0x1F, 
                0x026D
            }, 
            Package (0x03)
            {
                0x10, 
                0x27, 
                0x0270
            }, 
            Package (0x03)
            {
                0x4E, 
                0x22, 
                0x0273
            }, 
            Package (0x03)
            {
                0x8C, 
                0x1D, 
                0x0276
            }, 
            Package (0x03)
            {
                0xC6, 
                0x0E, 
                0x0279
            }, 
            Package (0x03)
            {
                0x4F, 
                0x25, 
                0x027C
            }, 
            Package (0x03)
            {
                0x10, 
                0x28, 
                0x027F
            }, 
            Package (0x03)
            {
                0x08, 
                0x14, 
                0x0282
            }, 
            Package (0x03)
            {
                0x4E, 
                0x23, 
                0x0285
            }, 
            Package (0x03)
            {
                0x4C, 
                0x1E, 
                0x0288
            }, 
            Package (0x03)
            {
                0x0F, 
                0x26, 
                0x028B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x28, 
                0x028E
            }, 
            Package (0x03)
            {
                0x4D, 
                0x21, 
                0x0291
            }, 
            Package (0x03)
            {
                0x88, 
                0x14, 
                0x0294
            }, 
            Package (0x03)
            {
                0x07, 
                0x12, 
                0x0297
            }, 
            Package (0x03)
            {
                0x90, 
                0x29, 
                0x029A
            }, 
            Package (0x03)
            {
                0x0A, 
                0x1A, 
                0x029D
            }, 
            Package (0x03)
            {
                0x4F, 
                0x27, 
                0x02A0
            }, 
            Package (0x03)
            {
                0x4A, 
                0x1A, 
                0x02A3
            }, 
            Package (0x03)
            {
                0x50, 
                0x2A, 
                0x02A6
            }, 
            Package (0x03)
            {
                0x87, 
                0x12, 
                0x02A9
            }, 
            Package (0x03)
            {
                0x48, 
                0x15, 
                0x02AC
            }, 
            Package (0x03)
            {
                0xCD, 
                0x22, 
                0x02AF
            }, 
            Package (0x03)
            {
                0x10, 
                0x2B, 
                0x02B2
            }, 
            Package (0x03)
            {
                0x8F, 
                0x28, 
                0x02B5
            }, 
            Package (0x03)
            {
                0x8C, 
                0x20, 
                0x02B8
            }, 
            Package (0x03)
            {
                0x46, 
                0x10, 
                0x02BB
            }, 
            Package (0x03)
            {
                0xD0, 
                0x2B, 
                0x02BE
            }, 
            Package (0x03)
            {
                0x10, 
                0x2C, 
                0x02C1
            }, 
            Package (0x03)
            {
                0x08, 
                0x16, 
                0x02C4
            }, 
            Package (0x03)
            {
                0xCE, 
                0x26, 
                0x02C7
            }, 
            Package (0x03)
            {
                0x90, 
                0x2C, 
                0x02CA
            }, 
            Package (0x03)
            {
                0x8C, 
                0x21, 
                0x02CD
            }, 
            Package (0x03)
            {
                0x4E, 
                0x27, 
                0x02D0
            }, 
            Package (0x03)
            {
                0x4F, 
                0x2A, 
                0x02D3
            }, 
            Package (0x03)
            {
                0x50, 
                0x2D, 
                0x02D6
            }, 
            Package (0x03)
            {
                0x89, 
                0x19, 
                0x02D9
            }, 
            Package (0x03)
            {
                0xC8, 
                0x16, 
                0x02DC
            }, 
            Package (0x03)
            {
                0x0F, 
                0x2B, 
                0x02DF
            }, 
            Package (0x03)
            {
                0x10, 
                0x2E, 
                0x02E2
            }, 
            Package (0x03)
            {
                0x8D, 
                0x25, 
                0x02E5
            }, 
            Package (0x03)
            {
                0xCC, 
                0x22, 
                0x02E8
            }, 
            Package (0x03)
            {
                0xCE, 
                0x28, 
                0x02EB
            }, 
            Package (0x03)
            {
                0xD0, 
                0x2E, 
                0x02EE
            }, 
            Package (0x03)
            {
                0x0F, 
                0x2C, 
                0x02F1
            }, 
            Package (0x03)
            {
                0x88, 
                0x17, 
                0x02F4
            }, 
            Package (0x03)
            {
                0x8B, 
                0x20, 
                0x02F7
            }, 
            Package (0x03)
            {
                0x90, 
                0x2F, 
                0x02FA
            }, 
            Package (0x03)
            {
                0xCB, 
                0x20, 
                0x02FD
            }, 
            Package (0x03)
            {
                0x10, 
                0x30, 
                0x0300
            }, 
            Package (0x03)
            {
                0x0B, 
                0x21, 
                0x0303
            }, 
            Package (0x03)
            {
                0x50, 
                0x30, 
                0x0306
            }, 
            Package (0x03)
            {
                0x4B, 
                0x21, 
                0x0309
            }, 
            Package (0x03)
            {
                0xD0, 
                0x30, 
                0x030C
            }, 
            Package (0x03)
            {
                0xCF, 
                0x2D, 
                0x030F
            }, 
            Package (0x03)
            {
                0x10, 
                0x31, 
                0x0312
            }, 
            Package (0x03)
            {
                0x0E, 
                0x2B, 
                0x0315
            }, 
            Package (0x03)
            {
                0x90, 
                0x31, 
                0x0318
            }, 
            Package (0x03)
            {
                0x4D, 
                0x28, 
                0x031B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x31, 
                0x031E
            }, 
            Package (0x03)
            {
                0xCF, 
                0x2E, 
                0x0321
            }, 
            Package (0x03)
            {
                0x50, 
                0x32, 
                0x0324
            }, 
            Package (0x03)
            {
                0x49, 
                0x1C, 
                0x0327
            }, 
            Package (0x03)
            {
                0x90, 
                0x32, 
                0x032A
            }, 
            Package (0x03)
            {
                0x8F, 
                0x2F, 
                0x032D
            }, 
            Package (0x03)
            {
                0x10, 
                0x33, 
                0x0330
            }, 
            Package (0x03)
            {
                0x4C, 
                0x26, 
                0x0333
            }, 
            Package (0x03)
            {
                0x50, 
                0x33, 
                0x0336
            }, 
            Package (0x03)
            {
                0x0E, 
                0x2D, 
                0x0339
            }, 
            Package (0x03)
            {
                0xD0, 
                0x33, 
                0x033C
            }, 
            Package (0x03)
            {
                0xD0, 
                0x33, 
                0x033F
            }, 
            Package (0x03)
            {
                0x10, 
                0x34, 
                0x0342
            }, 
            Package (0x03)
            {
                0x86, 
                0x13, 
                0x0345
            }, 
            Package (0x03)
            {
                0x90, 
                0x34, 
                0x0348
            }, 
            Package (0x03)
            {
                0x4F, 
                0x31, 
                0x034B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x34, 
                0x034E
            }, 
            Package (0x03)
            {
                0x0D, 
                0x2B, 
                0x0351
            }, 
            Package (0x03)
            {
                0x50, 
                0x35, 
                0x0354
            }, 
            Package (0x03)
            {
                0x47, 
                0x17, 
                0x0357
            }, 
            Package (0x03)
            {
                0x90, 
                0x35, 
                0x035A
            }, 
            Package (0x03)
            {
                0x8A, 
                0x21, 
                0x035D
            }, 
            Package (0x03)
            {
                0x10, 
                0x36, 
                0x0360
            }, 
            Package (0x03)
            {
                0xCA, 
                0x21, 
                0x0363
            }, 
            Package (0x03)
            {
                0x50, 
                0x36, 
                0x0366
            }, 
            Package (0x03)
            {
                0xC7, 
                0x17, 
                0x0369
            }, 
            Package (0x03)
            {
                0xD0, 
                0x36, 
                0x036C
            }, 
            Package (0x03)
            {
                0x8D, 
                0x2C, 
                0x036F
            }, 
            Package (0x03)
            {
                0x10, 
                0x37, 
                0x0372
            }, 
            Package (0x03)
            {
                0xCF, 
                0x33, 
                0x0375
            }, 
            Package (0x03)
            {
                0x90, 
                0x37, 
                0x0378
            }, 
            Package (0x03)
            {
                0xC6, 
                0x14, 
                0x037B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x37, 
                0x037E
            }, 
            Package (0x03)
            {
                0x10, 
                0x38, 
                0x0381
            }, 
            Package (0x03)
            {
                0x50, 
                0x38, 
                0x0384
            }
        })
        Name (MN31, Package (0xC8)
        {
            Package (0x03)
            {
                0x4E, 
                0x31, 
                0x0387
            }, 
            Package (0x03)
            {
                0x90, 
                0x38, 
                0x038A
            }, 
            Package (0x03)
            {
                0x8C, 
                0x2A, 
                0x038D
            }, 
            Package (0x03)
            {
                0x10, 
                0x39, 
                0x0390
            }, 
            Package (0x03)
            {
                0x8F, 
                0x35, 
                0x0393
            }, 
            Package (0x03)
            {
                0x50, 
                0x39, 
                0x0396
            }, 
            Package (0x03)
            {
                0x49, 
                0x20, 
                0x0399
            }, 
            Package (0x03)
            {
                0xD0, 
                0x39, 
                0x039C
            }, 
            Package (0x03)
            {
                0x4F, 
                0x36, 
                0x039F
            }, 
            Package (0x03)
            {
                0x10, 
                0x3A, 
                0x03A2
            }, 
            Package (0x03)
            {
                0x4D, 
                0x2F, 
                0x03A5
            }, 
            Package (0x03)
            {
                0x90, 
                0x3A, 
                0x03A8
            }, 
            Package (0x03)
            {
                0x4E, 
                0x33, 
                0x03AB
            }, 
            Package (0x03)
            {
                0xD0, 
                0x3A, 
                0x03AE
            }, 
            Package (0x03)
            {
                0x4F, 
                0x37, 
                0x03B1
            }, 
            Package (0x03)
            {
                0x50, 
                0x3B, 
                0x03B4
            }, 
            Package (0x03)
            {
                0xCB, 
                0x28, 
                0x03B7
            }, 
            Package (0x03)
            {
                0x90, 
                0x3B, 
                0x03BA
            }, 
            Package (0x03)
            {
                0x0B, 
                0x29, 
                0x03BD
            }, 
            Package (0x03)
            {
                0x10, 
                0x3C, 
                0x03C0
            }, 
            Package (0x03)
            {
                0x4B, 
                0x29, 
                0x03C3
            }, 
            Package (0x03)
            {
                0x50, 
                0x3C, 
                0x03C6
            }, 
            Package (0x03)
            {
                0x8B, 
                0x29, 
                0x03C9
            }, 
            Package (0x03)
            {
                0xD0, 
                0x3C, 
                0x03CC
            }, 
            Package (0x03)
            {
                0x0F, 
                0x39, 
                0x03CF
            }, 
            Package (0x03)
            {
                0x10, 
                0x3D, 
                0x03D2
            }, 
            Package (0x03)
            {
                0x8E, 
                0x35, 
                0x03D5
            }, 
            Package (0x03)
            {
                0x90, 
                0x3D, 
                0x03D8
            }, 
            Package (0x03)
            {
                0x0D, 
                0x32, 
                0x03DB
            }, 
            Package (0x03)
            {
                0xD0, 
                0x3D, 
                0x03DE
            }, 
            Package (0x03)
            {
                0x0F, 
                0x3A, 
                0x03E1
            }, 
            Package (0x03)
            {
                0x50, 
                0x3E, 
                0x03E4
            }, 
            Package (0x03)
            {
                0x09, 
                0x23, 
                0x03E7
            }, 
            Package (0x03)
            {
                0x90, 
                0x3E, 
                0x03EA
            }, 
            Package (0x03)
            {
                0xCF, 
                0x3A, 
                0x03ED
            }, 
            Package (0x03)
            {
                0x10, 
                0x3F, 
                0x03F0
            }, 
            Package (0x03)
            {
                0x4C, 
                0x2F, 
                0x03F3
            }, 
            Package (0x03)
            {
                0x50, 
                0x3F, 
                0x03F6
            }, 
            Package (0x03)
            {
                0x8E, 
                0x37, 
                0x03F9
            }, 
            Package (0x03)
            {
                0xD0, 
                0x3F, 
                0x03FC
            }, 
            Package (0x03)
            {
                0xD0, 
                0x3F, 
                0x03FF
            }, 
            Package (0x03)
            {
                0x10, 
                0x40, 
                0x0402
            }, 
            Package (0x03)
            {
                0x06, 
                0x18, 
                0x0405
            }, 
            Package (0x03)
            {
                0x90, 
                0x40, 
                0x0408
            }, 
            Package (0x03)
            {
                0x8F, 
                0x3C, 
                0x040B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x40, 
                0x040E
            }, 
            Package (0x03)
            {
                0xCD, 
                0x34, 
                0x0411
            }, 
            Package (0x03)
            {
                0x50, 
                0x41, 
                0x0414
            }, 
            Package (0x03)
            {
                0x87, 
                0x1C, 
                0x0417
            }, 
            Package (0x03)
            {
                0x90, 
                0x41, 
                0x041A
            }, 
            Package (0x03)
            {
                0x0A, 
                0x29, 
                0x041D
            }, 
            Package (0x03)
            {
                0x10, 
                0x42, 
                0x0420
            }, 
            Package (0x03)
            {
                0x4A, 
                0x29, 
                0x0423
            }, 
            Package (0x03)
            {
                0x50, 
                0x42, 
                0x0426
            }, 
            Package (0x03)
            {
                0x07, 
                0x1D, 
                0x0429
            }, 
            Package (0x03)
            {
                0xD0, 
                0x42, 
                0x042C
            }, 
            Package (0x03)
            {
                0x4D, 
                0x36, 
                0x042F
            }, 
            Package (0x03)
            {
                0x10, 
                0x43, 
                0x0432
            }, 
            Package (0x03)
            {
                0x0F, 
                0x3F, 
                0x0435
            }, 
            Package (0x03)
            {
                0x90, 
                0x43, 
                0x0438
            }, 
            Package (0x03)
            {
                0x46, 
                0x19, 
                0x043B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x43, 
                0x043E
            }, 
            Package (0x03)
            {
                0x10, 
                0x44, 
                0x0441
            }, 
            Package (0x03)
            {
                0x50, 
                0x44, 
                0x0444
            }, 
            Package (0x03)
            {
                0xCE, 
                0x3B, 
                0x0447
            }, 
            Package (0x03)
            {
                0x90, 
                0x44, 
                0x044A
            }, 
            Package (0x03)
            {
                0x8C, 
                0x33, 
                0x044D
            }, 
            Package (0x03)
            {
                0x10, 
                0x45, 
                0x0450
            }, 
            Package (0x03)
            {
                0xCF, 
                0x40, 
                0x0453
            }, 
            Package (0x03)
            {
                0x50, 
                0x45, 
                0x0456
            }, 
            Package (0x03)
            {
                0x09, 
                0x27, 
                0x0459
            }, 
            Package (0x03)
            {
                0xD0, 
                0x45, 
                0x045C
            }, 
            Package (0x03)
            {
                0x8F, 
                0x41, 
                0x045F
            }, 
            Package (0x03)
            {
                0x10, 
                0x46, 
                0x0462
            }, 
            Package (0x03)
            {
                0x0D, 
                0x39, 
                0x0465
            }, 
            Package (0x03)
            {
                0x90, 
                0x46, 
                0x0468
            }, 
            Package (0x03)
            {
                0xCE, 
                0x3D, 
                0x046B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x46, 
                0x046E
            }, 
            Package (0x03)
            {
                0x8F, 
                0x42, 
                0x0471
            }, 
            Package (0x03)
            {
                0x50, 
                0x47, 
                0x0474
            }, 
            Package (0x03)
            {
                0x0B, 
                0x31, 
                0x0477
            }, 
            Package (0x03)
            {
                0x90, 
                0x47, 
                0x047A
            }, 
            Package (0x03)
            {
                0x4B, 
                0x31, 
                0x047D
            }, 
            Package (0x03)
            {
                0x10, 
                0x48, 
                0x0480
            }, 
            Package (0x03)
            {
                0x8B, 
                0x31, 
                0x0483
            }, 
            Package (0x03)
            {
                0x50, 
                0x48, 
                0x0486
            }, 
            Package (0x03)
            {
                0xCB, 
                0x31, 
                0x0489
            }, 
            Package (0x03)
            {
                0xD0, 
                0x48, 
                0x048C
            }, 
            Package (0x03)
            {
                0x4F, 
                0x44, 
                0x048F
            }, 
            Package (0x03)
            {
                0x10, 
                0x49, 
                0x0492
            }, 
            Package (0x03)
            {
                0x0E, 
                0x40, 
                0x0495
            }, 
            Package (0x03)
            {
                0x90, 
                0x49, 
                0x0498
            }, 
            Package (0x03)
            {
                0xCD, 
                0x3B, 
                0x049B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x49, 
                0x049E
            }, 
            Package (0x03)
            {
                0x4F, 
                0x45, 
                0x04A1
            }, 
            Package (0x03)
            {
                0x50, 
                0x4A, 
                0x04A4
            }, 
            Package (0x03)
            {
                0xC9, 
                0x29, 
                0x04A7
            }, 
            Package (0x03)
            {
                0x90, 
                0x4A, 
                0x04AA
            }, 
            Package (0x03)
            {
                0x0F, 
                0x46, 
                0x04AD
            }, 
            Package (0x03)
            {
                0x10, 
                0x4B, 
                0x04B0
            }, 
            Package (0x03)
            {
                0x4C, 
                0x38, 
                0x04B3
            }, 
            Package (0x03)
            {
                0x50, 
                0x4B, 
                0x04B6
            }, 
            Package (0x03)
            {
                0x0E, 
                0x42, 
                0x04B9
            }, 
            Package (0x03)
            {
                0xD0, 
                0x4B, 
                0x04BC
            }, 
            Package (0x03)
            {
                0xD0, 
                0x4B, 
                0x04BF
            }, 
            Package (0x03)
            {
                0x10, 
                0x4C, 
                0x04C2
            }, 
            Package (0x03)
            {
                0x86, 
                0x1C, 
                0x04C5
            }, 
            Package (0x03)
            {
                0x90, 
                0x4C, 
                0x04C8
            }, 
            Package (0x03)
            {
                0xCF, 
                0x47, 
                0x04CB
            }, 
            Package (0x03)
            {
                0xD0, 
                0x4C, 
                0x04CE
            }, 
            Package (0x03)
            {
                0x8D, 
                0x3E, 
                0x04D1
            }, 
            Package (0x03)
            {
                0x50, 
                0x4D, 
                0x04D4
            }, 
            Package (0x03)
            {
                0xC7, 
                0x21, 
                0x04D7
            }, 
            Package (0x03)
            {
                0x90, 
                0x4D, 
                0x04DA
            }, 
            Package (0x03)
            {
                0x8A, 
                0x30, 
                0x04DD
            }, 
            Package (0x03)
            {
                0x10, 
                0x4E, 
                0x04E0
            }, 
            Package (0x03)
            {
                0xCA, 
                0x30, 
                0x04E3
            }, 
            Package (0x03)
            {
                0x50, 
                0x4E, 
                0x04E6
            }, 
            Package (0x03)
            {
                0x47, 
                0x22, 
                0x04E9
            }, 
            Package (0x03)
            {
                0xD0, 
                0x4E, 
                0x04EC
            }, 
            Package (0x03)
            {
                0x0D, 
                0x40, 
                0x04EF
            }, 
            Package (0x03)
            {
                0x10, 
                0x4F, 
                0x04F2
            }, 
            Package (0x03)
            {
                0x4F, 
                0x4A, 
                0x04F5
            }, 
            Package (0x03)
            {
                0x90, 
                0x4F, 
                0x04F8
            }, 
            Package (0x03)
            {
                0xC6, 
                0x1D, 
                0x04FB
            }, 
            Package (0x03)
            {
                0xD0, 
                0x4F, 
                0x04FE
            }, 
            Package (0x03)
            {
                0x10, 
                0x50, 
                0x0501
            }, 
            Package (0x03)
            {
                0x50, 
                0x50, 
                0x0504
            }, 
            Package (0x03)
            {
                0x4E, 
                0x46, 
                0x0507
            }, 
            Package (0x03)
            {
                0x90, 
                0x50, 
                0x050A
            }, 
            Package (0x03)
            {
                0x8C, 
                0x3C, 
                0x050D
            }, 
            Package (0x03)
            {
                0x10, 
                0x51, 
                0x0510
            }, 
            Package (0x03)
            {
                0x0F, 
                0x4C, 
                0x0513
            }, 
            Package (0x03)
            {
                0x50, 
                0x51, 
                0x0516
            }, 
            Package (0x03)
            {
                0xC9, 
                0x2D, 
                0x0519
            }, 
            Package (0x03)
            {
                0xD0, 
                0x51, 
                0x051C
            }, 
            Package (0x03)
            {
                0xCF, 
                0x4C, 
                0x051F
            }, 
            Package (0x03)
            {
                0x10, 
                0x52, 
                0x0522
            }, 
            Package (0x03)
            {
                0xCD, 
                0x42, 
                0x0525
            }, 
            Package (0x03)
            {
                0x90, 
                0x52, 
                0x0528
            }, 
            Package (0x03)
            {
                0x4E, 
                0x48, 
                0x052B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x52, 
                0x052E
            }, 
            Package (0x03)
            {
                0xCF, 
                0x4D, 
                0x0531
            }, 
            Package (0x03)
            {
                0x50, 
                0x53, 
                0x0534
            }, 
            Package (0x03)
            {
                0x4B, 
                0x39, 
                0x0537
            }, 
            Package (0x03)
            {
                0x90, 
                0x53, 
                0x053A
            }, 
            Package (0x03)
            {
                0x8B, 
                0x39, 
                0x053D
            }, 
            Package (0x03)
            {
                0x10, 
                0x54, 
                0x0540
            }, 
            Package (0x03)
            {
                0xCB, 
                0x39, 
                0x0543
            }, 
            Package (0x03)
            {
                0x50, 
                0x54, 
                0x0546
            }, 
            Package (0x03)
            {
                0x0B, 
                0x3A, 
                0x0549
            }, 
            Package (0x03)
            {
                0xD0, 
                0x54, 
                0x054C
            }, 
            Package (0x03)
            {
                0x8F, 
                0x4F, 
                0x054F
            }, 
            Package (0x03)
            {
                0x10, 
                0x55, 
                0x0552
            }, 
            Package (0x03)
            {
                0x8E, 
                0x4A, 
                0x0555
            }, 
            Package (0x03)
            {
                0x90, 
                0x55, 
                0x0558
            }, 
            Package (0x03)
            {
                0x8D, 
                0x45, 
                0x055B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x55, 
                0x055E
            }, 
            Package (0x03)
            {
                0x8F, 
                0x50, 
                0x0561
            }, 
            Package (0x03)
            {
                0x50, 
                0x56, 
                0x0564
            }, 
            Package (0x03)
            {
                0x89, 
                0x30, 
                0x0567
            }, 
            Package (0x03)
            {
                0x90, 
                0x56, 
                0x056A
            }, 
            Package (0x03)
            {
                0x4F, 
                0x51, 
                0x056D
            }, 
            Package (0x03)
            {
                0x10, 
                0x57, 
                0x0570
            }, 
            Package (0x03)
            {
                0x4C, 
                0x41, 
                0x0573
            }, 
            Package (0x03)
            {
                0x50, 
                0x57, 
                0x0576
            }, 
            Package (0x03)
            {
                0x8E, 
                0x4C, 
                0x0579
            }, 
            Package (0x03)
            {
                0xD0, 
                0x57, 
                0x057C
            }, 
            Package (0x03)
            {
                0xD0, 
                0x57, 
                0x057F
            }, 
            Package (0x03)
            {
                0x10, 
                0x58, 
                0x0582
            }, 
            Package (0x03)
            {
                0x06, 
                0x21, 
                0x0585
            }, 
            Package (0x03)
            {
                0x90, 
                0x58, 
                0x0588
            }, 
            Package (0x03)
            {
                0x0F, 
                0x53, 
                0x058B
            }, 
            Package (0x03)
            {
                0xD0, 
                0x58, 
                0x058E
            }, 
            Package (0x03)
            {
                0x4D, 
                0x48, 
                0x0591
            }, 
            Package (0x03)
            {
                0x50, 
                0x59, 
                0x0594
            }, 
            Package (0x03)
            {
                0x07, 
                0x27, 
                0x0597
            }, 
            Package (0x03)
            {
                0x90, 
                0x59, 
                0x059A
            }, 
            Package (0x03)
            {
                0x0A, 
                0x38, 
                0x059D
            }, 
            Package (0x03)
            {
                0x10, 
                0x5A, 
                0x05A0
            }, 
            Package (0x03)
            {
                0x4A, 
                0x38, 
                0x05A3
            }, 
            Package (0x03)
            {
                0x50, 
                0x5A, 
                0x05A6
            }, 
            Package (0x03)
            {
                0x87, 
                0x27, 
                0x05A9
            }, 
            Package (0x03)
            {
                0xD0, 
                0x5A, 
                0x05AC
            }, 
            Package (0x03)
            {
                0xCD, 
                0x49, 
                0x05AF
            }, 
            Package (0x03)
            {
                0x10, 
                0x5B, 
                0x05B2
            }, 
            Package (0x03)
            {
                0x8F, 
                0x55, 
                0x05B5
            }, 
            Package (0x03)
            {
                0x90, 
                0x5B, 
                0x05B8
            }, 
            Package (0x03)
            {
                0x46, 
                0x22, 
                0x05BB
            }, 
            Package (0x03)
            {
                0xD0, 
                0x5B, 
                0x05BE
            }, 
            Package (0x03)
            {
                0x10, 
                0x5C, 
                0x05C1
            }, 
            Package (0x03)
            {
                0x50, 
                0x5C, 
                0x05C4
            }, 
            Package (0x03)
            {
                0xCE, 
                0x50, 
                0x05C7
            }, 
            Package (0x03)
            {
                0x90, 
                0x5C, 
                0x05CA
            }, 
            Package (0x03)
            {
                0x8C, 
                0x45, 
                0x05CD
            }, 
            Package (0x03)
            {
                0x10, 
                0x5D, 
                0x05D0
            }, 
            Package (0x03)
            {
                0x4F, 
                0x57, 
                0x05D3
            }, 
            Package (0x03)
            {
                0x50, 
                0x5D, 
                0x05D6
            }, 
            Package (0x03)
            {
                0x89, 
                0x34, 
                0x05D9
            }, 
            Package (0x03)
            {
                0xD0, 
                0x5D, 
                0x05DC
            }
        })
        Method (SPIC, 1, NotSerialized)
        {
            If (LLessEqual (Arg0, PICL))
            {
                WBYT (DerefOf (Index (ADP3, Zero)), DerefOf (Index (ADP3, 0x08
                    )), DerefOf (Index (DerefOf (Index (CUVR, Arg0)), GVOT (0x02, Arg0)
                    )))
                WBYT (DerefOf (Index (ADP3, Zero)), DerefOf (Index (ADP3, 0x09
                    )), DerefOf (Index (DerefOf (Index (LDLE, Arg0)), GVOT (0x04, Arg0)
                    )))
                If (LEqual (Arg0, 0x03))
                {
                    Store (Zero, PWTH)
                }
                Else
                {
                    Store (One, PWTH)
                }
                If (LEqual (AIGC, Zero))
                {
                    SFSB (Arg0)
                }
            }
            Else
            {
                If (LEqual (AIGC, Zero))
                {
                    SFSB (Arg0)
                }
                If (LEqual (Arg0, 0x03))
                {
                    Store (Zero, PWTH)
                }
                Else
                {
                    Store (One, PWTH)
                }
                WBYT (DerefOf (Index (ADP3, Zero)), DerefOf (Index (ADP3, 0x09
                    )), DerefOf (Index (DerefOf (Index (LDLE, Arg0)), GVOT (0x04, Arg0)
                    )))
                WBYT (DerefOf (Index (ADP3, Zero)), DerefOf (Index (ADP3, 0x08
                    )), DerefOf (Index (DerefOf (Index (CUVR, Arg0)), GVOT (0x02, Arg0)
                    )))
            }
            RCAS ()
        }
        Method (SFSB, 1, NotSerialized)
        {
            If (LEqual (GNVS (0x343D), Zero))
            {
                Store (Zero, Local5)
            }
            Else
            {
                Store (One, Local5)
            }
            ^^SIOR.SATO (DerefOf (Index (DerefOf (Index (PSLV, Local5)), Zero)))
            ^^SIOR.SATH (DerefOf (Index (DerefOf (Index (PSLV, Local5)), One)))
        }
        Method (ITAT, 0, NotSerialized)
        {
            If (LEqual (GNVS (0x343D), Zero))
            {
                Store (Zero, Local0)
            }
            Else
            {
                Store (One, Local0)
            }
            ^^SIOR.SATO (DerefOf (Index (DerefOf (Index (PSLV, Local0)), Zero)))
            ^^SIOR.SATH (DerefOf (Index (DerefOf (Index (PSLV, Local0)), One)))
            Sleep (0x03E8)
        }
        Method (STHR, 1, NotSerialized)
        {
            WBYT (DerefOf (Index (ADP3, Zero)), DerefOf (Index (ADP3, 0x05
                )), DerefOf (Index (DerefOf (Index (PSLB, Arg0)), Zero)))
            WBYT (DerefOf (Index (ADP3, Zero)), DerefOf (Index (ADP3, 0x06
                )), DerefOf (Index (DerefOf (Index (PSLB, Arg0)), One)))
            WBYT (DerefOf (Index (ADP3, Zero)), DerefOf (Index (ADP3, 0x07
                )), DerefOf (Index (DerefOf (Index (PSLB, Arg0)), 0x02)))
        }
        Method (RCAS, 0, NotSerialized)
        {
            SBYT (DerefOf (Index (ADP3, Zero)), DerefOf (Index (ADP3, 0x0A
                )))
        }
    }
    Scope (_SB.PCI0.SBRG.ASOC)
    {
        Name (GF01, Package (0x09)
        {
            0x0F080000, 
            "CPU Level Up", 
            Zero, 
            Zero, 
            0x04, 
            "Original", 
            "i7-860-2.8G", 
            "i7-870-2.93G", 
            "Crazy-3.2G"
        })
        Name (GF02, Package (0x09)
        {
            0x0F080000, 
            "CPU Level Up", 
            Zero, 
            Zero, 
            0x04, 
            "Original", 
            "i7-870-2.93G", 
            "Crazy-3.06G", 
            "Crazy-3.36G"
        })
        Name (GF03, Package (0x09)
        {
            0x0F080000, 
            "CPU Level Up", 
            Zero, 
            Zero, 
            0x04, 
            "Original", 
            "Crazy-3.08G", 
            "Crazy-3.2G", 
            "Crazy-3.52G"
        })
        Name (GF04, Package (0x09)
        {
            0x0F080000, 
            "CPU Level Up", 
            Zero, 
            Zero, 
            0x04, 
            "Original", 
            "i3-530-2.93G", 
            "i3-540-3.06G", 
            "i5-650-3.2G"
        })
        Name (GF05, Package (0x09)
        {
            0x0F080000, 
            "CPU Level Up", 
            Zero, 
            Zero, 
            0x04, 
            "Original", 
            "i3-540-3.06G", 
            "i5-650-3.2G", 
            "i5-661-3.33G"
        })
        Name (GF06, Package (0x09)
        {
            0x0F080000, 
            "CPU Level Up", 
            Zero, 
            Zero, 
            0x04, 
            "Original", 
            "i5-650-3.2G", 
            "i5-661-3.33G", 
            "i5-670-3.46G"
        })
        Name (GF07, Package (0x09)
        {
            0x0F080000, 
            "CPU Level Up", 
            Zero, 
            Zero, 
            0x04, 
            "Original", 
            "i5-661-3.33G", 
            "i5-670-3.46G", 
            "Crazy-3.6G"
        })
        Name (GF08, Package (0x09)
        {
            0x0F080000, 
            "CPU Level Up", 
            Zero, 
            Zero, 
            0x04, 
            "Original", 
            "i5-670-3.46G", 
            "Crazy-3.59G", 
            "Crazy-3.7G"
        })
        Name (GF09, Package (0x09)
        {
            0x0F080000, 
            "CPU Level Up", 
            Zero, 
            Zero, 
            0x04, 
            "Original", 
            "Crazy-3.59G", 
            "Crazy-3.7G", 
            "Crazy-3.8G"
        })
        Name (GF10, Package (0x08)
        {
            0x0F080000, 
            "CPU Level Up", 
            Zero, 
            Zero, 
            0x03, 
            "Original", 
            "Crazy-3.8G", 
            "Crazy-4.0G"
        })
        Method (GRPF, 0, NotSerialized)
        {
            Store (GNVS (0x56E2), Local0)
            Name (T_0, Zero)
            Store (Local0, T_0)
            If (LEqual (T_0, One))
            {
                Return (Package (0x01)
                {
                    GF01
                })
            }
            Else
            {
                If (LEqual (T_0, 0x02))
                {
                    Return (Package (0x01)
                    {
                        GF02
                    })
                }
                Else
                {
                    If (LEqual (T_0, 0x03))
                    {
                        Return (Package (0x01)
                        {
                            GF03
                        })
                    }
                    Else
                    {
                        If (LEqual (T_0, 0x04))
                        {
                            Return (Package (0x01)
                            {
                                GF04
                            })
                        }
                        Else
                        {
                            If (LEqual (T_0, 0x05))
                            {
                                Return (Package (0x01)
                                {
                                    GF05
                                })
                            }
                            Else
                            {
                                If (LEqual (T_0, 0x06))
                                {
                                    Return (Package (0x01)
                                    {
                                        GF06
                                    })
                                }
                                Else
                                {
                                    If (LEqual (T_0, 0x07))
                                    {
                                        Return (Package (0x01)
                                        {
                                            GF07
                                        })
                                    }
                                    Else
                                    {
                                        If (LEqual (T_0, 0x08))
                                        {
                                            Return (Package (0x01)
                                            {
                                                GF08
                                            })
                                        }
                                        Else
                                        {
                                            If (LEqual (T_0, 0x09))
                                            {
                                                Return (Package (0x01)
                                                {
                                                    GF09
                                                })
                                            }
                                            Else
                                            {
                                                If (LEqual (T_0, 0x0A))
                                                {
                                                    Return (Package (0x01)
                                                    {
                                                        GF10
                                                    })
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            Return (Package (Zero) {})
        }
        Method (GITF, 1, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, Zero))
            {
                Store (GNVS (0x3465), ASB1)
            }
            Else
            {
                Store (Zero, ASB0)
            }
        }
        Method (SITF, 3, NotSerialized)
        {
            Name (T_0, Zero)
            Store (And (Arg0, 0xFFFF), T_0)
            If (LEqual (T_0, Zero))
            {
                Store (Zero, ASB0)
                If (LEqual (Arg2, Zero))
                {
                    Or (ASB0, 0x03, ASB0)
                }
                If (And (Arg2, One))
                {
                    Store (Arg1, PAR0)
                    ISMI (0xAC)
                    Store (And (PAR0, 0xFFFF), Local0)
                    If (LEqual (Local0, One))
                    {
                        Or (ASB0, 0x03, ASB0)
                    }
                }
            }
        }
    }
    OperationRegion (_SB.PCI0.SBRG.PIX0, PCI_Config, 0x60, 0x0C)
    Field (\_SB.PCI0.SBRG.PIX0, ByteAcc, NoLock, Preserve)
    {
        PIRA,   8, 
        PIRB,   8, 
        PIRC,   8, 
        PIRD,   8, 
                Offset (0x08), 
        PIRE,   8, 
        PIRF,   8, 
        PIRG,   8, 
        PIRH,   8
    }
    Scope (_SB)
    {
        Name (BUFA, ResourceTemplate ()
        {
            IRQ (Level, ActiveLow, Shared, )
                {15}
        })
        CreateWordField (BUFA, One, IRA0)
        Device (LNKA)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, One)
            Method (_STA, 0, NotSerialized)
            {
                And (PIRA, 0x80, Local0)
                If (Local0)
                {
                    Return (0x09)
                }
                Else
                {
                    Return (0x0B)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSA)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PIRA, 0x80, PIRA)
            }
            Method (_CRS, 0, NotSerialized)
            {
                And (PIRA, 0x0F, Local0)
                ShiftLeft (One, Local0, IRA0)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRA)
            }
        }
        Device (LNKB)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x02)
            Method (_STA, 0, NotSerialized)
            {
                And (PIRB, 0x80, Local0)
                If (Local0)
                {
                    Return (0x09)
                }
                Else
                {
                    Return (0x0B)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSB)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PIRB, 0x80, PIRB)
            }
            Method (_CRS, 0, NotSerialized)
            {
                And (PIRB, 0x0F, Local0)
                ShiftLeft (One, Local0, IRA0)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRB)
            }
        }
        Device (LNKC)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x03)
            Method (_STA, 0, NotSerialized)
            {
                And (PIRC, 0x80, Local0)
                If (Local0)
                {
                    Return (0x09)
                }
                Else
                {
                    Return (0x0B)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSC)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PIRC, 0x80, PIRC)
            }
            Method (_CRS, 0, NotSerialized)
            {
                And (PIRC, 0x0F, Local0)
                ShiftLeft (One, Local0, IRA0)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRC)
            }
        }
        Device (LNKD)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x04)
            Method (_STA, 0, NotSerialized)
            {
                And (PIRD, 0x80, Local0)
                If (Local0)
                {
                    Return (0x09)
                }
                Else
                {
                    Return (0x0B)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSD)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PIRD, 0x80, PIRD)
            }
            Method (_CRS, 0, NotSerialized)
            {
                And (PIRD, 0x0F, Local0)
                ShiftLeft (One, Local0, IRA0)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRD)
            }
        }
        Device (LNKE)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x05)
            Method (_STA, 0, NotSerialized)
            {
                And (PIRE, 0x80, Local0)
                If (Local0)
                {
                    Return (0x09)
                }
                Else
                {
                    Return (0x0B)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSE)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PIRE, 0x80, PIRE)
            }
            Method (_CRS, 0, NotSerialized)
            {
                And (PIRE, 0x0F, Local0)
                ShiftLeft (One, Local0, IRA0)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRE)
            }
        }
        Device (LNKF)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x06)
            Method (_STA, 0, NotSerialized)
            {
                And (PIRF, 0x80, Local0)
                If (Local0)
                {
                    Return (0x09)
                }
                Else
                {
                    Return (0x0B)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSF)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PIRF, 0x80, PIRF)
            }
            Method (_CRS, 0, NotSerialized)
            {
                And (PIRF, 0x0F, Local0)
                ShiftLeft (One, Local0, IRA0)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRF)
            }
        }
        Device (LNKG)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x07)
            Method (_STA, 0, NotSerialized)
            {
                And (PIRG, 0x80, Local0)
                If (Local0)
                {
                    Return (0x09)
                }
                Else
                {
                    Return (0x0B)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSG)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PIRG, 0x80, PIRG)
            }
            Method (_CRS, 0, NotSerialized)
            {
                And (PIRG, 0x0F, Local0)
                ShiftLeft (One, Local0, IRA0)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRG)
            }
        }
        Device (LNKH)
        {
            Name (_HID, EisaId ("PNP0C0F"))
            Name (_UID, 0x08)
            Method (_STA, 0, NotSerialized)
            {
                And (PIRH, 0x80, Local0)
                If (Local0)
                {
                    Return (0x09)
                }
                Else
                {
                    Return (0x0B)
                }
            }
            Method (_PRS, 0, NotSerialized)
            {
                Return (PRSH)
            }
            Method (_DIS, 0, NotSerialized)
            {
                Or (PIRH, 0x80, PIRH)
            }
            Method (_CRS, 0, NotSerialized)
            {
                And (PIRH, 0x0F, Local0)
                ShiftLeft (One, Local0, IRA0)
                Return (BUFA)
            }
            Method (_SRS, 1, NotSerialized)
            {
                CreateWordField (Arg0, One, IRA)
                FindSetRightBit (IRA, Local0)
                Decrement (Local0)
                Store (Local0, PIRH)
            }
        }
    }
    Scope (_SB)
    {
        Name (XCPD, Zero)
        Name (XNPT, One)
        Name (XCAP, 0x02)
        Name (XDCP, 0x04)
        Name (XDCT, 0x08)
        Name (XDST, 0x0A)
        Name (XLCP, 0x0C)
        Name (XLCT, 0x10)
        Name (XLST, 0x12)
        Name (XSCP, 0x14)
        Name (XSCT, 0x18)
        Name (XSST, 0x1A)
        Name (XRCT, 0x1C)
        Mutex (MUTE, 0x00)
        Method (RBPE, 1, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            Add (Arg0, PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, One)
            Field (PCFG, ByteAcc, NoLock, Preserve)
            {
                XCFG,   8
            }
            Release (MUTE)
            Return (XCFG)
        }
        Method (RWPE, 1, NotSerialized)
        {
           Acquire (MUTE, 0xFFFF)
            And (Arg0, 0xFFFFFFFE, Arg0)
            Add (Arg0, PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x02)
            Field (PCFG, WordAcc, NoLock, Preserve)
            {
                XCFG,   16
            }
            Release (MUTE)
            Return (XCFG)
        }
        Method (RDPE, 1, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            And (Arg0, 0xFFFFFFFC, Arg0)
            Add (Arg0, PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x04)
            Field (PCFG, DWordAcc, NoLock, Preserve)
            {
                XCFG,   32
            }
            Release (MUTE)
            Return (XCFG)
        }
        Method (WBPE, 2, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            Add (Arg0, PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, One)
            Field (PCFG, ByteAcc, NoLock, Preserve)
            {
                XCFG,   8
            }
            Store (Arg1, XCFG)
            Release (MUTE)
        }
        Method (WWPE, 2, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            And (Arg0, 0xFFFFFFFE, Arg0)
            Add (Arg0, PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x02)
            Field (PCFG, WordAcc, NoLock, Preserve)
            {
                XCFG,   16
            }
            Store (Arg1, XCFG)
            Release (MUTE)
        }
        Method (WDPE, 2, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            And (Arg0, 0xFFFFFFFC, Arg0)
            Add (Arg0, PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x04)
            Field (PCFG, DWordAcc, NoLock, Preserve)
            {
                XCFG,   32
            }
            Store (Arg1, XCFG)
            Release (MUTE)
        }
        Method (RWDP, 3, NotSerialized)
        {
            Acquire (MUTE, 0xFFFF)
            And (Arg0, 0xFFFFFFFC, Arg0)
            Add (Arg0, PCIB, Local0)
            OperationRegion (PCFG, SystemMemory, Local0, 0x04)
            Field (PCFG, DWordAcc, NoLock, Preserve)
            {
                XCFG,   32
            }
            And (XCFG, Arg2, Local1)
            Or (Local1, Arg1, XCFG)
            Release (MUTE)
        }
        Method (RPME, 1, NotSerialized)
        {
            Add (Arg0, 0x84, Local0)
            Store (RDPE (Local0), Local1)
            If (LEqual (Local1, Ones))
            {
                Return (Zero)
            }
            Else
            {
                If (LAnd (Local1, 0x00010000))
                {
                    WDPE (Local0, And (Local1, 0x00010000))
                    Return (One)
                }
                Return (Zero)
            }
        }
    }
    Scope (_SB.PCI0)
    {
        Method (_OSC, 4, NotSerialized)
        {
            Name (SUPP, Zero)
            Name (CTRL, Zero)
            CreateDWordField (Arg3, Zero, CDW1)
            CreateDWordField (Arg3, 0x04, CDW2)
            CreateDWordField (Arg3, 0x08, CDW3)
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0x5B, 0x4D, 0xDB, 0x33, 0xF7, 0x1F, 0x1C, 0x40, 
                        /* 0008 */    0x96, 0x57, 0x74, 0x41, 0xC0, 0x3D, 0xD7, 0x66
                    }))
            {
                Store (CDW2, SUPP)
                Store (CDW3, CTRL)
                If (LNotEqual (And (SUPP, 0x16), 0x16))
                {
                    And (CTRL, 0x1E, CTRL)
                }
                If (LNot (PEHP))
                {
                    And (CTRL, 0x1E, CTRL)
                }
                If (LNot (SHPC))
                {
                    And (CTRL, 0x1D, CTRL)
                }
                If (LNot (PEPM))
                {
                    And (CTRL, 0x1B, CTRL)
                }
                If (LNot (PEER))
                {
                    And (CTRL, 0x15, CTRL)
                }
                If (LNot (PECS))
                {
                    And (CTRL, 0x0F, CTRL)
                }
                If (Not (And (CDW1, One)))
                {
                    If (And (CTRL, One)) {}
                    If (And (CTRL, 0x04)) {}
                    If (And (CTRL, 0x10)) {}
                }
                If (LNotEqual (Arg1, One))
                {
                    Or (CDW1, 0x08, CDW1)
                }
                If (LNotEqual (CDW3, CTRL))
                {
                    Or (CDW1, 0x10, CDW1)
                }
                And (CTRL, 0xEF, CTRL)
                Store (CTRL, CDW3)
                Return (Arg3)
            }
            Else
            {
                Or (CDW1, 0x04, CDW1)
                Return (Arg3)
            }
        }
    }
    OperationRegion (SMRG, SystemIO, 0x0400, 0x10)
    Field (SMRG, ByteAcc, NoLock, Preserve)
    {
        HSTS,   8, 
        SSTS,   8, 
        HSTC,   8, 
        HCMD,   8, 
        HADR,   8, 
        HDT0,   8, 
        HDT1,   8, 
        BLKD,   8, 
        SLCT,   8, 
        SHCM,   8, 
        SLEV,   24, 
        AUXC,   8
    }
    Field (SMRG, ByteAcc, NoLock, Preserve)
    {
                Offset (0x05), 
        HDTW,   16
    }
    Method (SCMD, 4, Serialized)
    {
        Store (0x05, Local0)
        While (Decrement (Local0))
        {
            Store (0xFFFF, Local1)
            While (LAnd (HSTS, Decrement (Local1)))
            {
                Store (0xFE, HSTS)
                Stall (0x0A)
            }
            Store (HSTC, Local2)
            Store (Arg0, HADR)
            Store (Arg1, HCMD)
            Store (Arg2, HDTW)
            Store (Arg3, HSTC)
            Store (0xFFFF, Local1)
            While (Decrement (Local1))
            {
                If (And (HSTS, 0x0C))
                {
                    Store (One, Local1)
                }
                If (LEqual (And (HSTS, 0x03), 0x02))
                {
                    Return (HDTW)
                }
                Stall (0x0A)
            }
            Store (0x42, HSTC)
            Store (0xFFFF, Local1)
            While (Decrement (Local1))
            {
                If (And (HSTS, 0x10))
                {
                    Store (One, Local1)
                }
                Stall (0x0A)
            }
            Store (Zero, HSTC)
        }
        Return (Ones)
    }
    Method (SBYT, 2, NotSerialized)
    {
        SCMD (Arg0, Arg1, Zero, 0x44)
    }
    Method (WBYT, 3, NotSerialized)
    {
        SCMD (Arg0, Arg1, Arg2, 0x48)
    }
    Method (WWRD, 3, NotSerialized)
    {
        SCMD (Arg0, Arg1, Arg2, 0x4C)
    }
    Method (RSBT, 2, NotSerialized)
    {
        Or (Arg0, One, Arg0)
        Return (And (SCMD (Arg0, Arg1, Zero, 0x44), 0xFF))
    }
    Method (RBYT, 2, NotSerialized)
    {
        Or (Arg0, One, Arg0)
        Return (And (SCMD (Arg0, Arg1, Zero, 0x48), 0xFF))
    }
    Method (RWRD, 2, NotSerialized)
    {
        Or (Arg0, One, Arg0)
        Return (SCMD (Arg0, Arg1, Zero, 0x4C))
    }
    Method (RBLK, 3, NotSerialized)
    {
        Or (AUXC, 0x02, AUXC)
        Or (Arg0, One, Local0)
        SCMD (Local0, Arg1, Arg2, 0x54)
        Store (HSTC, Local0)
        Store (HDT0, Local0)
        Add (Local0, One, Local7)
        Name (RBUF, Buffer (Local7) {})
        Store (Zero, Local1)
        While (Local0)
        {
            Store (BLKD, Index (RBUF, Local1))
            Decrement (Local0)
            Increment (Local1)
        }
        Return (RBUF)
    }
    Method (WBLK, 4, NotSerialized)
    {
        Or (AUXC, 0x02, AUXC)
        Store (HSTC, Local0)
        Store (Zero, Local0)
        While (LLessEqual (Local0, Arg2))
        {
            Store (DerefOf (Index (Arg3, Local0)), BLKD)
            Increment (Local0)
        }
        And (Arg0, 0xFE, Local0)
        SCMD (Local0, Arg1, Arg2, 0x54)
    }
    Scope (_SB.PCI0.SBRG.SIOR)
    {
        Name (SNCT, Zero)
        Name (E1BK, Zero)
        Method (HWV0, 0, NotSerialized)
        {
            Return (Multiply (VCOR, 0x08))
        }
        Method (HWV1, 0, NotSerialized)
        {
            Return (Multiply (V12V, 0x08))
        }
        Method (HWV3, 0, NotSerialized)
        {
            Return (Multiply (V33V, 0x08))
        }
        Method (HWV4, 0, NotSerialized)
        {
            Return (Multiply (V50V, 0x08))
        }
        Method (HWT0, 0, NotSerialized)
        {
            ENFG (0x0C)
            Store (CR20, Local0)
            EXFG ()
            If (LEqual (Local0, 0xB3))
            {
                Store (Zero, BSEL)
                Store (Zero, SR7D)
                Store (SR7E, Local1)
            }
            Else
            {
                Store (MBTE, Local1)
            }
            If (And (Local1, 0x80))
            {
                Or (Local1, 0xFFFFFF00, Local1)
            }
            Multiply (Local1, 0x0A, Local1)
            Return (Local1)
        }
        Method (HWT1, 0, NotSerialized)
        {
            ENFG (0x0C)
            If (LNotEqual (CRE1, E1BK))
            {
                If (LEqual (E1BK, Zero))
                {
                    Store (CRE1, E1BK)
                }
                Else
                {
                    Store (E1BK, CRE1)
                }
            }
            EXFG ()
            If (LLess (SNCT, 0x02))
            {
                Store (One, BSEL)
                Store (TSR1, Local3)
                Store (Zero, BSEL)
                Add (MBTE, One, Local1)
                XOr (Local1, 0x80, Local1)
                XOr (Local3, 0x80, Local3)
                If (LGreater (Local1, Local3))
                {
                    ENFG (0x0C)
                    If (LAnd (CRE0, 0xF0))
                    {
                        Subtract (Local1, Local3, Local3)
                        ShiftRight (Local3, One, Local3)
                        Add (Local3, 0x03, Local3)
                        Add (CRE1, Local3, CRE1)
                        Store (CRE1, E1BK)
                        Sleep (0x32)
                    }
                    Increment (SNCT)
                    EXFG ()
                }
            }
            Store (One, BSEL)
            Store (TSR1, Local1)
            If (And (Local1, 0x80))
            {
                Or (Local1, 0xFFFFFF00, Local1)
            }
            Multiply (Local1, 0x0A, Local1)
            Store (TSR2, Local2)
            Multiply (Local2, 0x05, Local2)
            Add (Local1, Local2, Local1)
            Return (Local1)
        }
        Method (HWT2, 0, NotSerialized)
        {
            Store (0x02, BSEL)
            Store (TSR1, Local1)
            If (And (Local1, 0x80))
            {
                Or (Local1, 0xFFFFFF00, Local1)
            }
            Multiply (Local1, 0x0A, Local1)
            Store (TSR2, Local2)
            Multiply (Local2, 0x05, Local2)
            Add (Local1, Local2, Local1)
            Return (Local1)
        }
        Method (GAUT, 0, NotSerialized)
        {
            Store (0x02, BSEL)
            Store (TSR1, Local0)
            Return (TSR1)
        }
        Method (GAUI, 0, NotSerialized)
        {
            Store (GAUT (), Local0)
            Multiply (Local0, Local0, Local1)
            Multiply (Local1, Local0, Local2)
            Divide (Multiply (Local2, 0x8A), 0x00989680, Local3, Local4)
            Divide (Multiply (Local1, 0xAC), 0x2710, Local3, Local5)
            Divide (Multiply (Local0, 0x01AA), 0x64, Local3, Local6)
            Add (Local4, Local5, Local5)
            If (LGreater (Local0, 0x49))
            {
                Add (Local5, 0xEB, Local5)
            }
            Else
            {
                If (LGreater (Local0, 0x2D))
                {
                    Add (Local5, 0xE9, Local5)
                }
                Else
                {
                    Add (Local5, 0xE7, Local5)
                }
            }
            If (LGreater (Local5, Local6))
            {
                Store (Subtract (Local5, Local6), Local7)
            }
            Else
            {
                Store (Zero, Local7)
            }
            Return (Local7)
        }
        Method (GAUP, 0, NotSerialized)
        {
            Store (Multiply (HWV0 (), GAUI ()), Local0)
            Return (Local0)
        }
        Method (GATO, 0, NotSerialized)
        {
            Store (0x02, BSEL)
            Store (ATOV, Local1)
            Multiply (Local1, 0x0A, Local1)
            Store (ATOL, Local2)
            Multiply (Local2, 0x05, Local2)
            Add (Local1, Local2, Local1)
            Return (Local1)
        }
        Method (GATH, 0, NotSerialized)
        {
            Store (0x02, BSEL)
            Store (FAN4, Local1)
            Multiply (Local1, 0x0A, Local1)
            Store (ATHL, Local2)
            Multiply (Local2, 0x05, Local2)
            Add (Local1, Local2, Local1)
            Return (Local1)
        }
        Method (SATO, 1, NotSerialized)
        {
            Store (0x02, BSEL)
            Divide (Arg0, 0x0A, Local0, Local1)
            Store (And (Local1, 0xFF), ATOV)
            If (LGreater (Local0, 0x07))
            {
                Store (Add (Local1, One), ATOV)
                Store (Zero, ATOL)
            }
            Else
            {
                If (LGreater (Local0, 0x02))
                {
                    Store (One, ATOL)
                }
                Else
                {
                    Store (Zero, ATOL)
                }
            }
        }
        Method (SATH, 1, NotSerialized)
        {
            Store (0x02, BSEL)
            Divide (Arg0, 0x0A, Local0, Local1)
            Store (And (Local1, 0xFF), FAN4)
            If (LGreater (Local0, 0x07))
            {
                Store (Add (Local1, One), FAN4)
                Store (Zero, ATHL)
            }
            Else
            {
                If (LGreater (Local0, 0x02))
                {
                    Store (One, ATHL)
                }
                Else
                {
                    Store (Zero, ATHL)
                }
            }
        }
        Method (GATS, 0, NotSerialized)
        {
            Store (0x04, BSEL)
            Return (AUTS)
        }
        Method (CATS, 0, NotSerialized)
        {
            Store (Zero, BSEL)
            Store (AUIS, Local0)
        }
        OperationRegion (DBGE, SystemIO, 0x80, 0x04)
        Field (DBGE, WordAcc, NoLock, Preserve)
        {
            DBGG,   22
        }
        Method (HWF0, 0, NotSerialized)
        {
            Store (FAN1, Local0)
            Store (Zero, BSEL)
            And (FD21, 0x20, Local1)
            ShiftRight (Local1, 0x05, Local1)
            Multiply (Local1, 0x04, Local1)
            And (FDR1, 0x30, Local2)
            ShiftRight (Local2, 0x04, Local2)
            Add (Local1, Local2, Local1)
            If (LOr (LGreater (Local1, 0x05), LLess (Local1, 0x02)))
            {
                If (LGreater (Local0, 0xF0))
                {
                    Store (0x02, Local1)
                }
                Else
                {
                    If (LLess (Local0, 0x1E))
                    {
                        Store (0x05, Local1)
                    }
                    Else
                    {
                        Store (0x03, Local1)
                    }
                }
                Divide (Local1, 0x04, Local2, Local3)
                ShiftLeft (Local3, 0x05, Local3)
                Store (FD21, Local4)
                And (Local4, 0xDF, Local4)
                Or (Local3, Local4, FD21)
                Store (FDR1, Local4)
                And (Local4, 0xCF, Local4)
                ShiftLeft (Local2, 0x04, Local2)
                Or (Local4, One, Local4)
                Or (Local4, Local2, FDR1)
                Sleep (0x32)
                Store (FAN1, Local0)
            }
            While (LOr (LAnd (LGreater (Local0, 0xF0), LLess (Local1, 0x05)), LAnd (
                LLess (Local0, 0x1E), LGreater (Local1, 0x02))))
            {
                If (LAnd (LGreater (Local0, 0xF0), LLess (Local1, 0x05)))
                {
                    Add (Local1, One, Local1)
                    Divide (Local1, 0x04, Local2, Local3)
                    Store (Zero, BSEL)
                    ShiftLeft (Local3, 0x05, Local3)
                    Store (FD21, Local4)
                    And (Local4, 0xDF, Local4)
                    Or (Local3, Local4, FD21)
                    Store (FDR1, Local4)
                    And (Local4, 0xCF, Local4)
                    ShiftLeft (Local2, 0x04, Local2)
                    Or (Local4, One, Local4)
                    Or (Local4, Local2, FDR1)
                    Sleep (0x32)
                    Store (FAN1, Local0)
                    Sleep (0x32)
                    Store (FAN1, Local0)
                    Sleep (0x32)
                    Store (FAN1, Local0)
                }
                Else
                {
                    Subtract (Local1, One, Local1)
                    Divide (Local1, 0x04, Local2, Local3)
                    Store (Zero, BSEL)
                    ShiftLeft (Local3, 0x05, Local3)
                    Store (FD21, Local4)
                    And (Local4, 0xDF, Local4)
                    Or (Local3, Local4, FD21)
                    Store (FDR1, Local4)
                    And (Local4, 0xCF, Local4)
                    ShiftLeft (Local2, 0x04, Local2)
                    Or (Local4, One, Local4)
                    Or (Local4, Local2, FDR1)
                    Sleep (0x32)
                    Store (FAN1, Local0)
                    Sleep (0x32)
                    Store (FAN1, Local0)
                    Sleep (0x32)
                    Store (FAN1, Local0)
                }
            }
            If (LAnd (LEqual (Local0, 0xFF), LEqual (Local1, 0x05)))
            {
                Return (Zero)
            }
            If (LAnd (LEqual (Local0, Zero), LEqual (Local1, 0x02)))
            {
                Return (0xFFFF)
            }
            Store (One, Local2)
            While (Local1)
            {
                Multiply (Local2, 0x02, Local2)
                Decrement (Local1)
            }
            Multiply (Local0, Local2, Local0)
            Divide (0x00149970, Local0, Local1, Local0)
            Return (Local0)
        }
        Method (HWF1, 0, NotSerialized)
        {
            Store (Zero, BSEL)
            Store (FAN2, Local0)
            And (FD21, 0x40, Local1)
            ShiftRight (Local1, 0x06, Local1)
            Multiply (Local1, 0x04, Local1)
            And (FDR1, 0xC0, Local2)
            ShiftRight (Local2, 0x06, Local2)
            Add (Local1, Local2, Local1)
            If (LOr (LGreater (Local1, 0x05), LLess (Local1, 0x02)))
            {
                If (LGreater (Local0, 0xF0))
                {
                    Store (0x02, Local1)
                }
                Else
                {
                    If (LLess (Local0, 0x1E))
                    {
                        Store (0x05, Local1)
                    }
                    Else
                    {
                        Store (0x03, Local1)
                    }
                }
                Divide (Local1, 0x04, Local2, Local3)
                ShiftLeft (Local3, 0x06, Local3)
                Store (FD21, Local4)
                And (Local4, 0xBF, Local4)
                Or (Local3, Local4, FD21)
                Store (FDR1, Local4)
                And (Local4, 0x3F, Local4)
                ShiftLeft (Local2, 0x06, Local2)
                Or (Local4, One, Local4)
                Or (Local4, Local2, FDR1)
                Sleep (0x32)
                Store (Zero, BSEL)
                Store (FAN2, Local0)
            }
            While (LOr (LAnd (LGreater (Local0, 0xF0), LLess (Local1, 0x05)), LAnd (
                LLess (Local0, 0x1E), LGreater (Local1, 0x02))))
            {
                If (LAnd (LLess (Local0, 0x1E), LGreater (Local1, 0x02)))
                {
                    Subtract (Local1, One, Local1)
                    Divide (Local1, 0x04, Local2, Local3)
                    Store (Zero, BSEL)
                    ShiftLeft (Local3, 0x06, Local3)
                    Store (FD21, Local4)
                    And (Local4, 0xBF, Local4)
                    Or (Local3, Local4, FD21)
                    Store (FDR1, Local4)
                    And (Local4, 0x3F, Local4)
                    ShiftLeft (Local2, 0x06, Local2)
                    Or (Local4, One, Local4)
                    Or (Local4, Local2, FDR1)
                    Sleep (0x32)
                    Store (Zero, BSEL)
                    Store (FAN2, Local0)
                    Sleep (0x32)
                    Store (FAN2, Local0)
                    Sleep (0x32)
                    Store (FAN2, Local0)
                }
                Else
                {
                    Add (Local1, One, Local1)
                    Divide (Local1, 0x04, Local2, Local3)
                    Store (Zero, BSEL)
                    ShiftLeft (Local3, 0x06, Local3)
                    Store (FD21, Local4)
                    And (Local4, 0xBF, Local4)
                    Or (Local3, Local4, FD21)
                    Store (FDR1, Local4)
                    And (Local4, 0x3F, Local4)
                    ShiftLeft (Local2, 0x06, Local2)
                    Or (Local4, One, Local4)
                    Or (Local4, Local2, FDR1)
                    Sleep (0x32)
                    Store (Zero, BSEL)
                    Store (FAN2, Local0)
                    Sleep (0x32)
                    Store (FAN2, Local0)
                    Sleep (0x32)
                    Store (FAN2, Local0)
                }
            }
            If (LAnd (LEqual (Local0, 0xFF), LEqual (Local1, 0x05)))
            {
                Return (Zero)
            }
            If (LAnd (LEqual (Local0, Zero), LEqual (Local1, 0x02)))
            {
                Return (0xFFFF)
            }
            Store (One, Local2)
            While (Local1)
            {
                Multiply (Local2, 0x02, Local2)
                Decrement (Local1)
            }
            Multiply (Local0, Local2, Local0)
            Divide (0x00149970, Local0, Local1, Local0)
            Return (Local0)
        }
        Method (HWF2, 0, NotSerialized)
        {
            Store (FAN3, Local0)
            Store (Zero, BSEL)
            And (FD21, 0x80, Local1)
            ShiftRight (Local1, 0x07, Local1)
            Multiply (Local1, 0x04, Local1)
            Divide (FD13, 0x40, Local2, Local3)
            Add (Local1, Local3, Local1)
            If (LOr (LGreater (Local1, 0x05), LLess (Local1, 0x02)))
            {
                If (LGreater (Local0, 0xF0))
                {
                    Store (0x02, Local1)
                }
                Else
                {
                    If (LLess (Local0, 0x1E))
                    {
                        Store (0x05, Local1)
                    }
                    Else
                    {
                        Store (0x03, Local1)
                    }
                }
                Divide (Local1, 0x04, Local2, Local3)
                ShiftLeft (Local3, 0x07, Local3)
                Store (FD21, Local4)
                And (Local4, 0x7F, Local4)
                Or (Local3, Local4, FD21)
                Store (FD13, Local3)
                And (Local3, 0x3F, Local3)
                Multiply (Local2, 0x40, Local2)
                Add (Local3, Local2, Local2)
                Store (Local2, FD13)
                Sleep (0x32)
                Store (FAN3, Local0)
            }
            While (LOr (LAnd (LGreater (Local0, 0xF0), LLess (Local1, 0x05)), LAnd (
                LLess (Local0, 0x1E), LGreater (Local1, 0x02))))
            {
                If (LAnd (LGreater (Local0, 0xF0), LLess (Local1, 0x05)))
                {
                    If (LEqual (Local0, 0xFF))
                    {
                        Store (0x05, Local1)
                    }
                    Else
                    {
                        Add (Local1, One, Local1)
                    }
                    Divide (Local1, 0x04, Local2, Local3)
                    Store (Zero, BSEL)
                    ShiftLeft (Local3, 0x07, Local3)
                    Store (FD21, Local4)
                    And (Local4, 0x7F, Local4)
                    Or (Local3, Local4, FD21)
                    Store (FD13, Local3)
                    And (Local3, 0x3F, Local3)
                    Multiply (Local2, 0x40, Local2)
                    Add (Local3, Local2, Local2)
                    Store (Local2, FD13)
                    If (LNotEqual (Local0, 0xFF))
                    {
                        Sleep (0x32)
                    }
                    Store (FAN3, Local0)
                    Sleep (0x32)
                    Store (FAN3, Local0)
                    Sleep (0x32)
                    Store (FAN3, Local0)
                }
                Else
                {
                    Subtract (Local1, One, Local1)
                    Divide (Local1, 0x04, Local2, Local3)
                    Store (Zero, BSEL)
                    ShiftLeft (Local3, 0x07, Local3)
                    Store (FD21, Local4)
                    And (Local4, 0x7F, Local4)
                    Or (Local3, Local4, FD21)
                    Store (FD13, Local3)
                    And (Local3, 0x3F, Local3)
                    Multiply (Local2, 0x40, Local2)
                    Add (Local3, Local2, Local2)
                    Store (Local2, FD13)
                    Sleep (0x32)
                    Store (FAN3, Local0)
                    Sleep (0x32)
                    Store (FAN3, Local0)
                    Sleep (0x32)
                    Store (FAN3, Local0)
                }
            }
            If (LAnd (LEqual (Local0, 0xFF), LEqual (Local1, 0x05)))
            {
                Return (Zero)
            }
            If (LAnd (LEqual (Local0, Zero), LEqual (Local1, 0x02)))
            {
                Return (0xFFFF)
            }
            Store (One, Local2)
            While (Local1)
            {
                Multiply (Local2, 0x02, Local2)
                Decrement (Local1)
            }
            Multiply (Local0, Local2, Local0)
            Divide (0x00149970, Local0, Local1, Local0)
            Return (Local0)
        }
        Method (HWF4, 0, NotSerialized)
        {
            Store (0x05, BSEL)
            Store (FAN4, Local0)
            Store (Zero, BSEL)
            And (FND4, 0x80, Local1)
            ShiftRight (Local1, 0x07, Local1)
            Multiply (Local1, 0x04, Local1)
            And (FND4, 0x0C, Local2)
            ShiftRight (Local2, 0x02, Local2)
            Add (Local1, Local2, Local1)
            If (LOr (LGreater (Local1, 0x05), LLess (Local1, 0x02)))
            {
                If (LGreater (Local0, 0xF0))
                {
                    Store (0x02, Local1)
                }
                Else
                {
                    If (LLess (Local0, 0x1E))
                    {
                        Store (0x05, Local1)
                    }
                    Else
                    {
                        Store (0x03, Local1)
                    }
                }
                Divide (Local1, 0x04, Local2, Local3)
                ShiftLeft (Local3, 0x07, Local3)
                ShiftLeft (Local2, 0x02, Local2)
                Store (FND4, Local4)
                And (Local4, 0x73, Local4)
                Or (Local3, Local2, Local3)
                Or (Local3, Local4, FND4)
                Sleep (0x32)
                Store (0x05, BSEL)
                Store (FAN4, Local0)
            }
            While (LOr (LAnd (LGreater (Local0, 0xF0), LLess (Local1, 0x05)), LAnd (
                LLess (Local0, 0x1E), LGreater (Local1, 0x02))))
            {
                If (LAnd (LGreater (Local0, 0xF0), LLess (Local1, 0x05)))
                {
                    Add (Local1, One, Local1)
                    Divide (Local1, 0x04, Local2, Local3)
                    Store (Zero, BSEL)
                    ShiftLeft (Local3, 0x07, Local3)
                    ShiftLeft (Local2, 0x02, Local2)
                    Store (FND4, Local4)
                    And (Local4, 0x73, Local4)
                    Or (Local3, Local2, Local3)
                    Or (Local3, Local4, FND4)
                    If (LNotEqual (Local0, 0xFF))
                    {
                        Sleep (0x32)
                    }
                    Store (0x05, BSEL)
                    Store (FAN4, Local0)
                    Sleep (0x32)
                    Store (FAN4, Local0)
                    Sleep (0x32)
                    Store (FAN4, Local0)
                    Store (Zero, BSEL)
                }
                Else
                {
                    Subtract (Local1, One, Local1)
                    Divide (Local1, 0x04, Local2, Local3)
                    Store (Zero, BSEL)
                    ShiftLeft (Local3, 0x07, Local3)
                    ShiftLeft (Local2, 0x02, Local2)
                    Store (FND4, Local4)
                    And (Local4, 0x73, Local4)
                    Or (Local3, Local2, Local3)
                    Or (Local3, Local4, FND4)
                    Sleep (0x32)
                    Store (0x05, BSEL)
                    Store (FAN4, Local0)
                    Sleep (0x32)
                    Store (FAN4, Local0)
                    Sleep (0x32)
                    Store (FAN4, Local0)
                    Store (Zero, BSEL)
                }
            }
            If (LAnd (LEqual (Local0, 0xFF), LEqual (Local1, 0x05)))
            {
                Return (Zero)
            }
            If (LAnd (LEqual (Local0, Zero), LEqual (Local1, 0x02)))
            {
                Return (0xFFFF)
            }
            Store (One, Local2)
            While (Local1)
            {
                Multiply (Local2, 0x02, Local2)
                Decrement (Local1)
            }
            Multiply (Local0, Local2, Local0)
            Divide (0x00149970, Local0, Local1, Local0)
            Return (Local0)
        }
        Name (FNDT, Package (0x08)
        {
            One, 
            0x02, 
            0x04, 
            0x08, 
            0x10, 
            0x20, 
            0x40, 
            0x80
        })
        Method (HWF3, 0, NotSerialized)
        {
            Store (Zero, BSEL)
            Store (CFN3, Local0)
            And (FD15, 0x80, Local1)
            ShiftRight (Local1, 0x05, Local1)
            And (FND4, 0x03, Local2)
            Or (Local1, Local2, Local1)
            If (LOr (LGreater (Local1, 0x05), LLess (Local1, 0x02)))
            {
                If (LGreater (Local0, 0xF0))
                {
                    Store (0x02, Local1)
                }
                Else
                {
                    If (LLess (Local0, 0x1E))
                    {
                        Store (0x05, Local1)
                    }
                    Else
                    {
                        Store (0x03, Local1)
                    }
                }
                ShiftLeft (Local1, 0x05, Local2)
                And (Local2, 0x80, Local2)
                And (FD15, 0x7F, Local3)
                Or (Local2, Local3, Local3)
                Store (Local3, FD15)
                And (Local1, 0x03, Local2)
                And (FND4, 0xFC, Local3)
                Or (Local2, Local3, Local3)
                Store (Local3, FND4)
                Sleep (0x32)
                Store (CFN3, Local0)
            }
            While (LOr (LAnd (LGreater (Local0, 0xF0), LLess (Local1, 0x05)), LAnd (
                LLess (Local0, 0x1E), LGreater (Local1, 0x02))))
            {
                If (LAnd (LGreater (Local0, 0xF0), LLess (Local1, 0x05)))
                {
                    Increment (Local1)
                }
                Else
                {
                    Decrement (Local1)
                }
                ShiftLeft (Local1, 0x05, Local2)
                And (Local2, 0x80, Local2)
                And (FD15, 0x7F, Local3)
                Or (Local2, Local3, Local3)
                Store (Local3, FD15)
                And (Local1, 0x03, Local2)
                And (FND4, 0xFC, Local3)
                Or (Local2, Local3, Local3)
                Store (Local3, FND4)
                Sleep (0x32)
                Store (CFN3, Local0)
                Sleep (0x32)
                Store (CFN3, Local0)
                Sleep (0x32)
                Store (CFN3, Local0)
            }
            If (LAnd (LEqual (Local0, 0xFF), LEqual (Local1, 0x05)))
            {
                Return (Zero)
            }
            If (LAnd (LEqual (Local0, Zero), LEqual (Local1, 0x02)))
            {
                Return (0xFFFF)
            }
            Store (DerefOf (Index (FNDT, Local1)), Local2)
            Multiply (Local0, Local2, Local0)
            Divide (0x00149970, Local0, Local1, Local0)
            Return (Local0)
        }
        OperationRegion (HWRE, SystemIO, IOHW, 0x0A)
        Field (HWRE, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x05), 
            HIDX,   8, 
            HDAT,   8
        }
        IndexField (HIDX, HDAT, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x04), 
            CHNM,   1, 
            CFNM,   1, 
            CHNS,   2, 
            CFNS,   2, 
                    Offset (0x05), 
            SYST,   8, 
            TRGT,   8, 
                    Offset (0x08), 
            SSDN,   8, 
            CSDN,   8, 
            SSUP,   8, 
            CSUP,   8, 
                    Offset (0x20), 
            VCOR,   8, 
            V12V,   8, 
                    Offset (0x23), 
            V33V,   8, 
            V50V,   8, 
                    Offset (0x27), 
            MBTE,   8, 
            FAN1,   8, 
            FAN2,   8, 
            FAN3,   8, 
                    Offset (0x3F), 
            CFN3,   8, 
                    Offset (0x41), 
                ,   5, 
            AUIS,   1, 
                    Offset (0x42), 
                    Offset (0x47), 
            FDR1,   8, 
                    Offset (0x4B), 
            FD13,   8, 
            FD15,   8, 
                    Offset (0x4E), 
            BSEL,   4, 
                    Offset (0x4F), 
                    Offset (0x50), 
            TSR1,   8, 
                ,   7, 
            TSR2,   1, 
                    Offset (0x53), 
            FAN4,   8, 
                ,   7, 
            ATHL,   1, 
            ATOV,   8, 
                ,   7, 
            ATOL,   1, 
                    Offset (0x59), 
            FND4,   8, 
                ,   5, 
            AUTS,   1, 
                    Offset (0x5B), 
                    Offset (0x5D), 
            FD21,   8, 
                    Offset (0x7D), 
            SR7D,   8, 
            SR7E,   8
        }
    }
    Scope (_SB.PCI0.SBRG.ASOC)
    {
        Name (CORV, Package (0x05)
        {
            0x06020000, 
            "Vcore Voltage", 
            0x0320, 
            0x0640, 
            One
        })
        Name (V3VV, Package (0x05)
        {
            0x06020001, 
            " +3.3 Voltage", 
            0x0B9A, 
            0x0E2E, 
            One
        })
        Name (V5VV, Package (0x05)
        {
            0x06020002, 
            " +5 Voltage", 
            0x1194, 
            0x157C, 
            One
        })
        Name (VV12, Package (0x05)
        {
            0x06020003, 
            " +12 Voltage", 
            0x27D8, 
            0x35E8, 
            One
        })
        Name (VPAR, Package (0x04)
        {
            Package (0x03)
            {
                Zero, 
                One, 
                Zero
            }, 
            Package (0x03)
            {
                0x22, 
                0x22, 
                Zero
            }, 
            Package (0x03)
            {
                0x14, 
                0x0A, 
                Zero
            }, 
            Package (0x03)
            {
                0x3C, 
                0x0A, 
                Zero
            }
        })
        Name (VBUF, Package (0x05)
        {
            0x04, 
            CORV, 
            V3VV, 
            V5VV, 
            VV12
        })
        Method (VGET, 1, NotSerialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Return (^^SIOR.HWV0 ())
            }
            If (LEqual (Arg0, One))
            {
                Return (^^SIOR.HWV3 ())
            }
            If (LEqual (Arg0, 0x02))
            {
                Return (^^SIOR.HWV4 ())
            }
            If (LEqual (Arg0, 0x03))
            {
                Return (^^SIOR.HWV1 ())
            }
             Return (Zero)
        }
        Name (CPUT, Package (0x05)
        {
            0x06030000, 
            "CPU Temperature", 
            0x0258, 
            0x03B6, 
            0x00010001
        })
        Name (MBTP, Package (0x05)
        {
            0x06030001, 
            "MB Temperature", 
            0x01C2, 
            0x02EE, 
            0x00010001
        })
        Name (TBUF, Package (0x03)
        {
            0x02, 
            CPUT, 
            MBTP
        })
        Method (TGET, 1, NotSerialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Return (^^SIOR.HWT1 ())
            }
            If (LEqual (Arg0, One))
            {
                Return (^^SIOR.HWT0 ())
            }
             Return (Zero)
        }
        Name (CPUF, Package (0x05)
        {
            0x06040000, 
            "CPU FAN Speed", 
            0x0258, 
            0x1C20, 
            0x00010001
        })
        Name (CHF1, Package (0x05)
        {
            0x06040001, 
            "CHASSIS1 FAN Speed", 
            0x0258, 
            0x1C20, 
            0x00010001
        })
        Name (CHF2, Package (0x05)
        {
            0x06040002, 
            "CHASSIS2 FAN Speed", 
            0x0258, 
            0x1C20, 
            0x00010001
        })
        Name (PWRF, Package (0x05)
        {
            0x06040003, 
            "POWER FAN Speed", 
            0x0258, 
            0x1C20, 
            0x00010001
        })
        Name (FBUF, Package (0x05)
        {
            0x04, 
            CPUF, 
            CHF1, 
            CHF2, 
            PWRF
        })
        Method (FGET, 1, NotSerialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Return (^^SIOR.HWF1 ())
            }
            If (LEqual (Arg0, One))
            {
                Return (^^SIOR.HWF0 ())
            }
            If (LEqual (Arg0, 0x02))
            {
                Return (^^SIOR.HWF3 ())
            }
            If (LEqual (Arg0, 0x03))
            {
                Return (^^SIOR.HWF2 ())
            }
             Return (Zero)
        }
        Method (VSIF, 0, NotSerialized)
        {
            Return (VBUF)
        }
        Method (RVLT, 1, NotSerialized)
        {
            And (Arg0, 0xFFFF, Local0)
            Store (VGET (Local0), Local1)
            Store (DerefOf (Index (DerefOf (Index (VPAR, Local0)), Zero)), 
                Local2)
            Store (DerefOf (Index (DerefOf (Index (VPAR, Local0)), One)), 
                Local3)
            Store (DerefOf (Index (DerefOf (Index (VPAR, Local0)), 0x02)), 
                Local4)
            Multiply (Local1, Add (Local2, Local3), Local5)
            Divide (Local5, Local3, , Local5)
            Add (Local5, Local4, Local5)
            Return (Local5)
        }
        Method (SVLT, 1, NotSerialized)
        {
            And (DerefOf (Index (Arg0, Zero)), 0xFFFF, Local0)
            Store (DerefOf (Index (VBUF, Zero)), Local1)
            If (LGreaterEqual (Local0, Local1))
            {
                Return (Zero)
            }
            Increment (Local0)
            Store (DerefOf (Index (Arg0, One)), Index (DerefOf (Index (VBUF, 
                Local0)), One))
            Store (DerefOf (Index (Arg0, 0x02)), Index (DerefOf (Index (VBUF, 
                Local0)), 0x02))
            Store (DerefOf (Index (Arg0, 0x03)), Index (DerefOf (Index (VBUF, 
                Local0)), 0x03))
            Store (DerefOf (Index (Arg0, 0x04)), Index (DerefOf (Index (VBUF, 
                Local0)), 0x04))
            Return (One)
        }
        Method (TSIF, 0, NotSerialized)
        {
            Return (TBUF)
        }
        Method (RTMP, 1, NotSerialized)
        {
            And (Arg0, 0xFFFF, Local0)
            Store (TGET (Local0), Local1)
            Return (Local1)
        }
        Method (STMP, 1, NotSerialized)
        {
            Store (And (DerefOf (Index (Arg0, Zero)), 0xFFFF), Local0)
            Store (DerefOf (Index (TBUF, Zero)), Local1)
            If (LGreaterEqual (Local0, Local1))
            {
                Return (Zero)
            }
            Increment (Local0)
            Store (DerefOf (Index (Arg0, One)), Index (DerefOf (Index (TBUF, 
                Local0)), One))
            Store (DerefOf (Index (Arg0, 0x02)), Index (DerefOf (Index (TBUF, 
                Local0)), 0x02))
            Store (DerefOf (Index (Arg0, 0x03)), Index (DerefOf (Index (TBUF, 
                Local0)), 0x03))
            Store (DerefOf (Index (Arg0, 0x04)), Index (DerefOf (Index (TBUF, 
                Local0)), 0x04))
            Return (One)
        }
        Method (FSIF, 0, NotSerialized)
        {
            Return (FBUF)
        }
        Method (RFAN, 1, NotSerialized)
        {
            And (Arg0, 0xFFFF, Local0)
            Store (FGET (Local0), Local1)
            Return (Local1)
        }
        Method (SFAN, 1, NotSerialized)
        {
            And (DerefOf (Index (Arg0, Zero)), 0xFFFF, Local0)
            Store (DerefOf (Index (FBUF, Zero)), Local1)
            If (LGreaterEqual (Local0, Local1))
            {
                Return (Zero)
            }
            Increment (Local0)
            Store (DerefOf (Index (Arg0, One)), Index (DerefOf (Index (FBUF, 
                Local0)), One))
            Store (DerefOf (Index (Arg0, 0x02)), Index (DerefOf (Index (FBUF, 
                Local0)), 0x02))
            Store (DerefOf (Index (Arg0, 0x03)), Index (DerefOf (Index (FBUF, 
                Local0)), 0x03))
            Store (DerefOf (Index (Arg0, 0x04)), Index (DerefOf (Index (FBUF, 
                Local0)), 0x04))
            Store (DerefOf (Index (Arg0, 0x05)), Index (DerefOf (Index (FBUF, 
                Local0)), 0x05))
            Return (One)
        }
    }
    Scope (_SB)
    {
        Scope (PCI0)
        {
            Name (CRS, ResourceTemplate ()
            {
                WordBusNumber (ResourceProducer, MinFixed, MaxFixed, PosDecode,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x00FF,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0100,             // Length
                    ,, )
                IO (Decode16,
                    0x0CF8,             // Range Minimum
                    0x0CF8,             // Range Maximum
                    0x01,               // Alignment
                    0x08,               // Length
                    )
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0000,             // Range Minimum
                    0x0CF7,             // Range Maximum
                    0x0000,             // Translation Offset
                    0x0CF8,             // Length
                    ,, , TypeStatic)
                WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                    0x0000,             // Granularity
                    0x0D00,             // Range Minimum
                    0xFFFF,             // Range Maximum
                    0x0000,             // Translation Offset
                    0xF300,             // Length
                    ,, , TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000A0000,         // Range Minimum
                    0x000BFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00020000,         // Length
                    ,, , AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x000C0000,         // Range Minimum
                    0x000DFFFF,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00020000,         // Length
                    ,, _Y1D, AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x00000000,         // Range Minimum
                    0x00000000,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00000001,         // Length
                    ,, _Y1E, AddressRangeMemory, TypeStatic)
                DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                    0x00000000,         // Granularity
                    0x00000000,         // Range Minimum
                    0x00000000,         // Range Maximum
                    0x00000000,         // Translation Offset
                    0x00000001,         // Length
                    ,, _Y1F, AddressRangeMemory, TypeStatic)
            })
            CreateDWordField (CRS, \_SB.PCI0._Y1D._MIN, MIN5)
            CreateDWordField (CRS, \_SB.PCI0._Y1D._MAX, MAX5)
            CreateDWordField (CRS, \_SB.PCI0._Y1D._LEN, LEN5)
            CreateDWordField (CRS, \_SB.PCI0._Y1E._MIN, MIN6)
            CreateDWordField (CRS, \_SB.PCI0._Y1E._MAX, MAX6)
            CreateDWordField (CRS, \_SB.PCI0._Y1E._LEN, LEN6)
            CreateDWordField (CRS, \_SB.PCI0._Y1F._MIN, MIN7)
            CreateDWordField (CRS, \_SB.PCI0._Y1F._MAX, MAX7)
            CreateDWordField (CRS, \_SB.PCI0._Y1F._LEN, LEN7)
            Method (_CRS, 0, NotSerialized)
            {
                Store (MG1L, Local0)
                If (Local0)
                {
                    Store (MG1B, MIN5)
                    Store (MG1L, LEN5)
                    Add (MIN5, Decrement (Local0), MAX5)
                }
                Store (MG2B, MIN6)
                Store (MG2L, LEN6)
                Store (MG2L, Local0)
                Add (MIN6, Decrement (Local0), MAX6)
                Store (MG3B, MIN7)
                Store (MG3L, LEN7)
                Store (MG3L, Local0)
                Add (MIN7, Decrement (Local0), MAX7)
                Return (CRS)
            }
        }
    }
    Name (WOTB, Zero)
    Name (WSSB, Zero)
    Name (WAXB, Zero)
    Method (_PTS, 1, NotSerialized)
    {
        If (LEqual (Arg0, 0x05)) {}
         Else
         {
         Store (Arg0, DBG8)
        PTS (Arg0)
        \_SB.PCI0.SBRG.ASOC.PSOC (Arg0)
        Store (Zero, Index (WAKP, Zero))
        Store (Zero, Index (WAKP, One))
        If (LAnd (LEqual (Arg0, 0x04), LEqual (OSFL (), 0x02)))
        {
            Sleep (0x0BB8)
        }
        Store (ASSB, WSSB)
        Store (AOTB, WOTB)
        Store (AAXB, WAXB)
        Store (Arg0, ASSB)
        Store (OSFL (), AOTB)
        Store (OSYS (), OSTP)
        Store (Zero, AAXB)
         }
    }
    Method (_WAK, 1, NotSerialized)
    {
        ShiftLeft (Arg0, 0x04, DBG8)
        WAK (Arg0)
        If (IOWK) {}
        Else
        {
            Notify (\_SB.PWRB, 0x02)
        }
        If (ASSB)
        {
            Store (WSSB, ASSB)
            Store (WOTB, AOTB)
            Store (WAXB, AAXB)
        }
        If (DerefOf (Index (WAKP, Zero)))
        {
            Store (Zero, Index (WAKP, One))
        }
        Else
        {
            Store (Arg0, Index (WAKP, One))
        }
        \_SB.PCI0.SBRG.ASOC.WKOC (Arg0)
        Return (WAKP)
    }
    OperationRegion (IORK, SystemIO, 0xB3, One)
    Field (IORK, ByteAcc, NoLock, Preserve)
    {
        IOWK,   8
    }
    Name (_S0, Package (0x04)
    {
        Zero, 
        Zero, 
        Zero, 
        Zero
    })
    If (SS1)
    {
        Name (_S1, Package (0x04)
        {
            One, 
            Zero, 
            Zero, 
            Zero
        })
    }
    If (SS3)
    {
        Name (_S3, Package (0x04)
        {
            0x05, 
            Zero, 
            Zero, 
            Zero
        })
    }
    If (SS4)
    {
        Name (_S4, Package (0x04)
        {
            0x06, 
            Zero, 
            Zero, 
            Zero
        })
    }
    Name (_S5, Package (0x04)
    {
        0x07, 
        Zero, 
        Zero, 
        Zero
    })
    Method (PTS, 1, NotSerialized)
    {
        If (Arg0)
        {
            \_SB.PCI0.SBRG.SIOS (Arg0)
            \_SB.PCI0.NPTS (Arg0)
            \_SB.PCI0.SBRG.SPTS (Arg0)
        }
    }
    Method (WAK, 1, NotSerialized)
    {
        \_SB.PCI0.SBRG.SIOW (Arg0)
        \_SB.PCI0.NWAK (Arg0)
        \_SB.PCI0.SBRG.SWAK (Arg0)
    }
    Method (DTGP, 5, NotSerialized)
    {
        If (LEqual (Arg0, Buffer (0x10)
                {
                    /* 0000 */    0xC6, 0xB7, 0xB5, 0xA0, 0x18, 0x13, 0x1C, 0x44, 
                    /* 0008 */    0xB0, 0xC9, 0xFE, 0x69, 0x5E, 0xAF, 0x94, 0x9B
                }))
        {
            If (LEqual (Arg1, One))
            {
                If (LEqual (Arg2, Zero))
                {
                    Store (Buffer (One)
                        {
                            0x03
                        }, Arg4)
                    Return (One)
                }
                If (LEqual (Arg2, One))
                {
                    Return (One)
                }
            }
        }
        Store (Buffer (One)
            {
                0x00
            }, Arg4)
        Return (Zero)
    }
}
